2003-06-01  Jeffrey Stedfast  <fejj@ximian.com>

	* broken-date-parser.c (d): Turn off debugging.

	* providers/pop3/camel-pop3-engine.c (get_capabilities): Move the
	code that prepends the 'password' authtype to the auth list so
	that we don't add it again when regetting the capabilities.

2003-05-30  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (run_only_once): Turned off a debugging
	printf.

2003-05-27  Jeffrey Stedfast  <fejj@ximian.com>

	This should finish fixing all variations of bug #42854, which,
	funnily enough specified "copying" as the scenario for reproducing
	this bug, but somehow I found/fixed it only for expunging for some
	reason? I can't even guess as to how this happened. Oh well,
	expunging needed fixing either way.

	* providers/imap/camel-imap-folder.c (imap_transfer_online): Sort
	the uids here too (just like I had fixed for expunge a week or so
	ago).
	(imap_transfer_resyncing): Sort them here too.
	(imap_search_by_uids): Sort here too, even though I don't think it
	is necessary. Can't hurt.
	(imap_expunge_uids_offline): Might as well sort here too.

2003-05-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-object.c (camel_object_bag_destroy): Lets try this
	again. We don't actually want to free the key here, because
	camel_object_bag_remove() does that for us. This should fix bug
	#43406 properly.

2003-05-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-object.c (camel_object_bag_destroy): Create a second
	GPtrArray for the keys. We don't want to use bag->free_key() on
	the object. Fixes bug #43406.

2003-05-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (camel_folder_summary_load): Only display
	a warning if errno != EINVAL (EINVAL means there was a version
	mismatch, so we don't really need to warn here since we are
	supposed to be able to handle this situation).
	(perform_content_info_load): Turn off debugging message.
	(summary_assign_uid): Turn off uid-clash warning.
	(camel_folder_summary_decode_token): Turn off debug messages.
	(summary_header_load): Turn off version-mismatch warning.

2003-05-16  Jeremy Katz  <katzj@redhat.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Ensure cmdbuf
	is initialized to avoid compiler warning.

	* providers/local/camel-mbox-summary.c (summary_header_load): Cast
	folder_size to uint32 to fix warning.
	(camel_mbox_summary_sync_mbox): Update for new API.

	* providers/imap/camel-imap-utils.c (parse_params):
	imap_parse_nstring expects size_t, not int
	(imap_body_decode): Likewise.

	* camel-stream-filter.c (do_read): presize needs to be size_t
	instead of int.
	(do_write): Likewise.

	* camel-seekable-substream.c (stream_read): Return ssize_t instead
	of int to match prototypes.
	(stream_write): Likewise.

	* camel-mime-part.c (construct_from_parser): len needs to be
	size_t instead of int.

	* camel-mime-parser.c (folder_scan_step): datalength needs to be a
	size_t* instead of an int* to make dependent APIs safe.
	(camel_mime_parser_step): Likewise.
	(folder_scan_content): Likewise.
	* camel-mime-parser.h: Likewise.

	* camel-mime-message.c (camel_mime_message_class_init): Use glib
	macro for pointer/int conversions.
	(construct_from_parser): Update for new API.

	* camel-folder-summary.c
	(camel_folder_summary_info_new_from_parser): Update len to be
	size_t for new API.
	(summary_build_content_info): Likewise.
	* camel-http-stream.c (http_get_headers): Likewise.
	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Likewise.
	* camel-multipart-signed.c (signed_construct_from_parser): Likewise.
	* camel-multipart.c (construct_from_parser): Likewise.

	* camel-folder-search.c (match_words_index): Use glib macros for
	pointer/int conversions.
	* camel-html-parser.c (tokenise_setup): Likewise.
	(convert_entity): Likewise.
	* camel-block-file.c (block_hash_func): Likewise.
	(camel_block_file_get_block): Likewise.
	(camel_block_file_get_block): Likewise.
	(camel_block_file_detach_block): Likewise.
	* camel-session.c (session_thread_msg_new): Likewise.
	(session_thread_msg_free): Likewise.
	(session_thread_wait): Likewise.
	* camel-text-index.c (text_index_compress_nosync): Likewise.
	(text_index_compress_nosync): Likewise.
	(camel_text_index_validate): Likewise.
	* camel-vee-folder.c (vee_folder_remove_folder): Likewise.
	(unmatched_check_uid): Likewise.
	(folder_added_uid): Likewise.
	(vee_folder_build_folder): Likewise.
	(folder_changed_add_uid): Likewise.
	(folder_changed_remove_uid): Likewise.
	* providers/imap/camel-imap-search.c (imap_body_contains): Likewise.
	* providers/pop3/camel-pop3-folder.c (cmd_list): Likewise.
	(cmd_uidl): Likewise.

	* camel-data-cache.c (data_cache_init): Cast to CamelCopyFunc.
	Fixes a warning.

2003-05-15  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_decode_word): Simplistic quick-fix
	for #42710.  Add a charset argument.  If the data is 8 bit, try to
	decode into the passed in charset (i.e. the message header?), at
	worst, fall back to latin1, similarly to header_decode_text.
	Fixed all callers to pass in a charset if available, or NULL.

2003-05-14  Not Zed  <NotZed@Ximian.com>

	** See bug #42540
	
	* camel-service.c (camel_gethostbyname): pre-initialise the error
	return to invalid, so if we cancel, we definetly get a bad result.
	Also, for a valid return against result, not herr.
	(camel_gethostbyaddr): Likewise.

2003-05-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-folder.c (local_delete): Only delete
	the index if it is non-NULL. Fixes bug #42763.

2003-05-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_uid_array_to_set): Added
	a note to the comment block for this function noting that uids
	MUST be in sorted order.

	* providers/imap/camel-imap-folder.c (imap_expunge_uids_online):
	Sort the uids before splitting them into UID set chunks. The code
	that splits the uid array into sets expects the uids to be in
	sorted order. Fixes bug #42854.

	* providers/imap/camel-imap-command.c (imap_command_start):
	Re-enable camel_verbose_debug logging.

2003-05-12  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): If
	host->h_name is NULL or an empty string, default back to using the
	IP address rather than the hostname in the EHLO command.

2003-05-13  Ettore Perazzoli  <ettore@ximian.com>

	* providers/imap/camel-imap-folder.c (d): Disable debugging.

	* providers/imap/camel-imap-command.c (d): Disable debugging.

	* providers/imap/camel-imap-search.c (d): Disable debugging.

2003-05-02  Dan Winship  <danw@ximian.com>

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Don't call
	g_utf8_validate on an empty message. Fixes a warning.

2003-05-01  Jeffrey Stedfast  <fejj@ximian.com>

	Workaround for POS mailers like the one in bug #42045.

	* camel-mime-utils.c (header_decode_date): Make sure the numeric
	timezone is between -1200 and 1200, otherwise it is invalid.

	* broken-date-parser.c (get_tzone): Make sure the numeric timezone
	is between -1200 and 1200, otherwise it is invalid.

2003-04-29  Dan Winship  <danw@ximian.com>

	* Makefile.am (camel_lock_helper_SOURCES): Remove camel-lock.c
	from here because it upsets automake 1.6 for some reason
	(camel_lock_helper_LDADD): Add camel-lock.o here

2003-04-29  Jeremy Katz  <katzj@redhat.com>

	* providers/imap/camel-imap-folder.c (parse_fetch_response):
	body_len needs to be a size_t instead of int

2003-04-22  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c: Disable debugging printfs.

	* providers/imap/camel-imap-store.c (imap_connect_online): #if 0
	out some code that parsed the namespaces since the results aren't
	used and they generate debugging output.

2003-04-23  Not Zed  <NotZed@Ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): only free the
	host if it was set.  removes a run-time warning.

	* camel-session.c (get_service): oops, the service owns the url
	after we construct it.

2003-04-22  Not Zed  <NotZed@Ximian.com>

	** Should fix #41629, #41448, et al.
	
	* tests/folder/test10.c: a new torture test for object bag
	creation/unreffing.

	* camel-url.c (camel_url_copy): new function to copy a url.

	* camel-object.c (camel_object_bag_new): add arguments for key
	copy and key free functions.  Fixed all callers.
	(camel_object_bag_destroy): fix a memleak, free the bag key.
	(camel_object_bag_get, camel_object_bag_reserve)
	(camel_object_bag_abort, save_bag, save_object): Make the key a
	void type, rather than char *.
	(camel_object_bag_add): As above, and also copy the key.
	(camel_object_bag_remove_unlocked): free the key using
	bag->free_key.

	* camel-session.c (register_provider)
	(camel_session_destroy_provider, get_service): Changed to use an
	object bag instead of a hash table for the service 'cache'.
	(service_cache_remove): Removed, no longer required.

2003-04-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_parse_status): Don't set seen_eof1
	here anymore once we get a trust metric.
	(gpg_ctx_new): Init seen_eof1 to TRUE here.
	(gpg_ctx_set_ostream): Change seen_eof1 to FALSE here this way we
	only ever have to set this if we are expecting output.
	(gpg_ctx_parse_status): Don't set seen_eof1 for importing either.
	(gpg_ctx_op_step): Only FD_SET() those fd's that we have not yet
	finished reading.

2003-04-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url-scanner.c (camel_url_web_end): Urls are unlikely to
	end with punctuation or closing braces, so strip any of those off
	the end of the url. Fixes bug #41461.

	* tests/mime-filter/data/html.1.out: Removed a trailing \n at the
	end of the file, this is incorrect (since out input file does not
	contain one).

	* camel-mime-filter-tohtml.c (html_convert): Only output a <br> if
	we found an eoln in the input. Along the same lines, don't write a
	'\n' to the output buffer unless we've encountered that eoln in
	the input. Fixes bug #41407.

2003-04-17  Not Zed  <NotZed@Ximian.com>

	** for #40989

	* camel-text-index.c (text_index_delete): delete the block
	file/key file directly, not just its files.

	* providers/local/camel-local-folder.c (local_delete): implement,
	just delete the index file if it exists.
	camel-store-delete-folder will delete other data (maybe it all
	should be done here).

	* camel-block-file.c (camel_key_file_finalise): keep lock around
	decrementing key file use count.
	(camel_key_file_delete): new function to delete the key file (&
	close it off).
	(key_file_use): if we've been deleted, always fail.
	(camel_block_file_finalise): only close the file if its a valid
	fd.
	(block_file_use): if we've been deleted, always fail.
	(camel_block_file_delete): delete the block file & close.
	(struct _CamelBlockFilePrivate): fix the !ENABLE_THREADS case to
	still compile this.

	** for #41163

	* camel-multipart-signed.c (parse_content): Dont assume adding 1
	to line length will go to the next line.  e.g. for dos lines that
	end in \r\n.  Fix for #41163.
	(parse_boundary): util function to help above.

2003-04-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_verify): The gpg child process exiting
	does not necessarily mean that we've ready everything that we can
	from its pipes, so don't use gpg_ctx_op_exited() as a loop-exit
	condition. If for some reason the gpg child process does exit (due
	to an error), gpg_ctx_op_step() will eventually fail (as soon as
	it has finished reading any data in the pipes) and cause the loop
	to be terminated anyway. This fixes truncation of the gpg --verify
	stderr output that Evolution displays as the "validity report"
	(for lack of a better description).
	(gpg_ctx_op_step): Removed some debugging printf's
	(gpg_ctx_get_diagnostics): Use a bitfield to decide if we've
	already flushed the diagnostics stream, much simpler (plus we have
	plenty of bits to spare so might as well use them).
	(gpg_ctx_new): Fixed another logic bug which determined whether or
	not we should convert the gpg output from the locale charset into
	UTF-8.

2003-04-10  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c: Turn off debugging if
	CAMEL_VERBOSE_DEBUG isn't set.

2003-04-10  Not Zed  <NotZed@Ximian.com>

	* tests/mime-filter/data: filter data test cases.

	* tests/mime-filter/test-tohtml.c: New test for html filter.

	** See bug #40969

	* camel-mime-filter-tohtml.c (html_convert): Change the logic
	slightly, scan a whole line within the main loop.

2003-04-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_get_utf8_diagnostics): Removed. I
	just realised that we ALWAYS want to get gpg's stderr in UTF-8, so
	the better solution (plus less code duplication) is to just have
	the diagnostics buffer be a CamelStreamMem with a charset filter.
	(gpg_ctx_new): Setup a filter stream to convert our gpg stderr
	diagnostics into UTF-8 if needed.
	(gpg_ctx_free): Unref the diagnostcis stream.
	(gpg_ctx_parse_status): Flush the diagnostics stream if we are
	going to use the data in an exception.
	(gpg_ctx_op_step): Use camel_stream_write() to append to the
	diagnostics stream rather than appending the buffer to a
	GByteArray like we used to do.
	(gpg_ctx_op_step): Flush the diagnostics stream here too.
	(gpg_verify): Use a const char *diagnostics string here, forcing a
	slight rearrangement of calls - use the const char *dignostics
	before we gpg_ctx_free, otherwise we'll be passing free'd memory
	off to the cipher_validity.
	(gpg_ctx_get_diagnostics): Do the work here to flush the
	diagnostics stream and nul-terminate the buffer. Also return const
	now, instead of strdupping. No need for that.
	(gpg_ctx_parse_status): Convert the user hint to UTF-8.

2003-04-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_get_utf8_diagnostics): Changed my
	mind a bit on how I wanted this to work. Instead of aborting on an
	illegal sequence, do like we do with camel-mime-filter-charset and
	just skip over invalid sequences. Also, in the noop failure case,
	close the iconv_t so we don't leak it.

2003-04-09  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_body_decode): Save the
	content size in a temp variable until after we've successfully
	parsed all of the body_type_1part expr. Also fixed a type-o in the
	body_type_mpart case that caused the parser to fail.
	(imap_parse_body): On failure to parse the body, as we iterate
	through the child nodes, set their children/parent/next nodes to
	NULL so that content_info_free() won't double-free any of the
	other nodes we have already free'd (or are about to free).

	* camel-gpg-context.c (gpg_ctx_get_utf8_diagnostics): New function
	to get the UTF-8 version of the diagnostics (if the locale isn't
	already UTF-8 safe).
	(gpg_verify): Use the utf-8 diagnostics here. Also fixed a memleak
	in the exception case.

	* camel-mime-filter-charset.c
	(camel_mime_filter_charset_new_convert): NULL-protect the to/from
	charsets in the g_warning call.

2003-04-08  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes for bug #40778. Probably others as well.

	* providers/imap/camel-imap-utils.c (parse_params): Return 0 on
	success, or -1 on fail. The other small utility functions should
	probably do the same, but I was too lazy to fix them. Setting
	inptr to NULL is just lame.
	(imap_body_decode): New function to correctly parse a BODY
	response.
	(imap_parse_body): Rewritten to use the above function.

2003-04-08  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Make sure
	host->h_name is not an empty string too? Apparently for one user
	his resolved hostname is "". Go figure. Probably a broken system,
	but easy enough to work around.

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate): If
	store->engine->line is NULL, use _("Unknown error") as the error
	string instead.

2003-04-08  Not Zed  <NotZed@Ximian.com>

	* camel-folder-summary.c (camel_folder_summary_load): use
	g_strerror, and use errno directly rather than ferrno().
	(summary_header_load): set errno when we get a version mismatch.

2003-04-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c: Disable debug printf's

2003-03-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.c (gssapi_challenge): If we are using the
	heimdal krb5 implementation, don't free outbuf ever. Seems to
	segfault if we do.

2003-03-31  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-enriched.c (enriched_to_html): Use strncasecmp
	for matching the nofill and /nofill tags. Also fixed to handle
	enriched tags that require <param> tags.

2003-03-28  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-store.c (get_folder): remove unused
	var.

	* providers/imap/camel-imap-utils.c (imap_parse_list_response):
	moved an unused var to the #if 0'd out block.

	* providers/imap/camel-imap-store.c
	(parse_list_response_as_folder_info): remove unused vars.

	* camel-index-control.c (main): deifne camel_init() before using
	it.

	* camel-vee-store.c (vee_get_folder): removed unused var.

	* camel-stream-mem.c (stream_write): warning -> fixme.

	* camel-stream-filter.c (_CamelStreamFilterPrivate): Add a ; to
	the end of the struct definition.

	* camel-store.c (camel_store_delete_folder): remove unused var.
	(camel_store_rename_folder): "
	(camel_store_unsubscribe_folder): "

	* camel-mime-part.c (write_to_stream): Changed warning into a
	TODO.
	(construct_from_parser): removed warning, the code was fixed.

	* camel-mime-message.c (construct_from_parser): Remove the
	warning, the code was fixed.

	* camel-mime-filter-enriched.c (camel_mime_filter_enriched_new):
	Remove unused var.

	* camel-medium.c (camel_medium_get_header): Removed warning, and
	changed docs to reflect it.

	* camel-gpg-context.c (gpg_ctx_parse_status): handle MODE_EXPORT
	as a noop (warning).

	* camel-folder.c (get_message_user_tag): changed a warning into a
	fixme (its not that important).
	(camel_folder_get_message_user_tag): "

	* camel-data-cache.c (data_cache_finalise): removed unused vars.
	(data_cache_expire): "

2003-03-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.c (gssapi_challenge): Get rid of debug
	printf's that are no longer needed. In the case of errors, don't
	release the outbuf gss_buffer_t since it shouldn't be set. Also
	g_free (str) when we are done with it.

	* camel-mime-utils.c (header_encode_phrase_merge_words): When we
	remove a node from the list, make sure to g_list_free_1().
	(header_encode_phrase_merge_words): Don't use
	CAMEL_FOLD_PREENCODED as the upper-bound for merged-word length if
	the merged-word will not be an rfc2047 encoded word. Instead, use
	CAMEL_FOLD_SIZE-8 (which is the value we use in other places for
	determining upper-bound lengths). Solves bug #38659.

2003-03-27  Dan Winship  <danw@ximian.com>

	* camel-url.c (append_url_encoded): Like camel_url_encode, but
	works directly on an existing GString.
	(camel_url_to_string, output_param): Use it.
	(camel_url_encode): Likewise. Remove "escape_unsafe" arg since the
	"unsafe" chars are the ones that should *always* be escaped, and
	the places we were passing FALSE were wrong.
	(camel_url_decode): replace with a new version

	* camel-file-utils.c (camel_file_util_safe_filename): Remove extra
	arg to camel_url_encode.

	* tests/misc/url.c (main): Add tests of basic URL parsing and
	unparsing

2003-03-28  Not Zed  <NotZed@Ximian.com>

	*
	camel-mime-part-utils.c (simple_data_wrapper_construct_from_parser):
	Do a more thorough check for html marked as text/plain.  Check
	that the text starts with <html or <!doctype.  More complete fix
	for #16817.

2003-03-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.c (camel_sasl_gssapi_finalize): Pass in the
	addresses of the second args to the delete/release functions.

2003-03-27  Not Zed  <NotZed@Ximian.com>

	* camel-object.c (camel_object_bag_list): Ignore whether or not
	the bag is currently reserved.  We'll miss the new potential
	object, but only 1.  Should address #40103.

2003-03-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-service.c (camel_gethostbyaddr): Don't use setv when we
	don't need the stdarg interface.
	(camel_gethostbyname): Same.

2003-03-24  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-search.c (search_user_tag): This expression can
	never return an array. We must always return a string value.

2003-03-24  Timo Sirainen  <tss@iki.fi>

	* camel-imap-command.c (imap_read_untagged) Integer overflow fix.
	If server sent a huge literal length, only a few bytes of memory
	was allocated to it, but server could write as much data there as
	it wanted.

2003-03-21  Jeffrey Stedfast  <fejj@ximian.com>

	Camel part of the fix for Lewing's bug #39204. Second half of the
	patch should also fix it so that text/plain parts that are
	detected as being text/html are rendered as html (not that I agree
	with this mind you, but corporate customers want this "feature").

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): If the part is
	text/html and doesn't have a charset and we are able to find a
	charset in the meta tags of the html content, set the charset
	param on the content-type.
	(camel_mime_part_construct_content_from_parser): After setting the
	content object on the mime part, re-set the content-type of the
	content object back to the one from the parser (as it may contain
	changes from the original - see changes made to the ct in
	simple_data_wrapper_construct_from_parser for details).

2003-03-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (camel_certdb_nss_cert_get): continue
	reading the cert file until we've read it all or get a non-EINTR
	errno.

2003-03-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.c: #include <com_err.h> instead of
	#include <et/com_err.h>

2003-03-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl.c: Plug in GSSAPI support.

	* camel-sasl-gssapi.[c,h]: Various fixes to make it compile (fixed
	type-o's mostly).

2003-03-20  Dan Winship  <danw@ximian.com>

	Handle raw 8-bit From data "correctly". (The same way we handle
	raw 8-bit Subject data.)

	* camel-mime-utils.c (header_decode_mailbox): Take a charset arg
	and pass it to header_decode_string.
	(header_decode_address): Take a charset arg and pass it to
	header_decode_mailbox.
	(header_mailbox_decode): Likewise.
	(header_address_decode): Take a charset arg and pass it to
	header_decode_address.

	* camel-folder-summary.c (summary_format_address): Take a charset
	arg and pass to header_address_decode.
	(message_info_new, camel_message_info_new_from_header): Pass
	charset to summary_format_address

	* camel-internet-address.c (internet_decode): Update for
	header_address_decode change. (Unfortunately we don't have a
	charset to pass here.)

	* camel-mime-message.c (camel_mime_message_build_mbox_from): Move
	this here from camel-mbox-summary since the same functionality is
	needed by evolution-mail too (and update for header_address_decode
	change)

	* providers/local/camel-mbox-summary.c
	(camel_mbox_summary_build_from): Moved to CamelMimeMessage

2003-03-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (process_header): Removed unused variable left
	over from my previous fix.

	* providers/smtp/camel-smtp-transport.c (smtp_send_to): Don't pass
	'has_8bit_parts' to smtp_data() anymore.
	(smtp_data): No longer takes 'has_8bit_parts' argument. Ignore
	whether or not the message has 8bit parts when deciding what the
	required encoding type we need to enforce. Fixes bug #39744.

2003-03-13  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (process_header): Use
	header_contentid_decode() as this new function should be safer
	than the hack that we had before.

	* camel-mime-utils.c (header_contentid_decode): New function to
	try and parse a content-id string in such a way as to work around
	some of the known bugs in other MIME implementations. Try to be as
	"safe" as we can - ie. don't allow for more than 1 @ (since the
	mailer uses "@@@%d" as a fake content-id value for parts without
	content-ids) and don't allow for invalid content-type chars.

2003-03-13  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder.c (get_uids): Don't add bogus uids to the uid
	array. Might fix bug #38868 (it's the only way I can figure that
	camel_folder_get_message_info() could possibly return NULL for the
	Outbox folder).

2003-03-12  Not Zed  <NotZed@Ximian.com>

	* camel-object.c (remove_bag): removed, it was double-freeing the
	key.
	(save_object): Just save the object in an array.
	(camel_object_bag_destroy): first save the object bag's objects in
	a list, then remove them one at a time from the bag since we can't
	remove hash table entries while we're in a foreach (PITA glib
	shit).  For #39486.
	(camel_object_bag_*): killed some warnings.

2003-03-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url-scanner.c (camel_url_addrspec_end): Doh! If inptr ==
	pos + 1, then return FALSE (before it was checking for inptr ==
	pos, but it will never be pos).

2003-03-07  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (vee_search_by_expression): handle a null
	return from search_by_expression, for bug #33786.

2003-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_next_word):
	s/g_strncasecmp/strncasecmp/g

	* camel-iconv.c: Updated to be an exact copy of e-iconv (except
	names changed). We don't use this yet, but we may in the future.

	* camel-url.c (camel_url_new_with_base): Here too.

	* camel-sasl-kerberos4.c (krb4_challenge): Use camel_strdown()
	here instead of g_strdown() since the latter has been deprecated.

	* providers/imap/camel-imap-utils.c (imap_parse_body): Use
	camel_strdown() since g_ascii_strdown() does not do what we
	thought.

	* providers/imap/camel-imap-store.c:
	s/strstrcase/camel_strstrcase/g

	* providers/imap/camel-imap-folder.c (do_append):
	s/strstrcase/camel_strstrcase/
	(handle_copyuid): Same.

	* string-utils.c (camel_strdown): New function because the
	g_ascii_strdown interface sucks.
	(camel_strstrcase): Renamed from strstrcase.

2003-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-text-index.c (camel_utf8_next): Same as below.

	* camel-search-private.c (camel_utf8_getc): Updated since not all
	platforms/compiles support __inline__.

2003-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (camel_mime_part_get_encoding): Get rid of the
	const return - it mismatches the prototype and we don't need it
	anyway. Fixes bug #39173.

2003-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes for bug #39170

	* camel-store-summary.c (camel_store_info_set_string): Remove
	return keyword.

	* camel-session.c (camel_session_thread_msg_free): Remove return
	keyword.
	(camel_session_thread_wait): Same.

	* camel-index.c (camel_index_cursor_reset): Remove return keyword.

2003-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes for bug #39168

	* providers/local/camel-spool-summary.c: Get rid of the empty
	private struct.

	* providers/local/camel-mbox-summary.c: Get rid of the empty
	private struct.

	* camel-vee-store.c: Get rid of the empty private struct.

	* camel-mime-filter-from.c: Get rid of the empty private struct.

2003-03-05  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): Add a CRLF filter to the output stream to
	convert any CRLF sequences into plain old line-feeds to work
	around a bug in some local transport programs.

2003-03-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-object.h: s/class/klass in one place so that the header is
	c++-safe.

2003-03-03  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (camel_tcp_stream_ssl_new): Updated
	to use the new API from a fe commits ago for the NSS stream. This
	is just to make it compile, but does not update the behaviour to
	act like the NSS stream. Note that people shouldn't be using
	OpenSSL anyway.
	(camel_tcp_stream_ssl_new_raw): Same.

	* camel-process.[c,h]: New source file containing convenience
	functions for process creation/termination mainly for use with
	Pipe filters but should be usable for anything we want.

	* camel-io.[c,h]: New source files implementing read/write system
	calls with proper error checking and cancellation
	(ie. StreamFs::read/write and CamelTcpStreamRaw::read/write). No
	sense duplicating the same code over and over. Now I can use this
	same code easily in other i/o code (such as Pipe filters and gpg
	code?).

2003-03-03  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (camel_store_unsubscribe_folder): Do similar
	folder != NULL checking as for delete_folder before passing a NULL
	to object_bag_remove.

2003-02-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-http-stream.c (http_connect): Here too.

	* providers/smtp/camel-smtp-transport.c (connect_to_server): Same
	as IMAP and POP.

	* providers/imap/camel-imap-store.c (connect_to_server): Same as
	the POP3 code.

	* providers/pop3/camel-pop3-store.c (connect_to_server): Pass in
	appropriate flags for camel_tcp_stream_ssl_new*() functions.

	* camel-tcp-stream-ssl.c (enable_ssl): Not all ssl/tls streams
	will want to allow each of SSLv2, SSLv3 and TLSv1 so use flags to
	decide which to enable/disable.
	(camel_tcp_stream_ssl_new): Now takes a flags argument to mask out
	which SSL/TLS versions the stream should be compatable with.
	(camel_tcp_stream_ssl_new_raw): Same.

2003-02-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-stream-filter.c: Add a 'flushed' state variable to the
	private struct.
	(do_read): Set p->flushed to TRUE after we call
	camel_mime_filter_complete() on all the filters.
	(do_reset): Set p->flushed to FALSE.
	(do_eos): Make sure the filters have been flushed before returning
	that the stream is at EOS.

	* camel-mime-filter-canon.c (complete): Don't add a eol -
	otherwise we will fail to verify some mutt signatures that do not
	have a blank line before the boundary line (and note that the last
	\n before the boundary really belongs to the boundary anyway) so
	#if 0 this code out for now.

2003-02-27  Not Zed  <NotZed@Ximian.com>

	* camel-multipart-signed.c: Undo jeff's changes.

	* providers/local/camel-spool-store.c (scan_dir): Fix a paste-o in
	the object_bag_get key.

2003-02-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart-signed.c: Updated to use g_alloca instead of
	alloca so that we can skip all the #ifdef checks and skip checking
	for alloca in configure.in and all that foo.

	* camel-store.c (camel_store_delete_folder): Make sure the folder
	is non-NULL before trying to remove it from the store's
	object-bag.

2003-02-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): canonicalise the
	charset name (if it is an iso charset) so that our strncasecmp to
	see if it is an iso-8859-# charset will be guarenteed to work on
	all systems.
	(canon_charset_name): New function to return the canonical iso
	charset name.
	(simple_data_wrapper_construct_from_parser): If the charset is
	NULL *or* the charset == "us-ascii" then check that it is 7bit
	clean to decide if it is rawtext (we did not check the case where
	charset was "us-ascii" before).

2003-02-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-message.c: Same as the ones below.

	* camel-mime-part.c: Reverted back to pre-camel-iconv

	* camel-filter-search.c: Same as below.

	* camel-folder-summary.c: Reverted back to pre-camel-iconv

	* camel.c (camel_init): Reverted to pre-camel-iconv

	* camel-charset-map.c (camel_charset_locale_name): Removed (part
	of the revert).
	(camel_charset_canonical_name): Same.

	* camel-mime-filter-charset.c: Revert back to using e_iconv from GAL.

	* camel-mime-part-utils.c: Revert back to using e_iconv from GAL.

	* camel-mime-utils.c: Revert back to using e_iconv from GAL.

	* camel-sasl-digest-md5.c: Revert back to using e-iconv from GAL.

2003-02-24  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_canonical_name): g_alloca
	(strlen (charset) + 1) so we don't overflow the buffer.

	* providers/pop3/camel-pop3-stream.c (stream_write): Don't write
	the passwd, fixes "bug" #38601.

	* camel-iconv.c: Make bucket->refcount 31 bits and bucket->used 1
	bit instead of having each use their own 32bit int.
	(iconv_cache_bucket_expire): Use g_iconv_close() here, missed this
	before.
	(camel_iconv): Might as well call g_iconv here even though it just
	calls iconv directly.

2003-02-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-iconv.c (camel_iconv_charset_name): New function...back
	from the depths of hell from whence it came originally. Turns out
	that g_iconv_open() is lame and can't handle all the stuff we used
	to handle in e_iconv_charset_name().
	(camel_iconv_open): Use camel_iconv_charset_name() on the to/from
	charsets rather than camel_charset_canonical_name(). Now maybe
	g_iconv_open will work for charsets such as "ks_c_5601-1987".

	* providers/pop3/camel-pop3-store.c (pop3_connect): Reget the
	capabilities after a successful authentication.

	* providers/pop3/camel-pop3-engine.c (get_capabilities): If we are
	in the TRANSACTION state and CAPA did not list UIDL as a supported
	command, try checking for it the hard way.

2003-02-23  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_data): Do it the
	same way we just made the sendmail code do it.

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): My last change but in a better way.

2003-02-22  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_data): Remove all
	Bcc headers before sending to the smtp server.

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): Remove all Bcc headers before sending to
	sendmail.

2003-02-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel.c (camel_init): Call camel_iconv_init().
	(camel_shutdown): Call camel_iconv_shutdown().

	* camel-sasl-digest-md5.c (digest_response): Updated to use
	camel-iconv and the new camel-charset-map functions.

	* camel-mime-utils.c: Updated to use camel-iconv and the new
	camel-charset-map functions.

	* camel-mime-part-utils.c (check_html_charset): Use
	camel_charset_canonical_name() instead of e_iconv_charset_name()
	which is longer available.
	(convert_buffer): Use camel-iconv.
	(simple_data_wrapper_construct_from_parser): Since
	camel_charset_iso_to_windows() returns the charset in it's
	canonical format, no need to re-canonicalise it.

	* camel-mime-part.c (process_header): Use
	camel_charset_canonical_name() instead of e_iconv_charset_name()
	which is longer available.

	* camel-mime-message.c (process_header): Use
	camel_charset_canonical_name() instead of e_iconv_charset_name()
	which is longer available.

	* camel-mime-filter-charset.c: Use camel-iconv.

	* camel-folder-summary.c (message_info_new): Use
	camel_charset_canonical_name() instead of e_iconv_charset_name()
	which is longer available.
	(content_info_new): Use camel_charset_locale_name().
	(camel_message_info_new_from_header): Same as message_info_new().

	* camel-search-private.c: Use g_alloca() instead of alloca().

	* camel-filter-search.c (check_header): Use
	camel_charset_canonical_name() instead of e_iconv_charset_name()
	which is longer available.

	* camel-charset-map.c (camel_charset_locale_name): New function,
	replaces e_iconv_locale_charset().
	(camel_charset_canonical_name): New function, similar to
	e_iconv_charset_name() but instead of returning the iconv-friendly
	name, it returns the canonical name. (g_iconv will do the
	iconv-friendly name conversions for us).

2003-02-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-search.c (run_command): Redirect program's stdout
	and stderr to /dev/null

	* camel-filter-driver.c (pipe_to_system): Redirect the program's
	stderr to /dev/null
	(pipe_to_system): Write the pipe to a mem stream and use the mem
	stream in the parser. Also, when setting an exception get the
	errno from the parser so we can give more info about the error to
	the user.

2003-02-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (stream_connect): Fixed a type-o in the
	ENABLE_IPv6 ifdef section.

2003-02-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (pipe_message): New filter action that
	pipes the message source to the user-program and reads back the
	modified message and replaces driver->priv->message with the new
	message object.
	(do_copy): Check p->modified to make sure the message hasn't been
	modified by the pipe-message action - if it has been modified,
	default to the slower camel_folder_append_message() way of
	copying.
	(do_move): Same.
	(pipe_to_system): Set p->modified to TRUE if the user-program gave
	us back a message stream and we were able to parse it.
	(camel_filter_driver_filter_message): If the message has been
	modified, always use camel_folder_append_message() when appending
	it to the default folder.

2003-02-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-search.c: Added a (get-size ) function to fix bug
	#38073.
	(search_get_size): Implemented.

2003-02-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url-scanner.c (url_scanner_table_init): Mark chars with
	the high-bit set as CTRL chars.
	(camel_url_web_end): If the char before the start of the url is an
	open-brace, watch out for the matching close-brace.
	(camel_url_file_end): Same.

2003-02-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-smime-context.c (smime_get_password): Same as the gpg and
	pkcs7 contexts.

	* camel-sasl-popb4smtp.c (popb4smtp_challenge): Updated for
	camel_session_get_password().

	* camel-pkcs7-context.c (get_password): Same as the gpg code.

	* camel-gpg-context.c (gpg_ctx_parse_status): Updated for
	camel_session_get_password().

	* providers/smtp/camel-smtp-transport.c (smtp_connect): No need to
	set USER_CANCEL exception here as it is done by
	camel_session_get_password(). Also updated for the new
	get_password() API change.

	* providers/imap/camel-imap-store.c (imap_auth_loop): Updated for
	camel_session_get_password() changes. We don't need to play the
	"bad passwd" game here too, do we? Bah, probably should but I
	don't feel like it for now. Maybe when we rewrite the IMAP
	provider.

	* camel-session.c (camel_session_get_password): Now takes a
	'reprompt' argument that will force user-input to be given even if
	we have the passwd cached.

	* providers/pop3/camel-pop3-store.c (pop3_connect): Instead of
	uncaching the passwd after we receive a -ERR from the POP server,
	set 'reprompt' to TRUE to force user-input for the next password
	prompt (ie, make sure the front-end knows not to just return the
	cached value). The front-end can then decide to fill-in the
	user-input field with the last passwd that the user supplied.
	(pop3_try_authenticate): Now takes a reprompt argument which we
	pass into camel_session_get_password().

2003-02-05  Dan Winship  <danw@ximian.com>

	* Makefile.am (libcamelincludedir): Define in terms of
	privincludedir.
	(camellibexecdir): Define in terms of privlibexecdir
	(libcamel_la_LDFLAGS): Remove -rpath. (automake will add that)

	* providers/imap/Makefile.am (libcamelimapincludedir): Define in
	terms of privincludedir.
	(INCLUDES): Remove -I$(includedir)
	* providers/local/Makefile.am: Likewise
	* providers/nntp/Makefile.am: Likewise
	* providers/pop3/Makefile.am: Likewise
	* providers/sendmail/Makefile.am: Likewise
	* providers/smtp/Makefile.am: Likewise

2003-02-04  Not Zed  <NotZed@Ximian.com>

	* camel-object.c (camel_object_bag_new): Init bag->owner to 0.

2003-01-31  Not Zed  <NotZed@Ximian.com>

	* camel-object.c (camel_object_bag_*): Changed to use a posix
	semaphore instead of a condition variable + flag to reserve the
	object bag because e_mutex_cond is broken.

2003-02-04  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_parse_body): Use
	g_ascii_strdown() instead of g_strdown, since g_strdown is
	deprecated.
	(imap_parse_body): Same.

	* providers/imap/camel-imap-folder.c (decode_internaldate): Use
	strncasecmp() here too.
	(parse_fetch_response): And here.
	(camel_imap_folder_selected): Here too.

	* providers/imap/camel-imap-utils.c (imap_namespace_decode): Use
	strncasecmp() instead of g_strncasecmp() because the latter is
	deprecated.

	* providers/imap/camel-imap-store.c (imap_get_capability): Again here.
	(hash_folder_name): Here too.
	(compare_folder_name): And here.
	(get_folder_online): Again.
	(get_folder_offline): And again.

	* providers/imap/camel-imap-folder.c (camel_imap_folder_selected):
	Same as below again.

	* providers/imap/camel-imap-command.c (camel_imap_response_free):
	Same as below.

	* providers/smtp/camel-smtp-transport.c (smtp_data): Use
	strcasecmp() because g_strcasecmp() is deprecated.

	* camel-url.c (camel_url_new_with_base): Use g_ascii_strdown()
	instead of g_strdown, since g_strdown is deprecated.

2003-01-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.c (gssapi_challenge): Pass in some default
	flags to gss_init_sec_context() (these default flags are defined
	as a MUST in rfc1964).

2003-01-22  Hans Petter Jansson  <hpj@ximan.com>

	* Makefile.am: $(libexec) -> $(libexecdir)

2003-01-22  Ettore Perazzoli  <ettore@ximian.com>

	* providers/imap/Makefile.am (libcamelimapincludedir): Update to
	the new $(BASE_VERSION)-versioned path.
	* providers/smtp/Makefile.am (libcamelsmtpincludedir): Likewise.
	* providers/sendmail/Makefile.am (libcamelsendmailincludedir):
	Likewise.
	* providers/pop3/Makefile.am (libcamelpop3includedir): Likewise.
	* providers/nntp/Makefile.am (libcamelnntpincludedir): Likewise.
	* providers/local/Makefile.am (libcamellocalincludedir): Likewise.

	* camel-lock-client.c (camel_lock_helper_init): Use
	CAMEL_LIBEXECDIR instead of CAMEL_SBINDIR to find
	camel-lock-helper.

	* Makefile.am: Install camel-lock-helper and camel-index-control
	in $(libexec)/evolution/$(BASE_VERSION)/camel.  Install
	libcamel.la in $privlibdir.
	(install-exec-hook): Update for the new location of
	camel-lock-helper.
	(libcamelincludedir): Version using $(BASE_VERSION).
	(INCLUDES): Define CAMEL_LIBEXECDIR.

2003-01-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-canon.c (complete): Set the backbuflen to 0 so
	that calling us again won't re-flush the same data.

2003-01-17  Larry Ewing  <lewing@ximian.com>

	* camel-mime-filter-enriched.c (enriched_to_html): only grow the
	buffer when we are out of space.

2003-01-14  Not Zed  <NotZed@Ximian.com>

	* camel-mime-parser.c (folder_scan_step): If we have no
	content-type header, set it to text/plain explcitly, rather than
	NULL, because some code doesn't handle NULL.

2003-01-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-gssapi.[c,h]: New source files implementing the
	GSSAPI SASL mechanism.

2003-01-13  Not Zed  <NotZed@Ximian.com>

	* camel-mime-filter-tohtml.c: fix header include order.
	
	* camel-object.c (camel_object_bag_reserve): Add an assert to
	check we're not trying to reserve the bag more than once in a
	given thread.
	(camel_object_bag_list): If we have reserved the bag, dont try and
	cond wait.  Fixes a deadlock.

	* camel-mime-filter-tohtml.c (writeln): Read the characters as
	utf8, rather than as 8 bit bytes.  Remove the PRESERVE_8BIT as it
	has no meaning.  Also change the default logic slightly so that 8
	bit or greater characters are properly converted to entities.

	* camel-utf8.c (camel_utf8_getc_limit): new function, gets a utf8
	char, bounded by an end pointer.

2003-01-07  Dan Winship  <danw@ximian.com>

	* camel-provider.h (CamelProvider): add a "translation_domain"
	field. (NULL for all providers in the camel source tree itself).

	* camel-session.c (register_provider): Translate provider strings
	in the correct domain

2003-01-06  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (store_sync): init local exception before doing
	anything.  fixes a crash.

2003-01-04  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_send_to): Instead of
	checking recipients != NULL, check that camel_address_length
	(recipients) != 0 since it is illegal for recipients to be NULL
	(camel_transport_send_to already checks this).

2002-12-17  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c: Replace calls to
	g_string_sprintfa() with g_string_append_printf() since the former
	seems to have been deprecated.

	* providers/imap/camel-imap-search.c: Same.

	* providers/imap/camel-imap-folder.c: Here too.

	* providers/local/camel-mbox-summary.c: And here.

	* providers/local/camel-local-summary.c: Replace
	g_string_sprintf() with g_string_printf().

	* camel-data-cache.c (data_cache_expire): Replace
	g_string_sprintf() with g_string_printf().

	* camel-url.c: Replace calls to g_string_sprintfa() with
	g_string_append_printf() since the former seems to have been
	deprecated.

	* camel-service.c: Same.

	* camel-mime-utils.c: Here too.

2002-12-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Detect text/html
	parts that were marked as text/plain and re-tag them as text/html
	parts. Note: currently just checks if the first non-lwsp char is a
	'<' - but we might need to be smarter about this? *sigh* Stupid
	Windows mailers.

	* camel-mime-filter-tohtml.c (camel_text_to_html): New convenience
	function to replace calls to e_text_to_html() in the
	mailer/composer etc.

	* camel.h: #include some headers we had forgotten to add
	previously, also added camel-mime-filter-enriched.h.

	* camel-mime-filter-enriched.[c,h]: New stream filter to convert
	text/enriched and text/richtext into HTML.

2002-12-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart-signed.c (camel_multipart_signed_verify): Don't
	apply the CANON_STRIP filter here, since we are verifying whatever
	raw data we received (all we want to do is convert o the canonical
	CRLF format).

2002-12-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-tohtml.c (html_convert): Use camel-url-scanner
	instead of regex.

2002-12-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url-scanner.c (camel_url_addrspec_end): Fixed to not be
	fooled in the case where the address is followed immediately by a
	period.
	(camel_url_web_end): Made more robust.
	(camel_url_scanner_scan): Oops. We need to set the match->pattern
	string pointer to the correct pattern before executing the
	start/end methods (as some of them rely on this info).

2002-12-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url-scanner.c: New code to scan for patterns (used only
	for url pattern matching atm, but we may find other uses for this
	and thus rename it? I dunno). Uses ETrie.

2002-12-07  Not Zed  <NotZed@Ximian.com>

	* camel-data-cache.c (data_cache_init): Use a bag instead of a
	hashtable to track the cache streams.
	(data_cache_finalise): Same.
	(free_busy): No longer needed.
	(data_cache_expire): use bag instead of hashtable.
	(stream_finalised): No longer required.
	(camel_data_cache_add): objectbagise
	(camel_data_cache_get): "
	(camel_data_cache_remove): "
	(data_cache_path): Set the now expired date before running expiry,
	so it plays better with multiple threads.  Still a couple of
	harmless races.

2002-12-06  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-store.c (scan_dir): folders ->
	object bag.
	(get_folder_info_mbox): folders -> object bag.

	* providers/local/camel-mh-store.c (folder_info_new): folders ->
	object bag.

	* providers/local/camel-maildir-store.c (scan_dir): folders ->
	object bag.

	* providers/local/camel-local-store.c (rename_folder): folders ->
	object bag.

	* camel-private.h (CamelStorePrivate): Remove 'cache' lock,
	handled by the objectbag.

	* providers/imap/camel-imap-store.c (copy_folder): Removed.
	(imap_store_refresh_folders): folders -> object bag.
	(get_folder_counts): folders -> object bag.

	* camel-vee-store.c (vee_get_folder): changes for folders
	objectbag.
	(vee_get_folder_info): Change to use folders objectbag.  Also,
	dont refresh the base folder if we're in FAST mode.
	(build_info): Removed, no longer needed.
	(vee_rename_folder): Fixed for folders objectbag.

	* camel-store.c (camel_store_init): init the folders objectbag.
	(camel_store_finalize): Destroy the folders object bag.
	(folder_matches): 
	(folder_finalize): Removed, now handled implicitly by the
	objectbag.
	(camel_store_get_folder): object bag changes.
	(camel_store_delete_folder): "
	(get_subfolders): Removed, now handled without a callback.
	(camel_store_rename_folder): Changed to use object bag of folders.	
	(trash_add_folder): Removed.
	(init_trash): use folders object bag.
	(copy_folder_cache): 
	(sync_folder): Removed, no longer needed.  Weird arsed code anyway.
	(store_sync): Use folder object bag instead of hashtable.
	(camel_store_unsubscribe_folder): "
	(camel_store_init): remove cache_lock init, no longer used.
	(camel_store_finalize): Same for cleanup.

2002-12-05  Not Zed  <NotZed@Ximian.com>

	* camel-store.h (struct _CamelStore): change folders from a
	hashtable into a CamelObjectBag.

	* camel-object.c (camel_object_ref): Use type_lock instead of
	class lock for ref counting.
	(camel_object_unref): Use type_lock instead of class lock for
	unref.
	(camel_object_unref): If the object is 'bagged', then also look
	hooks, and remove it from any bags.
	(camel_object_bag_new):
	(camel_object_bag_destroy):
	(camel_object_bag_add):
	(camel_object_bag_get):
	(camel_object_bag_remove_unlocked):
	(camel_object_bag_list): 
	(camel_object_bag_abort): 
	(camel_object_bag_remove): New functions to implement a utility
	object which can manage a 'bag' of weakly ref'd children in an
	atomic & threadsafe way.

2002-12-04  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store-summary.c
	(camel_imap_store_summary_add_from_full): Properly handle the case
	where the namespace is "". Fixes bug #34975

2002-12-03  Jeffrey Stedfast  <fejj@ximian.com>

	* broken-date-parser.c (get_tzone): Fixed to not get false
	positives when the token is shorter than the actual timezone
	string (but matches the first little bit of it).
	(datetok): Modified to properly handle when the first char of a
	token is a special char (such as a '-') that is also used as a
	token delimiter.

2002-11-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (stream_read): Use the new
	camel_operation_cancel_prfd() function to get the cancellation fd
	so we can poll on it for cancellation stuff.
	(stream_write): Same.

2002-11-22  Not Zed  <NotZed@Ximian.com>

	* camel-operation.c (camel_operation_cancel_prfd): Implement, gets
	a nspr pr filedesc to poll/wait on
	(struct _CamelOperation): include a pr filedesc.

2002-11-21  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store-summary.c
	(camel_imap_store_summary_namespace_find_path): If we have a
	namespace of "", then always match any path.
	(camel_imap_store_summary_namespace_find_full): Same, for full
	names. Should address #33309 & friends.

2002-11-19  Radek Doulik  <rodo@ximian.com>

	* camel-mime-filter-tohtml.c (html_convert): added
	CAMEL_MIME_FILTER_TOHTML_PRESERVE_8BIT flag

2002-11-18  Rodney Dawes  <dobey@ximian.com>

	* tests/*/Makefile.am: Removed $(GNOME_LIBDIR) and $(GNOMEUI_LIBS)
	
2002-11-15  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (imap_connect_online): If the
	namespace is at/below INBOX, check for the INBOX explicitly (since
	it obviously won't show up in a LSUB INBOX.*). If either INBOX is
	not returned in the response or if the folder flags contain
	\NoSelect, subscribe to INBOX and then try LSUB again.

2002-11-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-tohtml.c (html_convert): Rewritten. Much much
	much cleaner implementation now, though uses malloc/free more
	often than I'd like.

2002-11-11  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (get_message_simple): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).

	* providers/pop3/camel-pop3-folder.c (pop3_refresh_info): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).
	(pop3_get_message): Same.

	* providers/local/camel-spool-summary.c (spool_summary_sync_full):
	Use g_strerror when setting an exception string (we need it to be
	in UTF-8).
	(spool_summary_check): Here too.

	* providers/local/camel-spool-store.c (construct): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).
	(get_folder): Same.
	(scan_dir): Here too.

	* providers/local/camel-spool-folder.c (spool_lock): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).

	* providers/local/camel-mh-summary.c (mh_summary_check): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).

	* providers/local/camel-mh-store.c (delete_folder): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).

	* providers/local/camel-mbox-summary.c (summary_update): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).
	(mbox_summary_sync_full): Here too.
	(mbox_summary_sync_quick): Same.
	(mbox_summary_sync): Also here.
	(camel_mbox_summary_sync_mbox): Again here.

	* providers/local/camel-mbox-folder.c (mbox_lock): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).
	(mbox_append_message): Same.
	(mbox_get_message): Here too.

	* providers/local/camel-maildir-summary.c (maildir_summary_load):
	Use g_strerror when setting an exception string (we need it to be
	in UTF-8).
	(maildir_summary_check): Same.

	* providers/local/camel-maildir-store.c (get_folder): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).
	(delete_folder): Same.
	(delete_folder): Here too.

	* providers/local/camel-local-summary.c (local_summary_sync): Use
	g_strerror when setting an exception string (we need it to be in
	UTF-8).

	* providers/local/camel-local-store.c (get_folder): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).
	(create_folder): Same.
	(xrename): Here too.
	(rename_folder): And here.
	(delete_folder): Also here.

	* camel-provider.c (camel_provider_init): For debugging printfs,
	we want to use normal strerror (we want locale charset, not
	UTF-8).

	* camel-movemail.c (camel_movemail): Use g_strerror when setting
	an exception string (we need it to be in UTF-8).
	(movemail_external): Same.
	(camel_movemail_copy_file): Here too.
	(camel_movemail_solaris): Also here.

	* camel-mime-utils.c (rfc2047_decode_word): For debugging printfs,
	we want to use normal strerror (we want locale charset, not
	UTF-8).
	(header_encode_param): Same.

	* camel-mime-part-utils.c (convert_buffer): For debugging printfs,
	we want to use normal strerror (we want locale charset, not
	UTF-8).

	* camel-lock-client.c (camel_lock_helper_init): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).

	* camel-data-cache.c (camel_data_cache_remove): Use g_strerror
	when setting an exception string (we need it to be in UTF-8).

	* camel-tcp-stream-raw.c (flaky_tcp_write): For debugging printfs,
	we want to use normal strerror (we want locale charset, not
	UTF-8).
	(flaky_tcp_read): Same.

	* camel-gpg-context.c (gpg_ctx_op_step): For debugging printfs, we
	want to use normal strerror (we want locale charset, not UTF-8).

	* camel-service.c (camel_gethostbyname): Use g_strerror when
	setting an exception string (we need it to be in UTF-8).

	* camel-lock.c (camel_lock_dot): Use g_strerror when setting an
	exception string (we need it to be in UTF-8).
	(camel_lock_fcntl): Same.

2002-11-07  Not Zed  <NotZed@Ximian.com>

	* camel-mime-part.c (camel_mime_part_set_content_type): constify
	the content_type.

2002-11-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-i18n.h: Added.

	* camel-object.h: #include camel-i18n.h instead of gnome-i18n.h

	* camel-lock.c: Same.

2002-11-07  Rodrigo Moya <rodrigo@ximian.com>

	* camel-object.h: removed gnome-defs.h, it does not exist.

2002-11-05  Not Zed  <NotZed@Ximian.com>

	* Makefile.am (camel_lock_helper_LDADD): Created temporary link
	list, we need to link with something for gettext.

	* camel.h: Remove gstring-util.h and hash-table-utils.h.

	* camel-text-index.c: 
	(text_index_normalise): Changed for g_utf8_strdown api change.

	* camel-search-private.c:
	* camel-mime-utils.c:
	* camel-mime-part-utils.c:
	* camel-html-parser.c:
	* camel-charset-map.c: Include glib/gunicode.h from glib instead
	of gal.

	* camel-filter-driver.c: Remove include of gtk/gtk.h, should never
	have been there.

2002-11-01  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (g_string_append_len): Removed. Glib2 has
	this function.

	* providers/local/camel-local-store.c (delete_folder): Use
	g_path_get_basename instead of g_strdup (g_basename (filename)).

	* camel-uid-cache.c (camel_uid_cache_new): Use g_path_get_dirname
	since g_dirname has been deprecated.

2002-10-31  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (camel_gpg_context_class_init): Set the
	virtual method pointers to the import/export methods.
	(camel_gpg_context_init): Set the key_protocol string.
	(gpg_hash_to_id): Handle 2 more hash types.
	(gpg_id_to_hash): Same.
	(gpg_ctx_op_step): Slight fixes to support import/export.
	(gpg_ctx_parse_status): Fix to hack around the fact that importing
	keys doesn't write to stdout.
	(gpg_import_keys): Implemented.
	(gpg_export_keys): Implemented.

	* camel-cipher-context.c (camel_cipher_context_class_init): Hook
	up default virtual methods for import/export.
	(camel_cipher_import_keys): Implemented.
	(camel_cipher_export_keys): Implemented.

2002-10-31  Jeffrey Stedfast  <fejj@ximian.com>

	* Makefile.am: Removed hash-table-utils.[c,h] from the build.

	* hash-table-utils.[c,h]: Removed.

	* string-util.c: Imported g_strcase[hash,equal] into here so we
	can remove hash-table-utils.[c,h].

	* camel-medium.c: Removed #include "hash-table-utils.h"

	* camel-mime-message.c: Same here.

	* camel-mime-part.c: And here.

	* camel-session.c: Here too.

	* providers/imap/camel-imap-store-summary.c: #include
	string-utils.h instead of hash-table-utils.h

	* camel-charset-map.c: Same.

	* camel-folder-summary.c: Here too.

	* camel-provider.c: Again here.

	* camel-store-summary.c: And again...

2002-10-31  Jeffrey Stedfast  <fejj@ximian.com>

	Remove a ton of useless snot.

	* Makefile.am: Remove gstring-util.[c,h] from the build.

	* gstring-util.[c,h]: Removed.

	* string-utils.c (string_equal_for_glist): Removed.
	(string_split): Removed.
	(string_trim): Removed.
	(string_prefix): Removed.
	(string_unquote): Removed.
	(strip): Removed.

	* hash-table-utils.c (g_hash_table_generic_free): Removed.

	g_str[n]casecmp functions are deprecated in glib2.

	* string-utils.c (strstrcase): Use strncasecmp instead of
	g_strncasecmp.

	* hash-table-utils.c (g_strcase_equal): Use strcasecmp
	instead of g_strcasecmp.

	* camel-smime-utils.c (camel_smime_is_smime_v3_signed): Same.
	(camel_smime_is_smime_v3_encrypted): Here too.

	* camel-sasl-digest-md5.c (decode_data_type): And here.
	(parse_server_challenge): Again here.

	* camel-pgp-mime.c (camel_pgp_mime_is_rfc2015_signed): Same.
	(camel_pgp_mime_is_rfc2015_encrypted): Same

	* camel-mime-part-utils.c (check_html_charset): Here too.

	* camel-folder-summary.c (camel_system_flag): Same.

2002-10-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_parse_status): Don't prematurely
	set gpg->complete to TRUE. Let gpg_ctx_op_step () set it to TRUE
	when gpg closes the status-fd instead.

2002-10-24  Not Zed  <NotZed@Ximian.com>

	** For bug #31647 and bug #31456.
	
	* camel-store-summary.c (store_info_string): for STORE_INFO_NAME,
	skip the leading /.

	* providers/imap/camel-imap-store.c
	(parse_list_response_as_folder_info): Remove jeff's last patch,
	and use the store summary to create the name and path of the
	folderinfo so it manages namespace issues.
	(get_folder_info_online): Just pass @top directly to
	build_folder_info always, since namespace is mapped to 1 tree
	level.
	(imap_build_folder_info): Remove jeff's last patch, dont strip
	leading /'s, they shouldn't exist.
	(imap_connect_online): Remove adding the INBOX here, we add it
	later.
	(get_subscribed_folders): Make sure INBOX is always in the list.
	some imap servers dont seem to let you subscribe to it(?), so
	always have it act as subscribed.

	* camel-store.c	(camel_folder_info_build): back out the last 2
	patches from Jeff (for #31456) to get the original behaviour.
	(camel_folder_info_build): When creating a fake
	parent, dont strip the namespace from the full_name.  malloc keys
	in hash since we dont have them anymore.
	(free_name): Helper to free names.

	* providers/imap/camel-imap-store-summary.c
	(camel_imap_store_summary_namespace_new): Canonicalise the
	namespace (strip trailing dir_sep), and change the path to remove
	any /'s.
	(camel_imap_store_summary_namespace_find_path):
	(camel_imap_store_summary_namespace_find_full): new, find
	namespace by path/full name.
	(camel_imap_store_summary_full_from_path): Changed to a simple
	wrapper around path_to_full, after checking namespace.
	(camel_imap_store_summary_add_from_full): map the namespace if
	present.
	(camel_imap_store_summary_path_to_full): If namespace exists,
	unmap it.

2002-10-18  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_folder):
	Canonicalise the source_uri to not have a path. Fixes bug #32268.

2002-10-17  Jeffrey Stedfast  <fejj@ximian.com>

	Possible fix for bug #32270

	* providers/pop3/camel-pop3-store.c (try_sasl): If we get an I/O
	error, we should not be setting the CANT_AUTH exception but should
	instead be setting the SYSTEM exception. Also check for EINTR
	which signifies a USER_CANCEL exception.
	(pop3_try_authenticate): If the auth mechanism isn't supported,
	don't set the CANT_AUTH exception since then we will loop and try
	again with the same data which will just cause an infinite loop.
	(pop3_connect): Simplified a bit.

2002-10-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (camel_certdb_nss_cert_set): If
	~/.camel_certs doesn't exist, create it.

2002-10-15  Not Zed  <NotZed@Ximian.com>

	* camel-tcp-stream-ssl.c (cert_fingerprint): helper, build
	fingerprint.
	(camel_certdb_nss_cert_get): Helper for nss certs.  Lookup cert.
	As well as fingerprint, the whole raw cert is checked for
	validity.
	(camel_certdb_nss_cert_add): Add an nss cert to a certdb, also
	saves the cert by fingerprint in ~/.camel_certs/.
	(ssl_bad_cert): Changed to use above functions to simplify logic.
	(ssl_bad_cert): Also added non-compiled code which mimics what
	mozilla does, but it doesn't work right :-/
	(camel_certdb_nss_cert_set): Save the raw cert associated with a
	cert.

	* camel-certdb.c (certdb_cert_free): Free the raw cert data if
	set.

2002-10-14  Not Zed  <NotZed@Ximian.com>

	* camel-file-utils.c (camel_file_util_encode_string): Encode a
	length of 0 as 1, not 0, to match the decode code.

2002-10-03  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (filter_filter): Do the filtering ourselves.
	This is so a problem like a missing uid (which can happen
	legitemitely) doesn't prematurely abort filtering.  Stop on all
	other errors.  See #31667.

2002-10-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (camel_gpg_context_new): No longer takes a
	path argument.
	(camel_gpg_context_fianlise): No need to free ctx->path.
	(gpg_ctx_new): No longer takes a path argument either.
	(gpg_ctx_free): No need to free ctx->path, it's no longer used.
	(gpg_ctx_op_start): Don't stat the path anymore and change the
	first arg to execvp to "gpg" so that we use the shell's
	environment to find gpg.
	(gpg_sign): Updated.
	(gpg_verify): Updated.
	(gpg_encrypt): Updated.
	(gpg_decrypt): Updated.
	(gpg_ctx_get_argv): Removed some debug printfs.

2002-10-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_id_to_hash): If the hash id is NULL,
	return CAMEL_CIPHER_HASH_DEFAULT. Fixes bug #32229.

2002-10-08  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-command.c (imap_read_response): If the
	response from the IMAP server is "No", don't set the
	SERVICE_UNAVAILABLE exception, this makes error reporting in the
	UI for deleting IMAP folders that cannot be deleted inaccurate
	(ie, it reports "Cannot delete in offline mode" which is not the
	problem).

2002-10-07  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #31752

	* providers/smtp/camel-smtp-transport.c (connect_to_server): Don't
	forget to send another EHLO command to the server once we toggle
	into STARTTLS mode.
	(smtp_helo): Reset any flags set using the EHLO response and also
	any authtypes.

2002-10-06  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #31681

	* camel-mime-utils.c: Fix all mailing list regex patterns to allow
	any number of spaces *or* tabs as pre-padding for the header
	values.

2002-10-03  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (write_to_stream): Use the content-object's
	rawtext flag to decide if it needs to be filtered through the
	charset filter instead of using the mime part's rawtext flag since
	this will never be set. Partial fix for bug #31655.

2002-10-03  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (folder_changed): Dont get the filter driver
	inside the change_lock.  Its not necessary, and can cause deadlock
	with the way the mailer gets the filter driver via g_mainloop.
	Should fix #31572.

2002-10-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_iso_to_windows): Map us-ascii
	to windows-1252 also.

2002-10-02  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (get_matching): Set *set to
	NULL if we dont get any matches.
	(imap_sync_online): If we get no matches, skip any work, also
	reorder some code to make it easier to skip.  See #31031.

	* providers/imap/camel-imap-store.c
	(imap_check_folder_still_extant): Default to "TRUE", if the list
	command failed, it probably means a server problem, assume the
	worst.  This makes imap_refresh_info not clear the exception and
	crash.  Fixes crash of #31000.

2002-10-01  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (imap_refresh_info): Make
	sure we pass the exception to imap_folder_selected(), otherwise
	failures can be lost.  See bug #31000.

2002-10-01  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (thaw): Add an assertion that the frozen count>0.
	(freeze): Same for >= 0.

	* camel-vee-folder.c (camel_vee_folder_remove_folder): Use the
	unmatched freeze_count when thawing folders removed from
	unmatched, rather than the folder's freeze_count.  Might be
	related to #27391.

2002-10-01  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (decode_internaldate): Use
	strtol when decoding the timezone (since it can be negative) and
	don't forget to increment inptr to the start of the time (ie,
	don't leave inptr pointing to the year when decoding the
	hour:min:sec).

2002-09-30  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #31456.

	* providers/imap/camel-imap-store.c (imap_connect_online): Don't
	LSUB "" "*", instead get both an LSUB containing the subfolders of
	the namespace and an LSUB of INBOX (assuming namespace was
	non-empty). This fix really has nothing to do with bug #31456 but
	is what should have been done in the first place.
	(parse_list_response_as_folder_info): Simplify a tad and strip
	extra leading /'s from fi->path.
	(imap_build_folder_info): Strip extra leading /'s from fi->path.

	* camel-store.c (camel_folder_info_build): Don't strip the
	namespace from the fi->full_name when hashing or creating fake
	parent folder-infos. Fixes a bug I found while trying to reproduce
	bug #31456.
	(camel_folder_info_build_path): Strip off extra leading dir_sep
	chars from the path.

2002-09-30  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (imap_get_message): Remove
	debug content_info_dump, could cause a crash, and not really
	needed anymore.

	* camel-folder-summary.c (camel_content_info_dump): Check ci->type
	!= NULL before dereferencing it.  Should fix crash #31331.

2002-09-27  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (decode_internaldate): New
	function to decode the INTERNALDATE response from an IMAP server
	so we don't have to use my broken-date-parser routines.

2002-09-27  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (connect_to_server):
	NULL-check the streams before unreffing them in the case of a
	failure during ssl negotiations.

	* camel-tcp-stream-ssl.c (camel_tcp_stream_ssl_enable_ssl): Check
	SSL_ResetHandshake() for errors. Also force a handshake after
	we've reset the handshake state on the socket.

2002-09-27  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (imap_update_summary): Use
	the summary's last uid as the one to fetch from, ignoring the
	cache.  Use strtoul instead of atoi as well.

	* providers/imap/camel-imap-store.c (get_folder_counts): If we
	have the folder open, and the unread count has changed, refresh
	it.  Should fix #30399 enough.  Also in non-check-all mode, if we
	have the folder open, use it anyway.

2002-09-26  Not Zed  <NotZed@Ximian.com>

	* tests/folder/test2.c (main): Treat spool as a local folder, so
	the ref checks work right.

	* providers/local/camel-spool-store.c (get_folder): Implement
	FOLDER_CREATE flag.
	(scan_dir): Dont free name on exception, its alloca'd.
	(scan_dir): If we start scanning from a file, just add that
	directly.
	(scan_dir): Allow empty files to also show up in folder list, as
	well as files starting with "From ".
	(get_folder): Use creat() instead of open() to create file.

	* providers/local/camel-spool-folder.c (camel_spool_folder_new):
	Check folder != NULL before writing to it.

	* providers/local/camel-local-store.c (create_folder): Handle a
	parent of NULL for creating top-level dirs.  Part of #31186.
	
	* providers/imap/camel-imap-store.c
	(parse_list_response_as_folder_info): Store the folder flags in
	the store summary.
	(get_one_folder_offline): Set the noselect url parameter if this
	is a noselect folder, from the stored summary flags.  #30877.

2002-09-23  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-charset.c (complete): Handle EILSEQ by eating
	bytes in the input buffer until conversion is successful. The old
	behaviour aborted when it got EILSEQ and just dumped the raw data.
	(filter): Same. Fixes bug #30873.

2002-09-24  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (mail_list_magic[]): Changed the Mailing-List
	rule to get the complete domain (* in wrong spot).  #31087.

	* camel-text-index.c (text_index_compress_nosync): If we have no
	data written to a key, dont add it, or its partition header.

2002-09-23  Not Zed  <NotZed@Ximian.com>

	* camel-block-file.c (sync_nolock): Mark root block dirty if we're
	going to sync it.
	(camel_key_file_finalise): de-count the active list if we close
	it.

	* camel-text-index.c (text_index_delete): Implement.
	(text_index_compress_nosync): Use index_delete when we're finished
	with the old one, so it is properly deactivated.

	* camel-index.c (camel_index_delete): Remove api call.  Mark index
	deleted in new state variable.
	(camel_index_*): Wrap all calls in check for deleted state.

2002-09-23  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder.c (transfer_message_to): If the original message is
	deleted, reset the deleted flag when we're done. Fixes bug #30876.

	* providers/imap/camel-imap-folder.c (add_message_from_data):
	Decode the INTERNALDATE if we've got one.
	(imap_update_summary): Instead of requesting a list of specific
	headers, request HEADER.FIELDS.NOT (RECEIVED) to reduce bandwidth
	usage even more.
	(parse_fetch_response): Change slightly to allow HEADER.FIELDS or
	HEADER.FIELDS.NOT so that we can make changes in
	imap_update_summary and not need to keep changing this function to
	match. Also parse an INTERNALDATE response.

2002-09-22  Dan Winship  <danw@ximian.com>

	* camel-mime-parser.c (folder_scan_drop_step): fix non-ANSI switch
	statement.

	* camel-service.c (service_getv): Likewise.

	* providers/imap/camel-imap-store.c (imap_getv): Likewise.

	* providers/pop3/camel-pop3-folder.c (cmd_builduid): Likewise.

2002-09-20  Not Zed  <NotZed@Ximian.com>

	* tests/misc/split.c: New regression test for word
	splitting/search input parsing code.

	* tests/folder/test9.c (main): Fix for filter_driver api change.

	* camel-search-private.c (camel_search_words_split): Handle "'s
	and \'s to escape characters.  For fat, lazy, slobs who dont like
	anything changing.

2002-09-19  Not Zed  <NotZed@Ximian.com>

	* camel-filter-search.c (camel_filter_search_match): Take new
	session arg.  Update callers.
	(symbols[]): changed get-source to header-source
	(header_source): Changed from get_source.  Now a boolean, returns
	true if source matches one of the arguments.  Uses the provider
	url comparison directly for accurate checking.  Makes 'filter on
	source' work.

	* camel-filter-driver.c (camel_filter_driver_new): Take new arg,
	session.
	(camel_filter_driver_finalise): Free session.

2002-09-19  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (parse_fetch_response): Don't
	increment the response pointer when deciding what type of header
	response we got, this screws up the string that we strdup into the
	part_spec string later. Also, instead of using the entire blob of
	HEADER.FIELDS that we get in the response, shorten it to just
	HEADER.FIELDS to use as the part_spec key.

2002-09-18  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (CAMEL_MESSAGE_INFO_HEADERS):
	Include MIME-VERSION and CONTENT-TYPE.

2002-09-18  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-command.c
	(camel_imap_command_response): If we get an ALERT, pass it to the
	user.  An rfc2060 MUST, and bug #22496.

2002-09-17  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (parse_fetch_response):
	Handle when the response is from a HEADER.FIELDS (if so, we don't
	want to cache the result).
	(imap_update_summary): Request specific headers when building the
	CamelMessageInfo's rather than fetching the full headers.

2002-09-13  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (process_header): If header_msgid_decode fails
	for the content-id field, just grab whatever is between the <>'s
	(yes, this means that the content-id is invalid - but what can ya
	do?). Addresses bug #21027.

2002-09-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_encode_string): Revert a patch that I
	had not meant to commit that was aimed at fixing bug #29234.

2002-09-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-store-summary.c (camel_store_summary_load): Same as
	below. Also save errno before closing the file so our caller can
	figure out why we failed.
	(camel_store_summary_save): Same here, but also flush the output
	stream to disk.

	* camel-folder-summary.c (camel_folder_summary_load): s/fclose(in)
	== -1/fclose(in) != 0/ since fclose doesn't necessarily return -1
	on fail, all we really know is that it returns 0 on success and
	non-zero on fail.

	* camel-certdb.c (camel_certdb_save): fsync() the stream after we
	fflush it.

	* camel-folder-summary.c (perform_content_info_save): Do proper
	error checking and return -1 on fail.
	(camel_folder_summary_save): Check the return of
	perform_content_info_save and a few other output calls within the
	message_info_save loop. If any of them fail, save errno, close the
	file, and return -1. If we finish the loop without fail, fflush
	the stream and then fsync (fflush only flushes user-space buffers,
	you still need to fsync afterward to flush the data to disk). If
	either fail, treat it as an exception by saving errno, closing the
	stream, and returning -1. I suspect that this also fixes bug
	#30150 because the old code would fclose if fflush or fclose
	failed in the check after the loop (man fclose(3) states that any
	further calls using the stream (even another call to fclose) will
	have undefined behaviour no matter what the first fclose call
	returned).

	* providers/local/camel-local-summary.c
	(camel_local_summary_init): Don't malloc a private struct of 0
	size.

	* providers/imap/camel-imap-folder.c
	(camel_imap_folder_fetch_data): Clear the exception even if we
	failed to get the message (part) from the imap-message-cache if we
	are online and able to try fetching it from the IMAP server.

2002-09-10  Not Zed  <NotZed@Ximian.com>

	* camel-data-cache.c (data_cache_expire): Remove the hash table
	entry using the right path.  Related to #29731.
	(camel_data_cache_remove): "

2002-09-09  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #4224

	* providers/imap/camel-imap-folder.c
	(camel_imap_folder_fetch_data): Pass ex into
	camel_imap_message_cache_get().

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_get): Now takes an exception and sets it
	on fail.
	(camel_imap_message_cache_copy): Updated to properly handle
	cache_get error conditions.

2002-09-04  Dan Winship  <danw@ximian.com>

	* camel-mime-utils.c (header_decode_date): Use e_mktime_utc.

	* camel-mime-message.c (camel_mime_message_set_date): Use
	e_localtime_with_offset.

	* broken-date-parser.c (decode_broken_date): Use e_mktime_utc.

2002-09-04  Not Zed  <NotZed@Ximian.com>

	* tests/folder/test4.c (main): clear nonfatal stuff.

	* tests/folder/test6.c (main): check inbox and 'another folder'
	because some servers do different things w/ inbox.

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_get): Dont try to open the directory
	instead of an empty "" uid.

	* providers/imap/camel-imap-folder.c (imap_get_message): we dont
	want to g_return_if_fail, we need to set an exception and always
	handle the case.
	(get_message_simple): Set an exception if we get a construct
	failure.
	(imap_refresh_info): if we're refreshing inbox, force a reselect.
	this is required for at least cyrus.  CHECK doesnt work either :(

	* tests/lib/folders.c (test_folder_basic): for non-local stores,
	the folder will have an extra ref for selection, take this into
	account when checking ref leaks.
	(test_folder_message_ops): Dont try to delete folder with messages
	in it, it works generally with imap.  also, change params so we
	can test different mailbox types.
	(test_folder_message_ops): disconnect remote services before
	finishing off.  doesn't need to stricly but makes ref count
	checking more accurate.
	(test_folder_message_ops): removed explicit remote sync, imap does
	it itself now ...

	* providers/imap/camel-imap-store.c:
	(camel_imap_store_finalize): call service_disconnect, so it isn't
	called later in the finalise chain, to properly cleanup on exit.

	* camel-mime-parser.c (folder_scan_content): If we fake the from
	eof file boundary, also make sure we say we matched nothing.  Also
	make the end case a little more robust to make sure we expired all
	hope of finding a sub-boundary.

	* providers/imap/camel-imap-store.c,
	providers/imap/camel-imap-folder.c: Lots of changes, too numerous
	to list.  Changed to use camel-imap-store-summary to cache list
	requests.  Changed to use a canonicalised url path with / instead
	of per-store directory separator.  Indirects folder name so
	invalid folder names can still be accessed.  Summary now stored in
	a new expandable format in .ev-store-summary.

2002-08-29  Not Zed  <NotZed@Ximian.com>

	* tests/folder/test3.c: Change the case sensitive search of
	subject to expect case insensitive results, as the behaviour has
	changed.
	(main): Made the search content before sync nonfatal.  its
	something that needs to be fixed but not practical concern in
	evolution.

	* camel-block-file.c (block_file_validate_root): Only spit out the
	invalid root warnings if the file isn't empty.

	* camel-text-index.c (text_index_compress_nosync): Swap the path
	as well when we compress.

	* camel-mime-parser.c (folder_scan_content): Treat the end of file
	as a boundary if we're scanning From lines, and drop the last \n.
	(folder_scan_init_with_fd): Dont pre-read from the fd, and init eof.
	(folder_scan_init_with_stream): Similar.
	(folder_read): Handle eof, and set eof on 0 read.
	(folder_seek): Dont pre-read after a seek, and reset eof flag.
	(camel_mime_parser_init_with_fd): Fix doco, no pre-read occurs
	anymore.
	(camel_mime_parser_init_with_stream): Same.

	* providers/local/camel-mbox-summary.c
	(camel_mbox_summary_sync_mbox): Add a \n to end of content of each
	message, not at start.

	* providers/local/camel-mbox-folder.c (mbox_append_message):
	Instead of appending "\nFrom " to a mailbox, start with "From ",
	and append a \n after the message always.  For better mutt/elm
	compatability.  Also, unlock after we've stat'd.
	(mbox_append_message): Set the message's from_pos exactly as the
	mbox size.

2002-08-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (stream_setsockopt): Fixed `set' to
	hold the correct value when setting the flags.

	* camel-tcp-stream-raw.c (stream_setsockopt): Fixed `set' to hold
	the correct value when setting the flags.

	* camel-mime-filter-tohtml.c (is_protocol): Match file: urls too.

2002-08-28  Not Zed  <NotZed@Ximian.com>

	* tests/folder/test8.c (test_add_message): Change message number
	to use hex, so its properly unique.
	(worker): Same here.

	* tests/misc/utf7.c: some utf7/utf8 tests.

	* providers/imap/camel-imap-utils.c (imap_mailbox_encode): Changed
	to use camel_utf8_utf7 code.
	(imap_mailbox_decode): As above, using camel_utf8_utf7.  'UTF-7'
	isn't a widely support iconv() codeset, and besides the new code
	is simpler.

	* camel-utf8.[ch]: robust utilities for working with utf8 and utf7.

2002-08-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-thread.c (camel_folder_thread_messages_new): Now
	takes a third argument to specify whether or not to group messages
	by subject when threading. It seems some people don't want this
	feature (see bug #22791 for details).
	(thread_summary): If thread_by_subject is enabled, group
	un-threaded messages by subject otherwise don't bother.

2002-08-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-command.c
	(camel_imap_response_free_without_processing): If the response is
	NULL, just return. (now works the same way as imap_response_free
	which allowed a NULL response argument). Fixes bug #25491.

2002-08-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c:

	* providers/imap/camel-imap-folder.c:

	* providers/imap/camel-imap-command.c: Lock the
	CamelService->priv->connect_lock instead of using our own
	command_lock. This fixes bug #28177.

2002-08-23  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): If we fail to
	send the EHLO/HELO command successfully, set transport->connected
	to FALSE when we close the tcp connection. Also updated to work on
	an IPv6 network.
	(smtp_connect): transport->authtypes can be NULL, so NULL-protect
	the call to g_hash_table_size() - this should fix a warning that
	was reported on the evolution@ximian.com mailing list.
	(smtp_set_exception): If the status message is multi-line, add a
	\n between lines.
	(connect_to_server): If we are going to ignore the EHLO/HELO error
	as if it were non-fatal, then we should clear the exception.

2002-08-22  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (imap_noop): If current_folder
	is not NULL and the summary for that folder is dirty, sync the
	flags rather than sending a NOOP.

	* providers/imap/camel-imap-utils.c (imap_parse_list_response):
	Workaround for Courier imap's brokeness when LSUBing the INBOX
	folder when it isn't subscribed to. Fixes bug #28929.

2002-08-21  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (connect_to_server): If
	imap_get_capability() fails, after unlocking the command_lock,
	disconnect the service.

2002-08-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-session.c (get_service): Don't register the noop timeout
	here anymore, we're gonna handle all this in the mailer now.
	(camel_session_register_timeout): Removed.
	(camel_session_remove_timeout): Removed.

2002-08-28  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (construct): Load store
	summary if it exists.
	(can_work_offline): Just see if we have any folders to say whether
	we can work offline or not.  Should probably always just return
	true.

2002-08-27  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store-summary.[ch]: New files to
	handle offline definition of folders, etc.

	* camel-url.h: Define CamelURL to be struct _CamelURL rather than
	anonymous struct.

	* camel-store-summary.[ch]: a few api tweaks.  Also, the summary
	header is versioned separately at each level, so that version
	upgrades can be handled separately.  Renamed FolderInfo ->
	StoreInfo to avoid namespace with current FolderInfo code.  This
	should be reversed when the FolderInfo code is rationalised to
	this new base.

2002-08-23  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-command.c (camel_imap_command): domt
	encode folder name.

	* providers/imap/camel-imap-folder.c (do_copy): dont encode folder
	name.
	(do_append): dont encode folder name.

	* providers/imap/camel-imap-store.c (get_folder_status): don
	encode folder name in imap request.
	(get_folder_online): here too for creating folder.
	(rename_folder): Assume the incoming 'new name' is a utf8 path,
	whereas the 'old name' is as from get folder info (raw).
	(create_folder): Dont encode parent_name, assume its the raw
	thing.

2002-08-22  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (get_folder_online): Select
	based on unconverted name.
	(imap_build_folder_info): New function to create a folderinfo
	properly based on raw name.
	(subscribe_folder): Use above helper.
	(imap_folder_effectively_unsubscribed): Same here.
	(imap_forget_folder): Same here.
	(get_one_folder_offline): "

2002-08-21  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c
	(parse_list_response_as_folder_info): Setup path properly, as
	decoded path with / separator.  Setup full_name as non-decoded raw
	name.  Keep url as decoded path but with server separator
	... (ick).
	(create_folder): Dont call build_path anymore, get_folders() does
	it for us.
	(subscribe_folder): Build the path ourself.
	(imap_folder_effectively_unsubscribed): Same here.
	(get_subscribed_folders): list using %S not %F, we're using the
	raw server provided name directly.
	(subscribe_folder): As above, for SUBSCRIBE.
	(unsubscribe_folder): Same here.
	(delete_folder): Same.
	(rename_folder_info): Same here for source name.
	(rename_folder): And here?
	(get_folders_online): Amd here.

	* providers/imap/camel-imap-utils.c:
	(imap_parse_list_response): Dont decode the mailbox.

	* camel-utf8.[ch]: some new utf8 & utf7 utilities.

	* providers/imap/camel-imap-utils.c (imap_mailbox_encode):
	(imap_mailbox_decode): use camel_utf7/8* functions instead.
	: Add config.h and alloca.h headers.

2002-08-20  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (imap_noop): Override the
	default noop implementation.

	* camel-store.c (camel_store_noop): New virtual method to ping a
	store.

	* camel-session.c (get_service): Register a timeout that calls
	camel_store_noop() every 10 minutes.

2002-08-19  Peter Williams  <peterw@ximian.com>

	Plug some large leaks in the indexing code.

	* camel-mime-filter-index.c (camel_mime_filter_index_set_index): Unref
	the old index if necessary.

	* camel-text-index.c (camel_text_index_get_type): Give it the correct
	parent type so that finalize handlers chain.
	(camel_text_index_name_get_type): Here too.
	(camel_text_index_cursor_get_type): Here too.
	(camel_text_index_key_cursor_get_type): Here too.

2002-08-20  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (get_folders): Don't let the
	minimum recursive depth be negative.
	(get_folders): Pass flags & CAMEL_FOLDER_INFO_SUBSCRIBED as the
	`lsub' argument to get_folders_online() otherwise we'll end up
	doing a LIST when we really wanted to do an LSUB.

	* camel-session.c: Set CAMEL_URL_NEED_PATH for the vFolder
	provider.

2002-08-19  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c: Changed the STOREINFO_VERSION
	- should fix bug #28571, but if it doesn't - oh well, I don't
	care. I'm considering it fixed no matter what.

	* camel-gpg-context.c (gpg_sign): If the diagnostics are empty,
	just explain that gpg failed to execute.
	(gpg_encrypt): Same.
	(gpg_decrypt): And here too.

	* tests/lib/camel-test.c (camel_test_init): Updated to pass the
	needed arguments to camel_init() and to init gthreads before camel
	(since camel expectes it to be initialised already).

	* tests/lib/session.c: #include <config.h> needed for
	ENABLE_THREADS so that sizeof (CamelSessionClass) gives the
	correct size.

	* tests/*: Updated to work with camel API changes.

2002-08-16  Dan Winship  <danw@ximian.com>

	* camel-session.c (get_service): If the passed-in URL contains a
	path, but the service doesn't allow paths, then the path part must
	be a folder name, and we should ignore it here. #29010

2002-08-16  Chris Toshok  <toshok@ximian.com>

	* camel-arg.h: remove the outer parens from the expansion of
	camel_argv_{start,end} since at least on freebsd va_end is
	#defined to be nothing, so (va_end(..)) causes a syntax error.

2002-08-16  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (get_folders): Fix the logic
	check for working out if we add inbox or not, we do it if we
	listed the namespace.

2002-08-15  Not Zed  <NotZed@Ximian.com>

	* camel-store.h (CamelFolderInfo): added a flags field, defined
	some flags, currently only used by imap.  This and below is first
	step to getting incremental folder tree loading.

	* providers/imap/camel-imap-store.c (get_subscribed_folders): If
	the subscribed list is empty, always add inbox.
	(imap_connect_offline): If the 'storeinfo' namespace isn't the
	same as our own (if its set), then ignore it, assume we changed
	settings.  Otherwise you can't change the namespace ...
	(get_folders): allow the env variable CAMEL_IMAP_MAX_DEPTH to
	override the default maximum recursion depth if 10 levels.
	(camel_imap_store_readline): Dont depend the log debug on d(x)
	being defined.
	(get_folder_info_online): changed to use new functions/names.

2002-08-14  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (get_subscribed_folders):
	Removed the by_hand sillyness.  Return an array instead.
	(get_folders): New method to get folders recursively without
	having to use '*'.  Uses '%', and stops if it gets too deep
	(current max of 10).
	(get_folder_counts): New method to fill out unread counts on
	folderinfo tree.
	(get_subscribed_folders): Fix some failure logic.

	* providers/imap/camel-imap-utils.[ch]: Changed IMAP_LIST_FLAGS to
	use the new CamelFolderInfoFlags directly.

2002-08-09  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (get_temp_uid): New function,
	generate a UID that has better chances of being unique.
	(imap_append_offline): Use it here.
	(imap_transfer_offline): And here.

2002-08-09 Peter Williams <peterw@ximian.com>
 
	* providers/imap/camel-imap-store.c
	(get_folder_info_online): Tweak how we build the tree based on whether
	a full tree or a subtree is being requested. Fixes subscribe dialog
	on UW servers.
	(get_one_folder_offline): Don't add folders that we're not subscribed
	to; fixes UW folders that weren't being marked as NoSelect because
	the storeinfo doesn't record that information.
	
2002-08-09  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_rename): When renaming our
	cache, add the "/folders" to the path.

2002-08-08  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (camel_imap_folder_init): Set
	some default permanent_flags. This is the other cause of bug
	#28038.
	(imap_refresh_info): After calling camel_imap_command() with a
	NULL format value (this is a shortcut to change the current_folder
	by SELECTing it), call camel_imap_folder_selected(). This may have
	been why permanent_flags never got set on the folder even after
	going online in bug #28038.
	(imap_update_summary): Same here. Also NULL-guard
	camel_imap_response_free().

2002-08-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_encode_param): Oops - outbuf pointed
	to alloca'd memory but we were g_free'ing it after using
	it. Instead use g_malloc for this outbuf buffer since it may be
	kinda large. Also don't depend on a single byte to nul-terminate
	the outbuf buffer so as to be safe with charsets such as UCS2 and
	UCS4, instead keep a pointer to the end of the buffer.

	* providers/imap/camel-imap-folder.c (parse_fetch_response): Only
	add the stream to the gdatalist if it is non-NULL.

2002-08-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): If writing to the sendmail pipe fails, wait
	for the sendmail process to exit before returning. Fixes bug
	#19636.

2002-08-06  Not Zed  <NotZed@Ximian.com>

	* providers/pop3/camel-pop3-folder.c (cmd_list): Add messageinfo
	to id table, and store array index in messageinfo too.
	(fi_to_index): Removed, use index member of messageinfo, fixed
	callers.
	(cmd_builduid): Parse the headers of the data, and ignore any
	status or x-status headers.
	(uid_to_fi): Removed, use the hashtable instead.
	(id_to_fi): Same.
	(cmd_uidl): Add messageinfo to uid table.
	(pop3_refresh_info): Setup hash tables, and fill out uid table for
	nonuid capable servers.
	(pop3_finalize): Destroy hash tables.  Only free resources if the
	uids table is not null (if finalised before we ran refresh info).
	(id_to_fi): Removed.  Use id hash table instead, fixed caller.

2002-08-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel.c (camel_init): Always set a g_atexit handler to
	flush/save the camel-certdb.

	* providers/imap/camel-imap-store.c (get_folder_info_online): If
	we are asking for the toplevel folders, use the IMAP store's
	namespace as the toplevel folder rather than an empty
	string. Fixes bug #28574.
	(imap_forget_folder): Rearrange the code so that name can never be
	used uninitialised.

	* providers/imap/camel-imap-utils.c (imap_namespace_concat):
	Removed.

2002-08-05  Dan Winship  <danw@ximian.com>

	* camel-folder-summary.h (CamelMessageFlags): Add
	CAMEL_MESSAGE_ANSWERED_ALL, for folders that can distinguish a
	reply-to-sender from a reply-to-all. (eg, Exchange)

	* providers/local/camel-local-folder.c (local_init): Add
	ANSWERED_ALL to permanent_flags too.

2002-08-02  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #26237.

	* providers/imap/camel-imap-command.c
	(imap_command_strdup_vprintf): Don't prepend any namespace shit in
	the %F case.

	* providers/imap/camel-imap-utils.c (imap_parse_list_response):
	Don't strip off the namespace.

2002-08-01  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-store.c (create_folder): If the folder
	name contains the directory separator, reject it.

2002-08-02  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-mbox-summary.c (mbox_summary_check): Clear
	the summary after building the 'removed uid' list.

	* camel-folder-summary.c (message_info_load): revert jeff's patch
	below, and do it slightly differently, and stop the auto-reformatting
	bullshit.

2002-08-02  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-summary.c (message_info_new): If
	we get a duplicate, just re-use the old info.
	(remove_summary): Add any removed to a change list.
	(maildir_summary_check): If we find new ones in 'cur' track them
	in the change list.  Removed FIXME about it.  For #18348.

2002-08-01  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (message_info_load): Do more error
	checking to prevent crashing if we fail to read a string for
	example.

2002-07-29  Peter Williams  <peterw@ximian.com>

	Fix bug #28238
	
	* providers/imap/camel-imap-store.c (imap_forget_folder): New
	function, breaking out the code in delete_folder() to handle when
	a folder is removed.
	(imap_folder_effectively_unsubscribed): New function, breaking out
	the code in unsubscribe_folder() to handle when a folder is
	unsubscribed.
	(imap_check_folder_still_extant): New function, check whether a
	folder exists by LIST'ing it.
	(imap_store_refresh_folders): Add code here to check if the folder
	still exists if we're unable to refresh its info. If so, pretend
	that it was unsubscribed (to get the mailer to remove it from 
	the tree) and delete its cache. If somehow this goofs up, the 
	worst that can happen is that we must redownload the headers.
	(get_folder_status): If we can't get the status, behave as above.
	(delete_folder): Call imap_forget_folder() where the bulk of this
	code has gone.
	(unsubscribe_folder): Call imap_folder_effectively_unsubscribed()
	where the bulk of this code has gone.

2002-07-31  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (parse_fetch_response):
	Disable my fix to not cache headers as it means that each time we
	load the message, we've got to re-fecth the headers.

	* camel-mime-filter-tohtml.c (is_addr_char): Don't use
	"isprint(c)" to mean "c >= 32 && c < 128" since it doesn't in most
	locales.
	(is_url_char): Same.
	(is_trailing_garbage): Same.
	(is_domain_name_char): New macro for dns-valid characters
	(email_address_extract): Use is_domain_name_char rather than
	is_addr_char for the part after the @.

2002-07-30  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream.c (camel_tcp_address_new): Update the comment.

	* camel-tcp-stream-raw.c (socket_connect): If building with IPv6
	support and the address is an IPv6 address, connect using a
	sockaddr_in6 otherwise use the standard IPv4 sockaddr_in
	structure.
	(stream_get_local_address): Fix to work with IPv6 addresses.
	(stream_get_remote_address): Same.

	* camel-tcp-stream-openssl.c (socket_connect): Same as above.
	(stream_get_local_address): Fix to work with IPv6 addresses.
	(stream_get_remote_address): Same.

	* camel-tcp-stream-ssl.c (stream_connect): If building with IPv6
	support and the address is an IPv6 address, initialise the
	PRNetAddr accordingly.
	(stream_get_local_address): Fix to work with IPv6 addresses.
	(stream_get_remote_address): Same.

2002-07-30  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (ssl_verify): X509_digest() needs a
	pointer to an int len. Also fixed some other compiler errors.

	* camel-certdb.h: #include <stdio.h>

2002-07-30  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-certdb.c: New source file implementing a very basic
	certificate database. This is mostly just here because the Mozilla
	NSS certdb seems to not be working for everyone's Evolution
	install (works fine for me and Ettore but not many other people).

	* camel-tcp-stream-ssl.c (ssl_bad_cert): If we have this
	certificate in our own CamelCertDB, then get the trust value from
	that and only prompt the user if the trust is unknown.

	* camel-tcp-stream-openssl.c (ssl_verify): Same.

	* camel.c (camel_init): Create our default certdb.

2002-07-30  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_transfer_offline): Use
	the same command-counter mojo that the append code uses in case
	the use tries to copy the same message to the folder repeatedly.

2002-07-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (unset_flag): New filter action to unset a
	system flag. The exact opposite of set_flag.

2002-07-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-store.c (get_folder): If the path
	exists and is a directory, return non-NULL. Missed this before
	which is how we could return NULL even on success. Oops.

2002-07-26  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-summary.c
	(camel_imap_summary_add_offline_uncached): The flags'n'tags
	copy was unnecessary. Removed it.

2002-07-25  Jeffrey Stedfast  <fejj@ximian.com>

	If we're gonna do an elite hack, lets do it right.

	* providers/local/camel-local-store.c (get_folder): On success,
	return non-NULL so that our caller doesn't have to depend on 'ex'
	being non-NULL in order to work correctly.

	* providers/local/camel-mbox-store.c (get_folder): Don't bother
	checking if an exception was set, just use the return value of
	camel-local-store's get_folder.

	* providers/local/camel-maildir-store.c (get_folder): Same as the
	mbox change.

	* providers/local/camel-mh-store.c (get_folder): Here too.

2002-07-25  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-summary.h
	(camel_imap_summary_add_offline_uncached): Prototype.

	* providers/imap/camel-imap-summary.c
	(camel_imap_summary_add_offline_uncached): New function to add an
	uncached message to the summary while offline.

	* providers/imap/camel-imap-store.c (imap_connect_online): Only
	refresh the folders if the disco diary is empty (ie, we're not
	resyncing.)

	* providers/imap/camel-imap-folder.c (imap_transfer_offline): Emit
	an event for the source if deleting its originals. Also, if we
	can't load the message, still process it, using the new imap
	summary function.

2002-07-25  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c: Remove "possibly
	non-fatal" exception strings, all exceptions are fatal unless
	their caller decides otherwise.
	(connect_to_server): If smtp_helo() fails due to us getting
	disconnected, treat the exception as fatal.
	(smtp_connect): Abort if smtp_helo() fails and we got
	disconnected.
	(smtp_send_to): If smtp_mail() fails, abort the send operation.
	(smtp_set_exception): If respbuf was NULL, then we got
	disconnected and so update our state accordingly.
	(smtp_disconnect): Only send a QUIT if we are still in the
	connected state (or, at least think we are).

2002-07-24  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c
	(imap_expunge_uids_resyncing): It would help to mark the UIDs as
	deleted before we try to expunge them
	(in the case when no other UIDs were marked deleted this didn't
	happen.)  Also fix an FMR.
	(imap_expunge_uids_offline): Trigger a folder_changed event with
	our own changeinfo because camel_imap_response_free won't be able
	to do that for us.

2002-07-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (do_shell): Renamed from
	shell_exec(). Also, we now want to pass argc/argv on to the
	CamelFilterDriverShellFunc.
	(camel_filter_driver_set_shell_func): Renamed a bit.

	* camel-filter-search.c (pipe_message): Renamed from shell_exec().

2002-07-25  Not Zed  <NotZed@Ximian.com>

	* camel-folder-summary.c (camel_folder_summary_save): When writing
	the summary, use TRUNC flag, duh.  Also, write to a temp file
	first, and rename when closed successfully, and check ferror() and
	fclose() against 0 rather than -1.

	* providers/local/camel-mbox-summary.c (summary_update): Decrement
	i if we remove the summary item so we dont skip every 2nd one.

	* camel-mime-utils.c (header_decode_mailbox): Use
	rfc2047_decode_word explicitly incase we just found an encoded
	word.  Stops us re-decoding the string twice, which fixes memory
	corruption in #26330 when the HUGE string is used later.

2002-07-24  Not Zed  <NotZed@Ximian.com>

	* camel-partition-table.c (camel_key_table_next): Didn't unlock if
	we exited on an empty key list.

	* providers/imap/camel-imap-folder.c (imap_expunge_uids_online):
	Sync before doing an expunge if we dont have uidplus.  See #25766.
	(imap_expunge_uids_resyncing): Same here.

	* providers/imap/camel-imap-store.c (get_folder_info_online):
	Duplicated the very much hack in imap_store_refresh_folders() to
	avoid a deadlock in #27959.  A decent fix has to wait for a
	rewrite.
	(get_folder_online): Move folders to a subdirectory of
	storage_path, rather than in it.  Bye bye everyones settings.  See
	24947.
	(get_folder_offline): And here too.
	(delete_folder): And here too.
	(rename_folder): and here too.
	(get_folder_info_offline): And here too.  I love code reuse.

2002-07-23  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream.c: #include <string.h> for memcpy.

2002-07-22  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (vee_set_message_user_tag): Oops, forgot to
	implement this.  Fixes #24604.

2002-07-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-crlf.c (filter): Only add a \r if the
	character before the \n wasn't already a \r - this covers for when
	people add DOS files as attachments. Fixes bug #28056.

2002-07-19  Not Zed  <NotZed@Ximian.com>

	* camel-mime-part-utils.c (convert_buffer): Changed to use a
	different length calculator.

2002-07-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-lock.c: Add the appropriate #include for the _() macro.

2002-07-17  Not Zed  <NotZed@Ximian.com>

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate): Got
	rid of the stupid "tryagain" semantics, which didn't work.
	(pop3_connect): Fixed here to only retry under proper conditions.

2002-07-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-canon.c (filter): When CRLF encoding, "empty"
	(after stripping trailing whitespace characters) lines need to end
	in CRLF also, not just lines with data in them.

2002-07-16  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_sync_online): Clean
	up some improper usage of CamelExceptions (looking at
	camel_exception_is_set when ex = NULL).

	* providers/imap/camel-imap-store.c (get_folder_online): Here too.

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_new): Nothing sets the exception so
	don't bother to check it at the end of this function. Prevents
	a warning about checking a NULL exception's value.

2002-07-16  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Make the
	standard AUTH format take priority over the AUTH= priority, since
	sometimes servers only list a subset of the supported authtypes in
	the AUTH= response while they list all authtypes in the standard
	AUTH response. Fixes "bug" #27841.

2002-07-15  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_get_message): If we're
	not online and the message isn't in our cache, give up.

2002-07-15  Not Zed  <NotZed@Ximian.com>

	* camel-filter-search.c (get_label): Removed.
	(get_score): Removed.  Labels & scores are stored in tags, we
	already have a function to get tags.
	(user_tag): Fail if we dont get valid arguments, it must be a
	string type.
	(system_flag): Same here.

2002-07-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_msgid_generate): Try to get the FQDN
	from the results of gethostname(). If that fails, then fall back
	to the results gotten from gethostname() or if that fails just use
	"localhost.localdomain". Addresses bug #17416.
	(header_decode_param): Protect against a NULL value.

	* providers/smtp/camel-smtp-transport.c (smtp_data): Get rid of
	the constant 'required' variable, just use the value when calling
	set_best_encoding.

	* providers/local/camel-local-provider.c: Changed the mbox and
	spool provider descriptions to try and be more clear. I'm not sure
	I like the mention of Evolution in the mbox provider description,
	but there was no other way to make it clear that it MOVED mail out
	of the mbox folder into a folder managed by Evolution without
	mentioning Evolution. *sigh* Anyways, to me "retrieve" means move,
	but apparently this isn't clear to the weak minded.

2002-07-15  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_rescan): >= is not
	appropriate here because the sequences are 1-based; so seq =
	summary_len is valid.  Hopefully addresses 15646, because this
	caused the last message in a folder to be reloaded, replacing its
	CamelMessageInfo, and the tree view was using the old
	CamelMessageInfo.

2002-07-13  Not Zed  <NotZed@Ximian.com>

	* camel-folder-summary.c
	(camel_folder_summary_info_new_from_message): Only assign a uid if
	indexing is enabled.  This stops us always assigning a uid in the
	imap folder and disco folder?

	* providers/imap/camel-imap-folder.c (imap_update_summary): Also
	check the uid is set at all, another bit of a fix for #15667.

2002-07-09  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (imap_update_summary): Check
	for existing messages of the same uid before doing anything.  If
	it exists, do nothing (perhaps it should merge?).  A dirty hack for
	#15667.

2002-07-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart-encrypted.c (camel_multipart_encrypted_decrypt):
	On error, do not unref the parts gotten using
	camel_multipart_get_part() since that function does not ref the
	parts. Also don't forget to reset the decrypted stream before
	trying to parse it ;-)

2002-07-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart.c (camel_multipart_class_init): Updated to not
	use camel_type_get_global_classfuncs() since this is just a cast
	macro now.

	* providers/imap/camel-imap-folder.c (get_content): Handle
	multipart/encrypted parts too.

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Handle
	multipart/encrypted types too.

2002-07-11  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_data): Don't let any
	parts have a binary encoding.

2002-07-11  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #27672

	* camel-mime-filter-bestenc.c: Conditionally #include <config.h>

	* camel-mime-filter-linewrap.c: Same here... although we could
	probably just get rid of this filter? We don't seem to use it
	anywhere since we try to QP/Base64 encode any text parts with long
	lines. Besides, we couldn't use this filter for SMTP anyway since
	we can't risk possibly linewrapping a binary mime part. I dunno,
	maybe this could be useful in the composer though? *shrug*

	* providers/smtp/camel-smtp-transport.c (smtp_data): Always call
	camel_mime_message_set_best_encoding() even if the server allows
	8BITMIME and even if we don't have any 8bit parts because we may
	have parts with long lines (>998 octets) which also need to be
	encoded.

	* camel-mime-message.c (check_8bit): Don't forget to check for the
	binary encoding here as well.

2002-07-11  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (parse_fetch_response): If we
	are fetching HEADERs, don't cache the stream - instead just create
	a mem-stream and return that. This reduces a significant amount of
	overhead due to disk i/o.

	* camel-multipart-encrypted.c (camel_multipart_encrypted_decrypt):
	Don't forget to set an appropriate exception before returning
	NULL.

2002-07-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (get_message_cb): Make sure message is
	non-NULL before setting the source on it.

	* camel-gpg-context.c: Renamed stdin to stdin_fd, stdout to
	stdout_fd, and stderr to stderr_fd in struct _GpgCtx since
	Solaris' stdin/stdout/etderr variables seem to be macros and are
	thus breaking the compilation.

2002-07-04  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/nntp/camel-nntp-provider.c: Set the IS_SOURCE provider
	flag.

	* providers/pop3/camel-pop3-store.c: Change all exceptions to
	report which POP server failed (and tried to make a few of the
	exceptions a bit more clear).

2002-07-03  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (vee_sync): If we get an exception from the
	child sync, update the exception string so we know where it really
	was.

	* camel-vee-store.c (change_folder): Util to emit created/deleted
	events.
	(vee_get_folder): If the folder has path elements, and its parents
	dont exist, create dummy no-select nodes.  This is for bug #4246.
	(vee_delete_folder): Use change_folder() to save code.

	* providers/local/camel-mbox-folder.c (mbox_set_message_flags):
	Only set xevchange if we're storing status headers in pine format,
	so we dont do a full sync every time any flag changes.

2002-06-27  Not Zed  <NotZed@Ximian.com>

	* camel-object.c (camel_object_hook_event): Take a void object arg.
	(camel_object_remove_event): "
	(camel_object_unhook_event): "
	(camel_object_trigger_event): ", also, execute events in the same
	order they were added, i.e. reverse hook-list order.

2002-06-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_get_argv): Don't use
	--no-auto-key-retrieve, this option has apparently been deprecated
	in gpg 1.0.7.

2002-06-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_op_step): Loop on our reads while
	errno is EINTR or EAGAIN. Also make sure to completely read stdout
	and stderr by keeping better state.
	(gpg_ctx_parse_status): In the case of a NODATA response from gpg,
	try to use the diagnostics that gpg may have written to its
	stderr.
	(gpg_verify): Check that the gpg process has not exited.
	(gpg_ctx_op_wait): Make sure we haven't already exited (as by
	gpg_ctx_op_is_exited()) and if we have, retrieve the exit status
	from the gpg context.

2002-06-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.[c,h]: Removed.

	* camel-pgp-mime.c (pgp_mime_part_sign_restore_part): Removed.
	(pgp_mime_part_sign_prepare_part): Removed.
	(camel_pgp_mime_part_sign): Removed.
	(camel_pgp_mime_part_verify): Removed.
	(camel_pgp_mime_part_encrypt): Removed.
	(camel_pgp_mime_part_decrypt): Removed.
	(camel_pgp_mime_is_rfc2015_signed): Documented.
	(camel_pgp_mime_is_rfc2015_encrypted): Same.

2002-06-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart-encrypted.c (camel_multipart_encrypted_encrypt):
	Oops, this needs to take a userid argument.

	* camel-gpg-context.c (gpg_clearsign): Removed (never did anything
	anyway).

	* camel-pgp-context.c (pgp_clearsign): Removed.

	* camel-cipher-context.c (camel_cipher_clearsign): Removed unused
	method.

	* camel-multipart-encrypted.[c,h]: New class implementing the
	multipart/encrypted content type. Contains methods for encrypting
	and decrypting a multipart/encrypted MIME object.

	* camel-gpg-context.c (gpg_ctx_parse_status): Check for NODATA
	too.

2002-06-25  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-provider.c: Remove the #include for
	camel-spoold-store.h

2002-06-26  Not Zed  <NotZed@Ximian.com>

	* camel-gpg-context.c: Include <sys/time.h> for struct timeval.

	* providers/local/camel-local-provider.c
	(camel_provider_module_init): Removed spoold provider.  The spool
	provider does it now.
	(): Spoold doesn't exist anymore, remove its header.

2002-06-25  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-folder.c (camel_spool_folder_new):
	Support a new xstatus option - folders update/honour the
	Status/X-Status headers in addition to X-Evolution.

	* providers/local/camel-local-summary.c
	(camel_local_summary_write_headers): If supplied with an
	additional status or xstatus arg, write a Status header and/or
	X-Status.  Also fix the case of properly terminating the headers
	if an xev line isn't supplied.

	* providers/local/Makefile.am (libcamellocalinclude_HEADERS,SOURCES):
	Removed spoold-store.[ch].

	* providers/local/camel-local-provider.c
	(camel_provider_module_init): For the spoold type, just use the
	spool store instead.

	* providers/local/camel-spool-store.h: Added a type field, so the
	1 store can implement different types without having to subclass.

	* providers/local/camel-spool-store.c
	(camel_spool_store_get_toplevel_dir): Removed, inherits from local
	store now.
	(construct): If we're pointing to a file, treat it as mbox mode,
	otherwise treat it as 'elm' mode.
	(get_folder): Only test for INBOX in mbox mode.
	(get_folder_info_elm): 
	(get_folder_info_mbox): Two alternatives for getting folder info,
	depending on the type of folder we're looking at.
	(get_folder_info_mbox): Make the url include the protocol.
	(scan_dir): "

	* providers/local/camel-spoold-store.c
	(camel_spoold_store_get_toplevel_dir): Removed, inherits from
	local store now.

	* camel-folder.c (get_message_user_tag): Dont use a
	g_return_if_fail for info==NULL.  This is not an error.
	(set_message_user_tag): And same here.
	(set_message_user_flag): Sigh, and here.
	(get_message_user_flag): And here.
	(set_message_flags): and here ...
	(get_message_flags): Dum de dum, de done at last.

	* providers/local/camel-mbox-folder.c (mbox_get_message): Check
	for new messages whenever we retrieve one.  In the common
	no-update case, this is a single stat.
	(mbox_get_message): If we need to rescan, then force a full rescan
	to make sure it does the right thing.
	(mbox_get_message): Cleanup the exception handling a bit, if we do
	get an error, propagate any folder changes anyway as well.
	(mbox_set_message_user_flag): Argh more of these stupid g_returns
	taht shouldn't be.
	(mbox_set_message_user_tag): Here too.
	(mbox_set_message_flags): If the read flag is being changed, mark
	it as an xevchange (i.e. Status line change).

	* providers/local/camel-mbox-summary.c (summary_rebuild): Merged
	into summary_update.
	(summary_update): Changed to allow it to update existing lists of
	messages without clearing out the summary.
	(mbox_summary_check): Dont clear the summary, just re-scan.
	(message_info_new): Attempt to support the 'Status: RO' elm/pine
	thing.
	(camel_mbox_summary_encode_status): 
	(camel_mbox_summary_decode_status): Util functions for
	creating/parsing the Status line.
	(camel_mbox_summary_sync_mbox): Write out the status line if we're
	going to try support it.
	(camel_mbox_summary_xstatus): Implement option to control
	read/write of (x-)status.
	(message_info_new): Do x-status stuff based on run-time option.
	(camel_mbox_summary_sync_mbox): "
	(mbox_summary_add): If x-status enabled, then always add
	status/x-status headers to message.

	* camel-folder-summary.c (summary_assign_uid): If the messageinfo
	is already in the summary, AND is the same messageinfo, dont do
	anything, return a value to indicate this.
	(camel_folder_summary_add): Do nothing if this info already in the
	summary, so we can perform updates.

2002-06-24  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-summary.c
	(camel_local_summary_check_force): New method to force the next
	summary check to be a full check, set if a mismatch occurs.

	* camel-folder-summary.c (camel_folder_summary_load): If we have
	no summary path set, dont do any i/o, rather than abort.
	(camel_folder_summary_save): "
	(camel_folder_summary_header_load): "

	* providers/local/camel-spool-store.h: Inherit from camel mbox
	store, even if we override almost everything.

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): If the base path points to a file,
	use that as the folder path as well.

	* providers/local/camel-spool-folder.h: Inherit from
	camel-mbox-folder.

	* providers/local/camel-spool-summary.c (spool_summary_sync_full):
	Use camel_mbox_summary_sync_mbox to do most of the work.

	* providers/local/camel-spool-summary.[ch]: Make spool-summary
	inherit from mbox summary rather than foldersummary.

	* providers/local/camel-mbox-summary.c (mbox_summary_sync): Make
	sync_full/quick virtual methods.
	(camel_mbox_summary_sync_mbox): The full sync method put into a
	simple function that sync's from fd to fd.
	(mbox_summary_sync_full): Use summary_sync_mbox to do the real
	work.
	(mbox_summary_check): Create removed events if the folder gets
	cleared.  Also, dont clear the summary before a rebuild, try to
	merge.

2002-06-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c: #include <sys/time.h>

2002-06-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_hash_str): Return the option as
	--digest-algo=<micalg>
	(gpg_ctx_parse_status): Decode more status information and keep
	track of trust and such.
	(gpg_ctx_op_complete): Make sure we aren't waiting for gpg to
	write data to stdout (such as encrypted/decrypted data or a
	signature).
	(gpg_encrypt): Remove the fejj@stampede.org hard-coded value
	(which had only meant to be for testing).

2002-06-24  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_get_argv): Use --command-fd rather
	than --passphrase-fd since what we really want is an interactive
	mode (besides, --passphrase-fd requires a passphrase to be sent
	before --status-fd will send a NEED_PASSPHRASE status message).
	(gpg_ctx_parse_status): When we encounter a BAD_PASSPHRASE, tell
	the session to uncache it.
	(camel_gpg_context_set_always_trust): Implemented.

2002-06-23  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_ctx_parse_status): Check for ERRSIG
	also.
	(gpg_ctx_op_step): Don't try writing a passphrase unless our
	operation requires it.

2002-06-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.c (gpg_encrypt): Return -1 on error.
	(gpg_decrypt): Same.
	(gpg_sign): Again here.
	(gpg_ctx_op_step): Only attenmpt to read from the status-fd if we
	are not already 'complete'.

	* camel-pgp-mime.c (camel_pgp_mime_part_encrypt): Flush the
	filtered stream.

2002-06-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-gpg-context.[c,h]: New source files implementing the
	CamelCipherContext class for gnupg.

	* camel-pgp-context.c (camel_pgp_context_new): Return a
	CamelCipherContext.

	* camel-pgp-mime.c (camel_pgp_mime_part_decrypt): Take a
	CamelCipherContext argument rather than a CamelPgpContext since we
	now have a CamelGpgContext also.
	(camel_pgp_mime_part_encrypt): Same.
	(camel_pgp_mime_part_verify): Same.
	(camel_pgp_mime_part_sign): Same.

2002-06-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-folder.c: Updated to support searching as well as
	making it use CamelDigestSummary.

	* camel-digest-summary.[c,h]: New class to handle the summary for
	CamelDigestFolder.

	* camel-tcp-stream-ssl.c (set_errno): PR_IO_TIMEOUT_ERROR should
	map to ETIMEDOUT and not EAGAIN.
	(stream_connect): Reset the PR_Poll() timeout back to 2 minutes as
	this wasn't the problem afterall.

2002-06-19  Not Zed  <NotZed@Ximian.com>

	* camel-mime-parser.c (folder_scan_drop_step): Drop back to
	initial state if we came from eof state.

2002-06-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (stream_connect): Set the poll timeout to
	be PR_INTERVAL_MIN, this one shouldn't need to be 2 minutes (plus
	it blocks my connection at home for far too long).

	* providers/imap/camel-imap-folder.c (imap_refresh_info): Make
	sure we hold the command_lock before accessing current_folder.
	(imap_append_online): Same.
	(imap_transfer_online): Same.

	* providers/imap/camel-imap-store.c (delete_folder): We need to
	hold the command_lock before we can set the current_folder to
	NULL.
	(rename_folder): Same.
	(get_folder_info_online): We need to make sure we hold the
	command_lock in order to use current_folder.
	(everywhere): Same.

2002-06-19  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_connect): Don't
	bother trying to authenticate (and thus don't throw up an error
	dialog) unless the server is an ESMTP server and supports
	authentication.

	* camel-sasl-plain.c: Change the user-friendly name to PLAIN, this
	is what it should be. Not "Password" because user's immediately
	think that they need authentication when they see "Password" even
	if they don't need it at all.

2002-06-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-vee-folder.c (camel_vee_folder_add_folder): Update the
	freeze state of the new source folder.
	(camel_vee_folder_remove_folder): Undo any freeze state that we
	have imposed on this source folder.

2002-06-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-vee-folder.c (vee_freeze): Freeze source folders.
	(vee_thaw): Thaw all source folders. Fixes bug #24317.

	* providers/imap/camel-imap-folder.c (imap_sync_online): Unlock
	the command_lock after each UID STORE command so that other
	(probably more important) threads can send their requests.

	* camel-arg.c:
	* camel-disco-diary.c:
	* camel-index-control.c:
	* camel-mime-part.c:
	* camel-pgp-mime.c:
	* camel-store.c:
	* camel-tcp-stream-ssl.c:
	* camel-text-index.c: Fixed compiler warnings.

	* camel-multipart-signed.c: Updated to use ctx->sign_protocol
	rather than ctx->protocol.

	* camel-cipher-context.h: Add an ecnryption protocol member.

	* camel-pgp-context.c (camel_pgp_context_init): Set the encryption
	protocol.

2002-06-11  Not Zed  <NotZed@Ximian.com>

	* camel-vtrash-folder.c (camel_vtrash_folder_class_init): Our
	parent class is camel_vee_folder, not camel_folder, fix setting of
	parent folder (unused anyway, but removes a run-time warning).

2002-06-07  Not Zed  <NotZed@Ximian.com>

	* camel-pgp-context.c (camel_pgp_context_init): Duh!  The protocol
	is application/pgp-signature.  TODO: need to have a signed and an
	encrypted protocol specified separately.

2002-06-06  Not Zed  <NotZed@Ximian.com>

	* camel-folder-thread.c (thread_summary): Do the work here.
	(camel_folder_thread_messages_remove): Implement.  Remove some
	uid's from the tree.   Disalbe from build, for now.
	(remove_uid_node_rec): Actually do the work.
	(camel_folder_thread_messages_add): Implement.  Add some summary
	items to the tree.  Disable from build though.
	(camel_folder_thread_messages_apply): Make a thread tree built
	using camel_folder_thread_new() map to a new set of uids,
	preserving some order.  Meant primarily to manage deleted + added
	uids in a user-friendly manner.

2002-06-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart-signed.c (camel_multipart_signed_verify): Use
	CAMEL_EXCEPTION_SYSTEM rather than '1' for clarity.

2002-06-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (stream_connect): Up the timeout on the
	connect code to 2 minutes.

2002-06-05  Dan Winship  <danw@ximian.com>

	* camel-mime-utils.c (header_decode_mailbox): Parse
	"From: Dan Winship <danw>" (with no domain) in the way the sender
	meant it, even though it's completely wrong.

2002-06-04  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-provider.c: Remove the
	CONF_DEFAULT_PATH entry, as this is handled by the url config
	stuff.  This made it basically impossible to configure any local
	folder from the gui.

	* providers/local/camel-local-folder.c (local_refresh_info): Force
	a refresh.  Should work for all local folders to force them to
	refresh.

	* providers/local/camel-maildir-folder.c (maildir_refresh_info):
	Removed, moved into camel-local-folder.

	* providers/local/camel-mh-summary.c (mh_summary_next_uid_string):
	Once we assign or get a uid, tell the summary of this, so the next
	uid we get will be higher than any previously.

	* camel-object.c (camel_object_ref, camel_object_unref): I got
	sick of casting, these now take void * like they should, and
	perform their own run-time type checking.

	* providers/local/camel-mh-store.c (recursive_scan): Changed to
	use stat, not lstat (*shrug* maybe someone wants to softlink their
	maildir tree?).
	(inode_hash):
	(inode_equal):
	(inode_free): Copied from camel-maildir store (should put into
	camel-local-store or utils?).
	(recursive_scan): Changed to check for re-visiting inodes.  Also,
	it builds the tree itself, rather than using folder_info_build.
	(add_folder): Changed to folder_info_new.
	(recursive_scan): Properly honour the recursive flag.  Also,
	lookup unread count from folder.
	(folder_info_new): Init unread message count to -1, since we dont
	know yet.
	(folder_info_new): Take the name as an argument, and perform the
	merging here.
	(folders_update): Util func to add/remove folders from .folders
	file.  I'm assuming its sorted.
	(get_folder): Add the folder to .folders if we created a new one,
	and if it exists.
	(delete_folder): Remove from .folders, etc.
	(folders_scan): If we have a .folders file, read and use that
	instead.
	(recursive_scan): Handle scanning from a particular directory
	properly.
	(rename_folder): Implement so we can track any changes to the
	.folders file if its turned on.

	** Applied patch below from Greg Hudson.
	
2002-05-10  Greg Hudson  <ghudson@mit.edu>

	* camel-mh-store.c (get_inbox, get_folder_info, recursive_scan,
	add_folder): Implement support for MH stores.

	* camel-mh-summary.c (mh_summary_check, sort_uid_cmp): Sort MH
	messages by message number (uid), like we sort maildir messages by
	date.

	* camel-local-provider.c (mh_provider): Turn on source and store
	flags.

2002-06-03  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (camel_vee_folder_add_folder):
	(folder_changed_change):
	(folder_changed_remove_uid):
	(folder_changed_add_uid):
	(vee_folder_build_folder): Check that any unmatched operation is
	not concerning any vfolder.  Other vfolders should never be part of any
	unmatched handling.  For #24615, and others probably.

2002-06-02  Not Zed  <NotZed@Ximian.com>

	* camel-sasl.c (camel_sasl_new): 
	(camel_sasl_finalize): setup/free the mech string.

	* camel-sasl.h: Added 'mech' mechanism string.

2002-06-01  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (imap_getv): Implement.  Only
	the object_description arg.
	(camel_imap_folder_get_type): Init parent_class holder.

	* providers/local/camel-local-folder.c (local_getv): Implement,
	object_description arg.

	* camel-folder.c (folder_getv): Implement, add a bunch of args you
	can get -> camel_folder_get_unread_count etc will be going RSN i
	hope.
	(camel_folder_finalize): Free cached description string.

	* camel-object.c (cobject_getv): Implement
	CAMEL_OBJECT_ARG_DESCRIPTION, just return the classname of the
	object.
	(camel_object_getv): 
	(camel_object_get): 
	(camel_object_setv): 
	(camel_object_set): Take object = void *, to simplify usage.
	(camel_object_setv): Removed unecessary locals.
	(camel_object_getv): Same.
	(camel_object_free): New method, free an arg, upto implementations
	whether args are static/const or not.
	(cobject_free): Implement a dummy do nothing free.

2002-05-31  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (camel_vee_folder_get_location): new function
	to get the real location (folder) (and uid) of a vfolder object.
	Using the folderinfo, since we already have it, maybe it should
	use the uid.

2002-05-31  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (get_content): When the part
	is a multipart/signed, make sure to free the part_spec before
	returning (the other types already did this properly).

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_get): Free the path buffer when we're
	done with it.

	* providers/imap/camel-imap-folder.c (imap_update_summary): Free
	the final tagged response buffer.

	* providers/imap/camel-imap-command.c (imap_read_untagged): If we
	fail to read a literal, free the temporary string buffer.

	* providers/imap/camel-imap-folder.c (imap_rescan): Revert my fix
	from the other day since camel_imap_command_response() doesn't
	guarentee that resp will be set to NULL on error.

	* camel-data-cache.c (camel_data_cache_get): If we fail to be able
	to create a stream to insert into the cache, then free the 'real'
	path.

2002-05-30  Not Zed  <NotZed@Ximian.com>

	* camel-cipher-context.h: Added a protocol field for users to use.

	* camel-stream-filter.c (do_read): Sigh, the pre-size is READ_PAD
	not READ_SIZE.  Big difference.
	(READ_PAD): Bumped upto 128 from 64, so we can fit a typical line
	in full.

	* providers/imap/camel-imap-folder.c (get_content): Changed to
	load multipart/signed as an opaque block into the right kind of
	object.

	* camel-multipart.h (struct _CamelMultipart): Removed the boundary
	field.  It wans't actually used anywhere.

	* camel-seekable-substream.c
	(camel_seekable_substream_new_with_seekable_stream_and_bounds):
	Shortened this stupidly long name to just :new(), its the only way
	its ever used.  Fixed all callers.

	* camel-multipart-signed.[ch]: new wrapper for multipart/signed
	types.  We need to treat the entire content as a blob of data for
	transport purposes.  This also cleans up a lot of the sign/verify
	handling.

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Just call
	camel_multipart_construct_from_parser for multipart parts, also
	use a multipart_signed for multipart/signed types.

	* camel-multipart.c (camel_multipart_construct_from_parser): New
	virtual function for multiparts to buld themselves.
	(construct_from_parser): Implement for normal multiparts.
	(toplevel): Got rid of a warning, it'll never be an abstract
	class.

	* camel-pgp-context.c (pgp_hash_to_id): 
	(pgp_id_to_hash): Implement.
	(camel_pgp_context_init): Init the pgp protocol specifier.

	* camel-cipher-context.c (camel_cipher_id_to_hash): 
	(camel_cipher_hash_to_id): Util virtual methods to handle the
	cipher id string.

	* camel-mime-filter-canon.[ch]: A new filter, end/start of line
	canonicalisation filter.  Can escape "From " and strip trailing
	whitespace, and canonicalise the end of line to crlf or to lf.

2002-05-29  Not Zed  <NotZed@Ximian.com>

	* camel-multipart.h (struct _CamelMultipart): Removed the
	'parent', nothing used it, anywhere.  Cleaned up some formatting
	slightly.

2002-05-30  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (camel_imap_store_readline):
	On error, don't leak the GByteArray buffer.

	* providers/imap/camel-imap-folder.c (imap_rescan): Free the
	response before checking for errors. I'm not sure this'll actually
	fix the memory leak here, but it might? Certainly can't hurt.

	* camel-block-file.c (camel_block_file_finalise): Destroy the
	blocks hash table.

2002-05-29  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (connect_to_server): Only free
	the LOGOUT response if it is non-NULL.

2002-05-28  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-folder.c (maildir_refresh_info):
	Implement.  Run a summary check to update for any newly arrived
	messages.

	* providers/local/camel-maildir-store.c (scan_dir): If we have a
	folder, execute a refresh_info on it, to suck in any new stuff.

2002-05-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_log): Use the
	CamelMessageInfo rather than the CamelMimeMessage because the
	message may not have been loaded (thus NULL).

2002-05-27  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (connect_to_server): On
	connection failure, unref the tcp stream.

	* providers/pop3/camel-pop3-store.c (connect_to_server): On
	connection failure, unref the tcp stream.

	* providers/imap/camel-imap-store.c (connect_to_server): On
	connection failure, unref the tcp stream.

	* providers/nntp/camel-nntp-store.c (nntp_store_query_auth_types):
	Our parent class is no longer CamelRemoteStore.
	(nntp_store_init): Same.
	(camel_nntp_store_get_type): Here too.
	(nntp_connect): Rewritten to try to connect via SSL. Also remove
	code using CamelRemoteStore.
	(camel_nntp_command): Don't call camel_remote_store_connected().

2002-05-24  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (content_info_get_part_spec):
	Helps if we allocate enough space here. Also, start smoking the
	same purple flavoured IMAP crack when counting parts (parts don't
	count if their parent part is a message/* part with a parent
	part). Fixes bug #25260.

2002-05-24  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-command.c (imap_read_untagged): Use
	the new readline function.

	* providers/imap/camel-imap-store.c (connect_to_server): Use the
	new camel_imap_store_readline() function which doesn't suck quite
	as bad as the original camel_remote_store_recv_line() function.
	(camel_imap_store_readline): New function to replace
	camel_remote_store_recv_line(). This function is at least safe
	with embedded nul chars. Not that any of our callers use it
	*sigh*.

2002-05-24  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (connect_to_server): Added
	some NULL protection fixes.

2002-05-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-remote-store.c: Removed from the build. Glory glory
	hallelujah.

	* camel-disco-store.c: Updated to inherit from
	CamelStore rather than CamelRemoteStore.

	* providers/imap/camel-imap-command.c (imap_command_start): Don't
	use the camel-remote-store shit to send a string. Just use
	camel_stream_printf for chrissakes.

	* providers/imap/camel-imap-store.c: Updated to not depend on
	CamelRemoteStore and to handle STARTTLS.
	(imap_disconnect_online): Unref the streams.
	(imap_keepalive): Removed.
	(camel_imap_store_connected): New function to replace
	camel_remote_store_connected().
	(camel_imap_store_finalize): Unref the streams.
	(camel_imap_store_recv_line): New function to replace
	camel_remote_store_recv_line().
	(imap_get_capability): Renamed from connect_to_server
	(connect_to_server): New function to try and connect to the
	server.
	(connect_to_server_wrapper): New wrapper function around
	connect_to_server that takes the ssl modes into consideration.
	(query_auth_types): Don't bother calling our parent's
	implementation of query_auth_types() since CamelDiscoStore doesn't
	have any anyway.
	(imap_get_name): New method to implement CamelService::get_name

2002-05-18  Not Zed  <NotZed@Ximian.com>

	* camel-search-private.c (camel_utf8_getc): If we get an invalid
	start char, just ignore it and goto the next character.

2002-05-16  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (get_folder_offline): Don't
	call some retarded function to simply set an exception.

	* camel-filter-search.c (get_label): New e-sexp callback function
	to get a user_tag label value.

2002-05-15  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c
	(imap_parse_namespace_response): New function to parse a NAMESPACE
	response properly.
	(imap_namespaces_destroy): New function to destroy the returned
	structure from the above function.

2002-05-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-service.c (service_setv): Only reconnect if we are already
	connected, if we are in a disconnected state then no need to
	reconnect.

	* providers/imap/camel-imap-folder.c (get_content): If the
	part_spec is an empty string for a leaft part, use "1" since we
	don't actually want to get the raw message headers too.

2002-05-15  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (refresh_folder_info): removed.
	(imap_store_refresh_folders): Copy the folders first, then refresh
	them, outside of the cache_lock, which could cause deadlocks
	because of a workaround for crappo exchange.
	(imap_disconnect_online): Dont pass an exception to LOGOUT
	command.  The required response 'BYE' always sets an exception
	when we call LOGOUT.  This also interfered with a lot of other
	processing causing partial failures and messed up offline/online
	state.

	* camel-disco-folder.c (disco_prepare_for_offline): Do progress
	reporting.

2002-05-14  Jeffrey Stedfast  <fejj@ximian.com>

	Fixes bug #24136.

	* providers/imap/camel-imap-folder.c (content_info_get_part_spec):
	New function to take a CamelMessageContentInfo and generate a
	part-specification string.
	(get_content): Stop passing around part_spec strings and use
	content_info_get_part_spec instead.

	* camel-folder-summary.c (camel_content_info_dump): Made this into
	a public debugging function.

	* providers/imap/camel-imap-utils.c (imap_parse_body): Make sure
	to set the parent of any message/rfc822 subparts.

2002-05-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_get_message): Previous
	fix reverted.

2002-05-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (camel_imap_store_class_init):
	Overload the setv/getv CamelObject virtual methods.
	(imap_setv): Implemented.
	(imap_getv): Implemented.

2002-05-13  Dan Winship  <danw@ximian.com>

	* camel-folder.c (camel_folder_append_message): Add a "char
	**appended_uid" argument, for the caller to optionally pass in a
	variable to receive the UID of the appended message (if the
	provider knows it).
	(camel_folder_transfer_messages_to): Likewise, add "GPtrArray
	**transferred_uids"
	(transfer_messages_to): Update default implementation to handle
	transferred_uids.

	* camel-disco-folder.c (disco_append_message,
	disco_transfer_messages_to): Update for API changes.

	* camel-disco-diary.c (camel_disco_diary_replay): Update the
	diary's temporary uid->real uid map when replaying appends and
	transfers.

	* providers/imap/camel-imap-folder.c (imap_append_offline,
	imap_append_online, imap_transfer_offline): Pass back the new
	UIDs, when requested and available.
	(imap_append_resyncing): Pass back the new UIDs when requested and
	available. Remove the diary uidmap managing code since
	CamelDiscoDiary can handle that itself now.
	(imap_transfer_online, imap_transfer_resyncing): Update for new
	APIs, but don't actually pass back the new UIDs yet. (It's tricky
	since the COPYUID response may not be in the same order as the
	input uids.)
	
	* providers/local/camel-maildir-folder.c (maildir_append_message):
	Pass back the new UID if requested.

	* providers/local/camel-mbox-folder.c (mbox_append_message):
	Likewise.

	* providers/local/camel-mh-folder.c (mh_append_message): Likewise.

	* providers/local/camel-spool-folder.c (spool_append_message):
	Likewise.

	* camel-digest-folder.c (digest_append_message,
	digest_transfer_messages_to): Update for API changes.

	* camel-filter-driver.c	(camel_filter_driver_filter_message,
	do_copy, do_move): Update for API changes.

	* camel-vee-folder.c (vee_append_message,
	vee_transfer_messages_to): Likewise.

	* camel-vtrash-folder.c (vtrash_append_message,
	vtrash_transfer_messages_to): Likewise. 

2002-05-13  Not Zed  <NotZed@Ximian.com>

	* camel-folder-thread.c
	(camel_folder_thread_messages_new_summary):
	(camel_folder_thread_messages_new): Since the fix for #3357 uses
	'order=0' to indicate tree structure nodes, make sure we dont
	actually set order=0 for valid messages, otherwise we silently
	lose duplicates of the first message (i==0).  Fixes #19920.

2002-05-10  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_get_message): Fetch the
	BODYSTRUCTURE rather than BODY since BODY seems to be lacking some
	of the data we need. This fixes bug #24136.

	* camel-transport.c (camel_transport_get_type): Might help if we
	called camel_transport_class_init.

2002-05-10  Dan Winship  <danw@ximian.com>

	* camel-folder.c (camel_folder_transfer_messages_to): Replace
	copy_messages_to and move_messages_to with a single function that
	just takes a "delete_originals" flag. Also, use the vtrash
	implementation if *either* folder is a vtrash.
	(transfer_messages_to): Make this use camel_operation_progress
	(previously move_messages_to did but copy_messages_to didn't), and
	freeze/thaw the folder(s) if doing multiple messages.

	* camel-vtrash-folder.c (vtrash_transfer_messages_to): Update for
	move/copy merge. Move the "move messages into vtrash" code here
	from mail-ops.c. Now all of the vtrash move/copy special casing is
	in camel instead of half of it being here and half in mail/. (This
	should also make it so that "Move to Trash" will work in filter
	rules.)

	* camel-vee-folder.c (vee_transfer_messages_to): Make this just
	return an exception, since it will only be called when trying to
	move/copy messages from one vfolder to another.
	(vee_append_message): Add this too so we get a nicer error message
	than the default "unimplemented" one in camel-folder.c.

	* camel-digest-folder.c: Replace copy_messages_to and
	move_messages_to with transfer_messages_to.

	* camel-disco-folder.c: Likewise

	* camel-disco-diary.c (camel_disco_diary_log,
	camel_disco_diary_replay): replace MOVE/COPY with TRANSFER.

	* providers/imap/camel-imap-folder.c (imap_transfer_offline,
	imap_transfer_online, imap_transfer_resyncing): Update for
	changes. (This ends up being a bit more complicated than it was
	before for now, but later disconnected operation changes should
	resimplify it.)

	* camel-filter-driver.c (camel_filter_driver_filter_message,
	do_copy, do_move): Use transfer_messages_to instead of copy.

2002-05-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-search.c (shell_exec): New filter function to pipe
	a message to another program.
	(run_command): Fixed some bugs to make this work.

2002-05-09  Not Zed  <NotZed@Ximian.com>

	* camel-service.c (camel_service_disconnect): Instead of testing
	for SERVICE_CONNECTED, we need to also handle SERVICE_CONNECTING
	too, as it will often have setup some details before it failed.
	Make it !DISCONNECTED (and !DISCONNECTING for recursive calls,
	which happen).  Fixes #23782, and maybe also #21604 and many other
	random crashes.

2002-05-08  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-store.c (digest_setv): Implemented.
	(digest_getv): Implemented.

	* camel-disco-store.c (disco_setv): Implemented.
	(disco_getv): Implemented.

	* camel-remote-store.c (remote_store_setv): Implemented.
	(remote_store_getv): Implemented.

	* camel-transport.c (camel_transport_class_init): Implemented.
	(transport_setv): Implemented.
	(transport_getv): Implemented.

	* camel-store.c (store_setv): Implemented.
	(store_getv): Implemented.

	* camel-service.c (service_setv): Implemented.
	(service_getv): Implemented.

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate):
	camel_pop3_engine_iterate doesn't return the state, it returns -1
	on fail, 0 when finished processing request or >0 if more ops are
	in the queue, so don't check status against CAMEL_POP3_STATE_OK,
	instead check pcp->state against that.

2002-05-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-object.h: s/class/klass for arguments so that c++
	developers don't complain later.

2002-05-07  Dan Winship  <danw@ximian.com>

	* camel-object.c (camel_object_class_cast): Fix a crash in a
	g_warning.

2002-05-07  Not Zed  <NotZed@Ximian.com>

	* camel-remote-store.c (remote_send_string): Check for LOGIN xxxx
	as well if debug is on, so we dont print passwords to evolution
	logs.

	* providers/imap/camel-imap-utils.c (imap_is_atom_char): This was
	really broken.  1. isprint() is locale dependent, and 2. it looked
	up an 8 bit value in a 7 bit table without truncating it.  I've
	removed the isprint() stuff and just put it directly into the
	special table, which i've expanded to the right size too.

	* providers/imap/*: Applied patch from Preston Elder
	<prez@magick.tm> to make camel only use literals if it needs to
	for simple strings.  Changed slightly to use imap_is_atom() and
	more consistent formatting.
	* providers/imap/camel-imap-utils.c (imap_is_atom): Changed from
	imap_needs_quoting().

	** Merged in camel-object2 branch.  Simpler camelobject
	implementation + object args interface.

	* camel.c (camel_init): Call camel_object_get_type() to make sure
	camel_object_type is initialised.

	* camel-object.h (CAMEL_OBJECT_TYPE): Changed to return global
	camel_object_type pointer, not call camel_object_get_type.
	
2002-05-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate): If
	the pop3 command status is -1, then we probably have a TCP error
	(?) so set a SYSTEM exception so our caller can distinguish
	between a "bad password" and a "tcp error".
	(pop3_connect): Only uncache the password on "bad password"
	errors.

	* camel-pgp-mime.c (pgp_mime_part_sign_prepare_part): Use
	CamelMimeFilterBestenc to get a more appropriate encoding rather
	than just blindling assigning QP.

	* providers/imap/camel-imap-folder.c (do_append): Call
	camel_mime_message_encode_8bit_parts() which fixes bug #10885.

	* camel-tcp-stream-raw.c (socket_connect): Don't bother with
	counting down the timeout.

2002-05-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-stream-fs.c (stream_read): Same fix as the tcp stream.
	(stream_write): Again here. Just like tcp stream's stream_write(),
	also make sure to save errno before calling fcntl to restore the
	fd flags.

	* camel-tcp-stream-raw.c (stream_read): Handle EINTR errors for
	select().
	(stream_write): Same and also preserve errno when setting the fd
	flags back. If w == -1, return -1.

2002-05-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_decode_mailbox): Fixed the fix for
	stupidly-broken-mailer bug #5 to work when multiple unescaped
	characters were in a row. Fixes bug #24140.

	* camel-tcp-stream-raw.c (socket_connect): Check select() for
	EINTR errors.

	* camel-pgp-context.c (crypto_exec_with_passwd): Change the order
	of some code so that we check if the select() failed before we
	check for user-cancellation.

	* camel-service.c (camel_gethostbyname): Check for EINTR when
	select()ing.
	(camel_gethostbyaddr): Same.

2002-04-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-provider.c (camel_provider_auto_detect): Now takes a
	CamelURL argument rather than a GHashTable *settings argument.

2002-04-29  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-store.c (get_folder_info): We want
	to set unread_count to get_unread_message_count, not
	get_message_count().  Might fix #17174.  Also removed FIXME: as it
	was fixed.

2002-04-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/Makefile.am: Don't link to libibex.a anymore.

	* providers/nntp/Makefile.am: Same.

	* providers/imap/Makefile.am: And again here.

	* camel-store-summary.h: No longer want to #include
	<libibex/ibex.h>

	* camel-provider.c (camel_provider_auto_detect): New function to
	auto-detect configuration settings.

2002-04-26  Not Zed  <NotZed@Ximian.com>

	* camel-block-file.c (block_file_validate_root): Remove the
	excessive \n's, after printfs.

	* camel-text-index.c (text_index_compress_nosync): @!#$@#$!@$#!.
	Since the rename op was fixed, this broke compression's rename,
	resulting in the index 'vanishing' after every compress
	(i.e. after every reindex).  Fix this code to account for the
	fixed rename operation.

2002-04-25  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_rcpt): Don't put a
	space between the "RCPT TO:" and the "<recipient>" strings -
	rfc0821 was not clear on this but it seems rfc2821 defines a
	grammar excluding that SP.
	(smtp_mail): Same.

2002-04-24  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-provider.c
	(camel_provider_module_init): Configure the default paths for mh,
	mbox, maildir, spools, etc.

	* camel-provider.h: Add a CAMEL_PROVIDER_CONF_LABEL enum and
	define some default CamelProviderConfEntry macros.

2002-04-19  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/pop3/camel-pop3-folder.c (pop3_refresh_info): Free the
	LIST pop3 command.

	* camel-data-cache.c (data_cache_finalise): Free the cdc->path.

	* camel-multipart.c (write_to_stream): Don't g_return_val_if_fail
	here if the boundary is an empty string. See bug #23676 for
	details. The way I see it, we have 2 options: 1) leave this fix
	the way it is, thus allowing multipart boundaries to be
	empty-strings; or 2) make camel_multipart_get_boundary() change
	the boundary to something legal if the boundary is an
	empty-string. Since the parser should be able to handle an
	empty-string boundary *and* more importantly because we want to
	keep the same boundaries as the original raw message so as to be
	able to verify multipart/signed parts, I vote for solution #1.

2002-04-19  Not Zed  <NotZed@Ximian.com>

	* devel-docs/camel-index.txt: Start of a white-paperish document
	describing camel-index and older libibex.

2002-04-18  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-store.c (rename_folder): If we get a
	failure, make sure we set an exception.

	* camel-text-index.c (camel_text_index_rename): If the file
	doesn't exist, just assume it never did, dont return failure.
	(text_index_rename): Add '.index' to the path name we're using,
	since we dont get it passed in.

	* camel-folder-search.c (check_header): When doing a contains
	match, split the words and perform an and on it.
	(match_words_messages): If we have an index, but were forced to do
	a full search, first lookup a subset of messages using
	the index and a simplified word set.  Only do a manual search of
	this subset.

2002-04-17  Not Zed  <NotZed@Ximian.com>

	* camel-folder-search.c (match_message_index): Changed to take a
	utf8 string not a regex pattern.
	(match_words_index): Matches against a camel_search_words list.
	(match_words_1message): Matches a single message against a
	camel_search_words list.
	(match_words_message): Same, but gets the message from the folder
	for you.
	(match_words_messages): Matches a list of messages against a words
	list.
	(search_body_contains): Rewritten to handle multiple word
	searches.  For #23371.

	* providers/imap/camel-imap-search.c (sync_match): Split words
	when searching, to support multiple search words.  Also, try
	searching specifying charset of utf8 if we can, if that fails,
	fall back to not specifying charset.  TODO: It should translate
	the strings into the locale default charset?

	* providers/imap/camel-imap-store.c (connect_to_server): Added new
	cap - utf8_search, if set, we tell the server we're searching
	using utf8, otherwise we dont (incorrectly, since we always use
	utf8 to search).

	* camel-search-private.c (camel_ustrstrcase): Make this class public.
	(camel_search_words_split): Split a word into multiple words based
	on whitespace, and keep track of whether the word is simple
	(indexable directly), or not.
	(camel_search_words_free): Free 'em.

2002-04-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-vee-folder.c (vee_search_by_expression): If the vee-folder
	is the unmatched, we don't have our own expression so we cannot
	merge them. Instead, just use the expression passed in. This fixes
	a Null-Pointer-Read crash on Solaris systems at least.

2002-04-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_folder): Get
	rid of an unused variable.

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Use
	camel_gethostbyaddr since gethostbyaddr is not reentrant.

	* camel-http-stream.c (http_connect): Updated after the rename of
	camel_get_host_byname.

	* camel-service.c (camel_gethostbyname): Renamed.
	(camel_gethostbyaddr): New cancellable/reentrant version of
	gethostbyaddr.

2002-04-14  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-spoold-store.c: Added #include
	<sys/types.h> for dirent.h which needs it on MacOS X.

	* providers/local/camel-maildir-store.c: Same.

	* providers/nntp/camel-nntp-store.c: Same.

	* providers/imap/camel-imap-message-cache.c: Same.

	* camel-provider.c: Same.

	* camel-data-cache.c: Same.

2002-04-12  Jeffrey Stedfast  <fejj@ximian.com>

	* broken-date-parser.c (datetok): Treat commas as token
	delimeters.
	(WEEKDAY_CHARS): Use full weekday names in case the broken mailer
	used the full names.
	(MONTH_CHARS): Same as above but for months.

2002-04-15  Not Zed  <NotZed@Ximian.com>

	* *.c: Fix callers for api changes to camel-object, mainly
	declare_event->add_event, and classfuncs->klass, and a couple
	of missing #include <config.h>'s

	* camel-arg.[ch], Makefile.am: New support code for
	camel_object_get/set arg.

	* *.h: Fixed all uses of get_type to return a CamelType rather
	than a guint (now a pointer).

	* camel-object.[ch]: Major cleanup of object implementation.  Also
	added a get/set interface, and some debugging options.

2002-04-11  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-summary.c (spool_summary_sync_full):
	If the last message(s) were deleted, and we had any messages
	output, account for the lost \n of the following From line by
	adding an extra \n. fix for #8214.

2002-04-10  Not Zed  <NotZed@Ximian.com>

	* camel-mime-part-utils.c (convert_buffer): If we get a 0 length
	input, return a 0 lenght output as valid - fixes bugs with some
	iconv impl and its simpler anyway.

2002-04-11  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c: Set the UID_SET_LIMIT value
	to 4096. I ran into an issue tonight where apparently the IMAP
	server changed the UIDVALIDITY and so Evo needed to re-fetch all
	headers and it was trying to send a uid set of some 25k (yes, I
	have a very large INBOX). Anyways, it was set to unlimited
	before. Courier IMAPd can safely handle up to ~16k per token, but
	UW IMAPd can only handle 8k per command-line, so I set it to 4k
	just to be safe.

2002-04-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c (convert_buffer): Fixed a bug that would
	miscalculate how much data to copy into the GByteArray (negative
	value) thus causing a segfault. Also optimized it while I was at
	it.

2002-04-09  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-store.c (camel_store_init): Make the folder_lock
	recursive. See bug #22363 for details. Basically,
	get_folder_info() is requesting a diary folder which in turn
	connects which requests then calls get_folder() but deadlocks
	because get_folder_info already holds the lock.

	* camel-mime-message.c (camel_mime_message_set_date): Don't adjust
	the timezone offset if we used tm.tm_gmtoff because it is already
	adjusted.

2002-04-09  Not Zed  <NotZed@Ximian.com>

	* camel-mime-part.c (construct_from_parser): If we get multiple
	Content-Type header values, change subsequent headers to
	X-Invalid-Content-Type so it doesn't wreck processing.  This fixes
	the reported case in #18929, but i dont know if it fixes the
	original posters problems.

2002-04-08  Not Zed  <NotZed@Ximian.com>

	* camel-vtrash-folder.c (vtrash_move_messages_to): If we find
	we're moving from the vtrash to another folder, we need to convert
	the uid from a vfolder uid to the source uid (+8).  Fix for
	#20886.  Also changed to batch multiple moves to different folders
	so they are done as efficiently as possible rather than one at a
	time.

	* camel-mime-utils.c (base64_decode_step): If we only get passed
	'=', we back track only if we actually output any data.  Fix for
	#21716.
	(quoted_decode): Pass out size_t instead of int, and use 0 instead
	of -1 for error since its not signed.  This will fix similar bug
	to above in different circumstances since the result is taken as
	unsigned.  This is only an internal func.
	(quoted_encode): Return size_t just for consistency.

	* camel-block-file.c (block_file_validate_root): Comment out the
	debug and move it into a warning when the validation fails.

2002-04-08  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (uuencode_close): Don't count our filler when
	encoding our line-length octet.

2002-04-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-http-stream.c (http_get_headers): Don't get the statuscode
	here anymore.
	(http_method_invoke): Use a User-Agent header and do basic proxy
	authentication.
	(stream_read): Handle redirects.
	(camel_http_stream_set_user_agent): New function to allow client
	to set the User-Agent string.
	(camel_http_stream_set_proxy): New function for setting the proxy
	server.
	(camel_http_stream_set_proxy_authrealm): New function for setting
	the proxy auth realm.
	(camel_http_stream_set_proxy_authpass): New function for setting
	the proxy auth password.

2002-04-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (message_info_new): Simplified since we
	can now decode in-reply-to without getting extra cruft. Get rid of
	the FIXME about having to check scan->id because of the
	possibility of it being NULL, this can no longer happen.

	* camel-mime-utils.c (header_references_inreplyto_decode): New
	function to decode in-reply-to headers. Only grabs the first thing
	that looks like a message-id and then returns.
	(header_references_decode): Loop calling
	header_references_decode_single (a new internal function).

2002-04-04  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-search.c (imap_body_contains): If
	(body-contains) is not passed any arguments, return empty/false.
	Fixes a crash exposed by #15001.

	* camel-remote-store.c (remote_connect): Reset the keepalive
	timeout to 10 minutes rather than the 30 seconds I was using for
	testing.

2002-04-03  Dan Winship  <danw@ximian.com>

	* camel-provider.h (CamelProvider): make service_cache be an array
	of CAMEL_NUM_PROVIDER_TYPES elements so you can have a single
	provider offer both stores and transports. (Eg, Exchange, NNTP)

	* providers/imap/camel-imap-provider.c: Don't initialize
	service_cache here. (The session code can do it itself since the
	url_hash and url_equal functions are stored as part of the
	provider.)

	* providers/nntp/camel-nntp-provider.c: Likewise.

	* providers/local/camel-local-provider.c: Likewise.

	* providers/pop3/camel-pop3-provider.c: Likewise.

	* providers/sendmail/camel-sendmail-provider.c: Likewise.

	* providers/smtp/camel-smtp-provider.c: Likewise.

	* camel-session.c (register_provider): Initialize the provider's
	service cache(s) here.
	(camel_session_class_init): Don't initialize.
	vee_provider.service_cache here.
	(camel_session_destroy_provider): Update to destroy multiple
	service_caches.
	(service_cache_remove, get_service): Tweak these a bit to deal
	with multiple service_caches.

2002-04-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (set_errno): Handle a ton more nspr i/o
	errno's.
	(stream_connect): Act as if we are doing a non-blocking
	connect. This is to try and work around bug #15120 where users get
	an EINPROGRESS error. Maybe importing a PRFileDesc into SSL mode
	automagically makes it non-blocking? I dunno.

2002-04-01  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (message_info_new): Updated the
	construction of the references to match JWZ's updated algorithm
	initialization (ie, append any In-Reply-To reference onto any
	References header and never take more than a single message-id
	from the In-Reply-To header since anything after the first will
	probably just be email addresses). Fixes bug #1336.

2002-04-03  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): Turn indexing back on, fingers
	crossed ...

	* camel-block-file.c (sync_nolock): #!@$@$#@~#$
	DF@#$!Q@$#!@$#!#%.  Well it helps if we're iterating a list to
	iterate the node pointer ...

	* camel-text-index.c (text_index_sync): Sync the key tables
	explcitly.
	(text_index_sync): Debug out frag info.
	(camel_text_index_dump): Added a (rather large, but optional) raw
	dumping mode for debugging purposes.

	* camel-partition-table.c (camel_key_table_finalise): Sync root
	block when done.
	(camel_key_table_sync): New function, sync key table (root) explicitly.
	(camel_partition_table_sync): Method to explicitly sync the
	partition table.

2002-04-02  Not Zed  <NotZed@Ximian.com>

	* camel-block-file.c (camel_block_file_free_block): Mark root
	block dirty when we change it (this function isn't used yet
	anyway).

	* camel-text-index.c (text_index_add_name_to_word): Touch the root
	block when we modify the counts.  Also, abort processing on any
	errors.
	(text_index_sync): Fix typo in comments.  Sync the block file
	inside the lock.
	(text_index_compress_nosync): Lock the old index while we're
	compressing.
	(text_index_compress_nosync): Remove the bogus while() at the end
	of the while() loops!  Also plug a memleak - records weren't
	freed.
	(text_index_rename): Lock around rename op.
	(text_index_add_name): More typos.
	(text_index_sync): Touch root when changing it.
	(text_index_add_name): "
	(text_index_delete_name): "
	(camel_text_index_new): Touch root if we change it.
	(text_index_cursor_reset): Make sure we NULL pointers after we
	free them (nothing uses this yet).

	* camel-partition-table.c (hash_key): Remove some debug
	accidentally left in.
	(camel_partition_table_add): When linking in the next block list,
	set the right previous pointer.
	(camel_key_table_add): Simplify the 'left' calculation (it was
	already ok though).
	(camel_key_table_next): Initialise returns before processing.
	Broaden the lock slightly, and simplify validity calculations.

	* providers/imap/camel-imap-store.c (imap_keepalive): Put back in
	the exception setup stuff i disabled for debugging.

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): Temporarily disable indexing.

2002-03-28  Not Zed  <NotZed@Ximian.com>

	* camel-partition-table.c (camel_key_table_lookup): Change range
	checking assert to a warning.

	* providers/pop3/camel-pop3-folder.c (pop3_finalize): Make sure we
	flush out all outstanding commands before finalising, stops being
	finalised while outsanding requests are processed by the store
	finalise.
	(pop3_get_message): Instead of pre-fetching all messages, just
	pre-fetch a maxiumum number at any one time, stops us running out
	of cache fd's.
	
	* providers/nntp/camel-nntp-folder.c (nntp_folder_init/finalise):
	Setup priv data + locks, & free.

	* providers/imap/camel-imap-folder.c (imap_rescan): Batch all
	message_chagned events into a single folder_changed event
	(otherwise updates can be >>> expensive, like >5 hours for 80K
	messages changing!).  Alternately it could use folder
	freeze/unfreeze perhaps.

2002-03-27  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (imap_keepalive): Pass an
	exception to called code so it behaves properly since it uses the
	passed exception to check returns.

2002-04-01  Dan Winship  <danw@ximian.com>

	* providers/imap/Makefile.am (libcamelimap_la_LDFLAGS): Use
	-avoid-version instead of -version-info 0:0:0, and specify
	-module. (From Max Horn <max@quendi.de>).

	* providers/local/Makefile.am (libcamellocal_la_LDFLAGS): Likewise.

	* providers/nntp/Makefile.am (libcamelnntp_la_LDFLAGS): Likewise.

	* providers/sendmail/Makefile.am (libcamelsendmail_la_LDFLAGS):
	Likewise.

	* providers/smtp/Makefile.am (libcamelsmtp_la_LDFLAGS): Likewise.

	* providers/pop3/Makefile.am (libcamelpop3_la_LDFLAGS): Likewise.
	Also remove $(KRB4_LDFLAGS) since KPOP is gone.
	(INCLUDES): and $(KRB4_CFLAGS)

2002-03-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (do_copy): We now have to check to make
	sure that p->message is non-NULL because we only load the message
	when we have to.
	(do_move): Same here.

2002-03-28  Dan Winship  <danw@ximian.com>

	* camel-transport.c (camel_transport_send_to): Change the message
	arg to a CamelMimeMessage instead of a CamelMedium. Even the NNTP
	provider returns CamelMimeMessages, and we're never going to
	support anything more exotic than that. Also do a few more
	g_return_if_fails here instead of in the providers.
	(camel_transport_can_send): No longer needed.
	(camel_transport_send): Remove this too. It wasn't being used any
	more, and it doesn't behave exactly the same in sendmail and smtp.

	* providers/smtp/camel-smtp-transport.c (smtp_send,
	smtp_can_send): Gone.
	(smtp_send_to): Update for arg change.
	(smtp_data): Make this take a CamelMimeMessage too.

	* providers/sendmail/camel-sendmail-transport.c (sendmail_send,
	sendmail_can_send): Gone.
	(sendmail_send_to): Update for arg change, and merge in the part
	that used to be shared with sendmail_send.

2002-03-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_folder):
	Construct the source_url the right way. The previous way was
	generating urls like pop://fejj@ximian.com;keep_on_server/inbox
	which is wrong.

2002-03-26  Not Zed  <NotZed@Ximian.com>

	* camel-text-index.c (text_index_normalise): Changed to use just
	g_utf8_strdown instead of utf8_normalise, to match the indexing
	code.  utf8_normalise is just far too expensive (saves approx 25%
	total processing).

2002-03-25  Not Zed  <NotZed@Ximian.com>

	* camel-text-index.c (text_index_add_name): When we add a new
	name, up all of the cache limits, because we're probably going to
	be adding more.
	(text_index_sync): Drop the cache limits back down again, we dont
	need them when looking words up.

	** MERGE camel_index branch.

	* camel-text-index.[ch]: Added files i forgot to add (eep nearly
	lost all this work!)

	* camel-block-file.c (sync_nolock): Fix an infinite loop in syncing.

2002-03-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (camel_message_info_new_from_header): Use
	the date in the received header for the received_date.

2002-03-22  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): Use the right option to remove the
	index file and reset the index file on creation.
	(camel_local_folder_construct): Remove any existing '.ibex' files
	- these are the old format index files.

	* camel-block-file.c (camel_block_file_rename): Lock io lock while
	renaming.
	(camel_key_file_rename): Lock around rename.
	(block_file_validate_root): Implement sync flag checking.
	(camel_block_file_touch_block): Turn off the sync flag if we're
	touching any non-root block and write it to disk.  Shoudl this
	fsync()?
	(sync_nolock): sync the root block only if we need to.

	* providers/local/camel-local-store.c (rename_folder): Re-enable
	index rename code.  Not sure how race-free it is though.
	(delete_folder): Delete the index file properly.

	* camel-partition-table.c (camel_key_table_lookup): Initialise
	output values to 0 before doing anything.
	(camel_key_table_add): Do some range-checking on values.

	* camel-text-index.c (text_index_compress): Changed to call sync here.
	(text_index_compress_nolock): and not here - stops a recursive
	sync call when sync performs a compress also.
	(text_index_compress_nolock): Change to _nosync, since the locking
	is irrelevent (recursive lock).  Fixed callers.
	(text_index_add_name_to_word): If we get a failure with key table
	ops, fail immediately.
	(text_index_compress_nosync): Likewise.
	(text_index_write_name): If the nameid is 0, do nothing.
	(text_index_add_name): If we can't get a keyid, dont add it to the
	partition table.
	(camel_text_index_remove): Function to delete an index file.
	(text_index_compress_nosync): Clean up temp files when done.

	* camel-folder-search.c (match_messages_index): New function,
	split from body_contains, matches a regex against all words in an
	index.
	(match_message_index): Similar to above but matches against an
	individual message.
	(search_body_contains): Changed to use above functions for
	matching - substring matches should now work on indexed data.

2002-03-21  Not Zed  <NotZed@Ximian.com>

	* camel-index.c (camel_index_words/names): New virtual
	methods/stubs to get a cursor of all words and names.

	* camel-text-index.c (text_index_compress_nolock): Split from
	text_index_compress, so we can call the compressor while locked
	also, removed lock calls.
	(text_index_compress): Changed to stub which calls
	text_index_compress_nolock.
	(camel_text_index_key_cursor_new): New object to iterate through
	a key table.
	(text_index_words, text_index_names): Implement virtual functions
	for iterating through all words or names.

	* camel-block-file.c: Turn off some debug.

2002-03-20  Not Zed  <NotZed@Ximian.com>

	** New body index implementation.

	* camel-index*: Code for camel index, a new class to replace ibex.

	* camel-block-file.[ch]: block-based and link based
	filesystem-in-a-file classes.

	* camel-partition-table.[ch]: An implementation of a partition
	table (automatically extending on-disk hash-table using ideal
	hash), and a key-table, a key<>name mapping table.  Used by
	camelindex.

	* providers/local/*, camel-folder-summary.[ch]: Changed to use
	camel-index interface rather than ibex.

2002-03-05  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-summary.c (maildir_summary_check):
	Do progress reporting of operations.
	(maildir_summary_sync): Same here.

2002-03-04  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spoold-store.c (scan_dir): Kill a warning
	with a cast.

	* providers/local/camel-*.c: Changed for ibex->camelindex.

	* camel-folder-search.c (camel_folder_search_set_summary): Init
	summary_hash to point to 'static' uid strings.
	(search_body_contains): Use the static uid memory to return
	results rather than the values from the index library.

	* camel-folder-search.[ch]: Changed to use camelindex object.

	* camel-folder-summary.c (summary_build_content_info_message):
	Use a stream to index content, also filter html mail first.
	(camel_folder_summary_info_new_from_message): Use a stream
	filtered to index content.
	(main): Removed the test main code.  Added headers for open call
	(ibex must've had them before).

	* camel-folder-summary.[ch]: Changed from ibex to CamelIndex.

	* camel-mime-filter-index.c (camel_mime_filter_index_finalize):
	Unref index.

	* camel-mime-filter-index.[ch]: Changed from ibex to CamelIndex.

2002-03-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_encode_param): Fix this to work
	right. We need to convert the input buffer to the charset we claim
	in the encoded param (duh).

2002-03-18  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c
	(connect_to_server_wrapper): Updated to use the same logic as the
	POP code.

	* providers/pop3/camel-pop3-store.c (connect_to_server): No longer
	takes a stls_supported argument since we no longer need it with
	the new logic.
	(connect_to_server_wrapper): New logic: First try connecting to
	the SSL port (995 by default), if that fails with
	SERVICE_UNAVAILABLE, then we attempt to connect (to port 110 by
	default) and try to use STARTTLS.

2002-03-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder.h: 

	* camel-private.h: Don't allow any empty structs. If
	!ENABLE_THREADS, provide a gpointer dummy member. Fixes bug #6382.

2002-03-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_auth): Added a
	work-around for SMTP servers that can't read the RFCs and thus
	implement SASL incorrectly. Oh well, that's life in the world of
	mail clients I guess.

2002-03-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-store.c (camel_digest_store_new): Now takes a url
	argument.

	* camel-digest-folder.c (digest_add_multipart): Fixed some memory
	corruption and also modified to use CAMEL_IS_MIME_MESSAGE() rather
	than comparing content-type strings.
	(digest_get_message): Fixed a logic blooper.

	* camel-folder-summary.c (camel_message_info_new_from_header): Set
	the date fields of the CamelMessageInfo as well. This may even fix
	some filter-related bugs where the user was trying to compare
	dates.

2002-03-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-store.c: A pretty empty store implementation to be
	the parent store of a CamelDigestFolder.

	* camel-digest-folder.c: Updated to reference it's parent store.

2002-03-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-folder.c (camel_digest_folder_new): Allow any leaf
	part to be a message/rfc822 part.
	(digest_get_uids): Recurse the mime structure and add all
	message/rfc822 parts and use a uid scheme similar to IMAP's mime
	part naming convention.
	(digest_get_message): Decode the uid to get the correct mime part.

2002-03-11  Ettore Perazzoli  <ettore@ximian.com>

	* camel-mime-utils.c: Change the order of the mailing list magic
	patterns so that the more mailing-list specific ones are on the
	top.

2002-03-11  Jeffrey Stedfast  <fejj@ximian.com>

	These fixes should fix bug #21737.

	* providers/smtp/camel-smtp-transport.c
	(connect_to_server_wrapper): Same as with the POP code.

	* providers/pop3/camel-pop3-store.c (connect_to_server_wrapper):
	Slight restructuring of the if-statements for the USE_SSL_ALWAYS
	case so that we can't possibly return TRUE unless we really did
	connect successfully.

2002-03-10  Dan Winship  <danw@ximian.com>

	Rename the OpenSSL implementation of things to match the NSS
	implementation so that callers don't need to care which one is
	being used.

	* camel-tcp-stream-openssl.c: Implement CamelTcpStreamSSL, not
	CamelTcpStreamOpenSSL. Rename methods as well. Replace the
	camel-tcp-stream-openssl.h include with camel-tcp-stream-ssl.h.

	* camel-tcp-stream-openssl.h: Gone.

	* camel-tcp-stream-ssl.c: Add a note explaining that this
	implementation is only used for NSS, and that OpenSSL's
	implementation is in another file. (Should probably do some CVS
	renaming magic at some point.)

	* camel-http-stream.c (http_connect): Remove OpenSSL refs; the
	previously-NSS-specific code works for both now.

	* camel-remote-store.c: Likewise.

	* providers/smtp/camel-smtp-transport.c: Likewise.

	* providers/pop3/camel-pop3-store.c: Likewise.

	* Makefile.am (libcamelinclude_HEADERS): Remove
	camel-tcp-stream-openssl.h

2002-03-10  Dan Winship  <danw@ximian.com>

	* camel-tcp-stream.c (camel_tcp_stream_get_socket): Remove this:
	it couldn't be generically used, because different subclasses
	returned entirely different types of data.
	(camel_tcp_stream_get_local_address,
	camel_tcp_stream_get_remote_address): Add these to replace what
	get_socket was being used for.
	(camel_tcp_address_new, camel_tcp_address_free): Utility functions
	for get_{local,remote}_address.

	* providers/smtp/camel-smtp-transport.c: Change localaddr to a
	CamelTcpAddress *.
	(connect_to_server): Call camel_tcp_stream_get_local_address to
	get the local IP address.
	(smtp_disconnect): free localaddr.
	(smtp_helo): Update for localaddr change.

	* camel-tcp-stream-raw.c (stream_get_socket): Remove
	(stream_get_local_address, stream_get_remote_address): Implement.

	* camel-tcp-stream-ssl.c (stream_get_socket): Remove
	(stream_get_local_address, stream_get_remote_address): Implement.

	* camel-tcp-stream-openssl.c (stream_get_socket): Remove
	(stream_get_local_address, stream_get_remote_address): Implement.

2002-03-08  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/pop3/camel-pop3-provider.c
	(camel_provider_module_init): Don't call
	camel_remote_store_get_authtypes since we no longer subclass
	camel-remote-store.

	* providers/pop3/camel-pop3-engine.c: Added STARTTLS to the
	capabilities to look for.
	(camel_pop3_engine_reget_capabilities): New function to re-get
	capabilities.

	* providers/pop3/camel-pop3-store.c: Updated to not subclass
	CamelRemoteStore.
	(connect_to_server): Rewritten to not depend on CamelRemoteStore's
	connect implementation. Also added support for STLS (aka
	STARTTLS).

2002-03-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_sign): Add support for
	hash type RIPEMD160.

	* camel-cipher-context.h: Add RIPEMD160 hash type.

	* camel-pgp-context.c (pgp_sign): Updated to consider hash
	function for pgp5 and pgp6.
	(pgp_clearsign): Same.

	* camel-tcp-stream-openssl.c (stream_read): Add a timeout on the
	select.
	(stream_write): Same.

2002-03-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (connect_to_server): Fix
	to work with OpenSSL.

	* camel-tcp-stream-openssl.c: compile fixes.
	(camel_tcp_stream_openssl_enable_ssl): Check to make sure that the
	sockfd != -1, it's not enough to check that it is non-zero. Also
	set the sockfd to -1 on fail (open_ssl_connection will close the
	sockfd on fail).

2002-03-06  Dan Winship  <danw@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_construct): Make
	this compile.

2002-03-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (save_ssl_cert): Removed. Glory glory
	hallelujah!
	(ssl_bad_cert): No longer calls ssl_save_cert or
	ssl_cert_is_saved.

2002-03-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (camel_tcp_stream_openssl_new_raw):
	Start the ssl stream off in non-ssl mode (useful for STARTTLS).
	(camel_tcp_stream_openssl_enable_ssl): New function to toggle an
	ssl stream into ssl mode.
	(open_ssl_connection): Close the sockfd on fail so our caller
	doesn't have to - this also allows us to save the original errno.
	(stream_connect): If we want ssl mode, do our ssl stuff.
	(camel_tcp_stream_openssl_class_init): Init some SSL stuff here
	instead of in open_ssl_connection since these only ever need to be
	called once.
	(stream_read): Only use SSL_read if we are in ssl mode.
	(stream_write): Only use SSL_write if we are in ssl mode.

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Check for the
	STARTTLS extension.
	(connect_to_server): Try to use STARTTLS whenever possible rather
	than the old way of doing things.
	(connect_to_server_wrapper): Wrapper around connect_to_server() to
	first try STARTTLS and then attempt normal SSL mode if we can't
	connect via STARTTLS.

	* camel-tcp-stream-ssl.c (camel_tcp_stream_ssl_enable_ssl): New
	function to toggle an ssl stream into ssl mode.
	(camel_tcp_stream_ssl_new_raw): Start the ssl stream off in
	non-ssl mode (useful for STARTTLS).
	(stream_connect): Only connect in SSL mode if required.

2002-03-01  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-vtrash-folder.h: 
	* camel-vee-store.h: 
	* camel-vee-folder.h: 
	* camel-stream-null.h: 
	* camel-stream-filter.h: 
	* camel-store-summary.h: 
	* camel-news-address.h: 
	* camel-mime-utils.h: 
	* camel-mime-parser.h: 
	* camel-mime-filter-save.h: 
	* camel-mime-filter-linewrap.h: 
	* camel-mime-filter-index.h: 
	* camel-mime-filter-html.h: 
	* camel-mime-filter.h: 
	* camel-mime-filter-from.h: 
	* camel-mime-filter-crlf.h: 
	* camel-mime-filter-chomp.h: 
	* camel-mime-filter-charset.h: 
	* camel-mime-filter-bestenc.h: 
	* camel-mime-filter-basic.h: 
	* camel-internet-address.h: 
	* camel-folder-thread.h: 
	* camel-folder-summary.h: 
	* camel-folder-search.h: 
	* camel-filter-driver.h: 
	* camel-charset-map.h: 
	* camel-address.h: Add c++ armoring.

	* camel-object.h: s/class/klass

2002-03-01  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Reverted my
	pgp/mime fixes here too.

	* camel-mime-part.c (write_to_stream): Removed my pgp/mime raw
	stream hack, this is causing problems such as some messages to not
	displaying, view->source not working at all, etc.

2002-02-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-parser.c: Changed offset variables from int's to
	off_t's since the system may support large files.

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Rearrange the
	save filter stuff so that we save raw streams for all mime
	parts. If the mime part turns out to be a multupart, then don't
	bother saving the raw stream, we only need to save the raw stream
	for leaf parts.

2002-02-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.h: Don't #include camel-mime-filter-save.h,
	we don't use it.

	* camel-file-utils.c: Fixed a few 'might be used uninitialized'
	warnings which were real problems.

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Save the raw mime
	stream for any/all signed parts.

	* camel-mime-part.c (camel_mime_part_init): Initialize our raw
	stream to NULL.
	(camel_mime_part_finalize): Unref our raw stream, if we have one.
	(write_to_stream): If we have a raw stream, write that out instead
	of re-encoding.

	* camel-mime-filter-save.[c,h]: Rewritten to save to a stream
	rather than a file.

2002-02-28  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_fold): Use the FOLD_SIZE as a
	recommended folding size, but add a new FOLD_MAX_SIZE (=998, the
	smtp max line size) as the hard limit for any output.

2002-02-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-chomp.c (camel_mime_filter_chomp_new): New
	stream filter that chomps excess trailing whitespace from the end
	of the stream. This is needed to update the PGP/MIME code to
	comply with rfc3156.

	* camel-pgp-mime.c (camel_pgp_mime_part_verify): Don't attach a
	from filter, if it ain't from-filtered already, then we'll just be
	breaking stuff. To become rfc3156 compliant, add a chomp filter
	here.
	(camel_pgp_mime_part_sign): Add a chomp filter here too.

2002-02-27  Not Zed  <NotZed@Ximian.com>

	* camel-mime-part.c (init_header_name_table): Changed header
	formatted table to contain a pointer to an output function, and
	added in-reply-to and references headers.
	(write_references): New function to write out references header,
	folded properly.  It only approximates based on the last >, but it
	should be adequate and will also handle invalid headers.
	(write_fold): Function to write out headers folded.  Since this is
	the default it isn't required.
	(write_raw): Write out an already formatted header, e.g. most of
	the rest.
	(write_to_stream): Lookup header output function, if we have one,
	use that, otherwise fold header using basic (dumb) function.

	This is all for #14779.  A better fix is probably do have the
	headers always stored formatted, but that can wait.

2002-02-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-digest-folder.c (camel_digest_folder_new): Allow all
	multiparts that contain message/rfc822 attachments.
	(digest_get_uids): Only assign uids to message parts.

2002-02-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part.c (camel_mime_part_set_filename): Set the 'name'
	parameter on the Content-Type too. Fixes bug #20779.

2002-02-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (pgp_sign): Pass --always-trust to gpg
	(requested by users).
	(pgp_clearsign): Same.
	(pgp_encrypt): Here too.

2002-02-12  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_helo): Since the
	AUTH token sometimes uses '=' instead of whitespace, don't use
	smtp_token_next here.

2002-02-09  Not Zed  <NotZed@Ximian.com>

	* providers/pop3/camel-pop3-engine.c (get_capabilities): Duh, when
	we grab the apop stamp it needs to include the <> as well, I even
	read the rfc, silly me.

	* providers/pop3/camel-pop3-store.c (pop3_try_authenticate): Doh,
	when iterating the authtype list, it helps to goto the next node.
	Found with help from miles.

2002-02-08  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-summary.c
	(camel_spool_summary_build_from): The day number has to be 2 chars
	wide, space filled to work properly with pine, etc.

	* providers/local/camel-spoold-store.[ch]: new type of provider
	'spool directory', which lets you view external mbox dirs without
	adding any extra cruft.  Perhaps it should use . files to store
	summaries?  Still a bit experimental, there's a warning when you
	select it in the account editor.  Finished off most of #1185.
	Can't rename or move folders.

	* camel-mime-utils.c (header_decode_date): If the date is
	100->1900 then we actually want to use it as the year in the tm
	struct, not year+100.  e.g. year 102 -> 2002, not 2102.

2002-02-07  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-store.c (get_folder): Pass path into
	spool_folder_new.

	* providers/local/camel-spool-folder.c (camel_spool_folder_new): 
	(camel_spool_folder_construct): Take the full path to the folder
	and use that as the file path, independent of the full_name we
	use.

2002-02-07  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-provider.c: Added new type, spoold
	provider, spoold: for local directories.

	* providers/imap/camel-imap-store.c (get_one_folder_offline):
	Create offline uri's in a compatible manner to online ones.

2002-02-07  Dan Winship  <danw@ximian.com>

	* camel-sasl-ntlm.c: Implementation of NTLM (aka "Secure Password
	Authentication") auth, taken from soup.

	* Makefile.am (libcamel_la_SOURCES, libcamel_la_HEADERS): Add
	camel-sasl-ntlm.

	* camel-sasl.c: Add refs to camel-sasl-ntlm.

	* providers/imap/camel-imap-store.c (try_auth): Use
	imap_next_word() to skip over the "+ " of the continuation rather
	than just "resp + 2" since Exchange (incorrectly) returns "+"
	instead of "+ " for an empty continuation response.

2002-02-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.h: Remove the CAMEL_MESSAGE_NEEDS_REPLY
	flag, we no longer will be using this.

2002-02-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-http-stream.c (stream_read): Use camel_mime_parser_read to
	read internal parser data.
	(camel_http_stream_get_content_type): Implemented.
	(http_method_invoke): Use HTTP/1.0 instead of 1.1

	* camel-mime-utils.c (header_decode_int): Made public.

	* camel-http-stream.[c,h]: Added. New stream for HTTP requests
	(currently supported are GET and HEAD).

	* camel-tcp-stream-ssl.c (stream_connect): Call set_errno
	appropriately.

2002-01-31  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_decode_domain): Oops, this was
	converting foo@[blah] to foo@[ blah ], fixed.

2002-01-30  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/pop3/camel-pop3-provider.c: Use "pop" instead of
	"pop3" so current configurations continue to work.

2002-01-30  Not Zed  <NotZed@Ximian.com>

	* camel-sasl-login.c: Changed name from "NT Login" to simply
	"Login".

	* providers/pop3/*: Entirely new pop implmentation, supporting
	pipelining.

2002-01-29  Not Zed  <NotZed@Ximian.com>

	* camel-data-cache.c (free_busy): We dont want to unref the
	stream, instead, stop listening to the finalised events, and free
	the path only.

2002-01-25  Not Zed  <NotZed@Ximian.com>

	* camel-data-cache.c (stream_finalised): Remove the object from
	the busy_stream hashtable, not the busy_path hashtable.

2002-01-29  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_update_summary): Added
	more kludge to an existing Exchange IMAP 5.5 kludge to work around
	it returning multiple messages with the same UIDs.

2002-01-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-message.c (process_header): Handle Resent headers
	too.

	* camel-mime-message.h: Added Resent-* #defines.

	* camel-filter-driver.c (camel_filter_driver_remove_rule_by_name):
	Use while (node->next) instead of while (node)

	* providers/smtp/camel-smtp-transport.c (smtp_decode_status_code):
	New function to decode an enhanced status code.
	(smtp_set_exception): Sets an exception based on the
	Enhanced-Status-Code.
	(esmtp_get_authtypes): Don't diplicate the key in the hash since
	the key and value are the same.
	(smtp_rcpt): Include the failed recipient in the error message to
	be more helpful to the user.

	* camel-mime-utils.c (hex_decode): Make sure to allocate enough
	for the NUL byte.

2002-01-28  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_construct):
	(connect_to_server): Use flags rather than a bunch of gboolean
	variables.
	(smtp_connect): Same.
	(smtp_mail): Here too. Use the enhanced status codes if available.
	(smtp_data): And again here.
	(smtp_helo): Finally here. Also detect the ENHANCEDSTATUSCODES
	extension.
	(smtp_rcpt): Use the enhanced status codes if available.
	(smtp_rset): Here too.
	(smtp_quit): And finally here.

	* camel-transport.h: Removed gboolean supports_8bit since this is
	pretty local to only SMTP for now.

2002-01-24  Ettore Perazzoli  <ettore@ximian.com>

	* Makefile.am: Remove some old cruft.

2002-01-24  Ettore Perazzoli  <ettore@ximian.com>

	* tests/folder/Makefile.am: s/MAILER_LIBS/EVOLUTION_MAIL_LIBS/.
	* tests/message/Makefile.am: Likewise.
	* tests/mime-filter/Makefile.am: Likewise.
	* tests/misc/Makefile.am: Likewise.
	* tests/smime/Makefile.am: Likewise.
	* tests/stream/Makefile.am: Likewise.

2002-01-24  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (do_beep): Call the beep callback
	function.
	(camel_filter_driver_set_system_beep_func): New function to set
	the beep callback.

2002-01-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_remove_rule_by_name):
	New function to remove a filter rule by name.

2002-01-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (do_beep): As a temporary solution, just
	printf ("\a"); to make a beep :-)

	* providers/imap/camel-imap-command.c
	(imap_command_strdup_vprintf): Encode the mailbox to UTF-7 here.

	* providers/imap/camel-imap-utils.c (imap_parse_list_response):
	Decode the mailbox name as we parse the list response.
	(imap_mailbox_decode): It's only an illegal mailbox name if it
	didn't switch back to US-ASCII mode.

2002-01-18  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_mailbox_decode): New
	function to decode an IMAP mailbox name from modified UTF-7
	encoding to UTF-8.
	(imap_mailbox_encode): New function to convert a mailbox name from
	UTF-8 to IMAP's modified UTF-7 encoding.

2002-01-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c (filter): Stop uudecoding once the
	CAMEL_UUDECODE_STATE_END state bit gets set. Set the
	CAMEL_UUDECODE_STATE_BEGIN state bit once we find the begin line.
	(reset): No longer have uu_begin or uulen state variables, these
	are now stuffed into a single state variable.

	* camel-mime-utils.c (uudecode_step): No longer needs a uulen
	argument and also keeps track of whether or not the end of the
	encoded data has been found in 'state'.
	(uuencode_step): Now stuffs uulen into state so that the uulen
	argument is no longer needed.
	(uuencode_close): Same.

2002-01-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c (filter): If we don't want to corrupt
	the uuencoded data by overwriting it with base64 decoded data
	afterward, we need to add a break statement!

	* camel-folder-summary.c (summary_build_content_info): Add code to
	add a uu filter.
	(camel_folder_summary_finalize): Unref the uuencode filter.

2002-01-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c (filter): Fixed slight logic error to
	find the uuencode begin line. Fixes bug #18754.

2002-01-15  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_send_to): Updated to
	match the new send_to API.
	(smtp_send): Get the from address and pass that along to
	smtp_send_to().

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): Updated to match the new send_to API.

	* camel-transport.c (camel_transport_send_to): Now takes a from
	argument too.

	* providers/imap/camel-imap-folder.c (imap_update_summary): Sort
	the needheaders UID array and fixed to respect the
	UID_SET_LIMIT. This should now finish the fixification of bug
	#2529. There's still the possible issue that a command-line (The
	only command-line I can think of that can still be too long is a
	SEARCH command, but this can't possibly be fixed until we rewrite
	the imap code to use Zucchi's ImapEngine idea).

2002-01-14  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_expunge_uids_online):
	Move the command-lock outside the loop.

2002-01-14  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_expunge_uids_online):
	Updated to use the new imap_uid_array_to_set() interface.
	(imap_expunge_uids_resyncing): Same.
	(do_copy): Here too.
	(imap_update_summary): Added a FIXME comment to rewrite allowing
	for a uid-set limitation.
	(get_matching): Copy some of the logic over from
	imap_uid_adday_to_set() to limit the length of the uid-set string.
	(imap_sync_online): Added a comment to explain what is going on
	with get_matching() since the behavior has changed slightly.

	* providers/imap/camel-imap-utils.c (imap_uid_array_to_set):
	Modify the interface so that we can limit the size of the uid set
	string returned.

2002-01-14  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-search.c (imap_body_contains):
	Rewritten to use a cache for body searches when online.  Will need
	some heavy testing but so far seems to be beneficial.

	* providers/imap/camel-imap-folder.c (imap_search_by_expression,
	search_by_uids): dont initialise search object here.
	(camel_imap_folder_new): Setup search object here with pointer to
	cache dir.

2001-12-01  Not Zed  <NotZed@Ximian.com>

	* camel-store-summary.[ch]: New class to store a store's folder
	list in.  Not yet completed.

2002-01-11  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_update_summary): Kludge
	around a bug in Exchange 5.5 that reports 2 messages with the same
	UID. Fixes bug #17694. Replaces the fix from yesterday.

2002-01-10  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-folder.c: If PATH_MAX doesn't exist,
	use _POSIX_PATH_MAX.

	* providers/imap/camel-imap-folder.c (imap_update_summary): If mi
	is NULL, don't bother updating it. Should fix bug #17694.

2002-01-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel.h: #include camel-mime-filter-tohtml.h

	* providers/imap/camel-imap-folder.c (imap_update_summary): Kludge
	around Microsoft Exchange 5.5 (bug #5348) by forgetting our
	currently selected folder and re-SELECTing it so that the Exchange
	server has a chance to realise it has new messages.

2002-01-09  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): If the mbox file is a symlink,
	follow the symlink and get the One True Path so that we can
	rewrite the mbox later without worrying about clobbering the
	symlink.

2002-01-08  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-search.c (TODO): There are a few sexp callbacks
	that could be modified to use fms->info rather than using a
	message object (like date and possibly mlist stuff) but *only* if
	the date exists on the CamelMessageInfo object (since it may be
	blank except for message flags).
	(camel_filter_search_get_message): New internal convenience
	function to make sure that the FilterMessageSearch has loaded the
	message (and to load the message if this isn't the case).
	(check_header): Call camel_filter_search_get_message().
	(header_exists): Same.
	(header_regex): Here too.
	(header_full_regex): And here.
	(body_contains): Again here.
	(body_regex): Here too.
	(get_sent_date): Here also.
	(get_received_date): Same.
	(get_source): Here if we need to.
	(camel_filter_search_match): Now takes a callback function/data
	pair for on-demand message loading so that we don't necessarily
	have to load the message if the defined filter rules don't require
	it.

	* camel-filter-driver.c (camel_filter_driver_filter_folder): Don't
	bother fetching the message here, let
	camel_filter_driver_filter_message() worry about this.
	(get_message_cb): New utility callback to fetch a message.
	(camel_filter_driver_filter_message): Only fetch the message if we
	absolutely need it to get a CamelMessageInfo. Instead of passing a
	message object to camel_filter_search_match(), pass get_message_cb
	and some user_data so that the matching code can fetch the message
	on demand.

2002-01-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder.c (filter_filter): Flush the only-once actions.

	* camel-filter-driver.c (camel_filter_driver_filter_message):
	Don't increment a filtered_count here any longer.
	(camel_filter_driver_reset_filtered_count): Removed.
	(camel_filter_driver_get_filtered_count): Removed.
	(do_beep): New action.
	(play_sound): New action to play a sound
	(do_only_once): Another new action.
	(camel_filter_driver_finalise): Free the only_once hash if the
	driver has not been "flushed".
	(camel_filter_driver_flush): Flush all of the only-once actions.

	* camel-charset-map.c: Moved windows-1251 to the end of the list
	since it contains the euro and we'd prefer to use iso-8859-15 when
	the euro is requested than a windows charset if possible.

	* camel-charset-map-private.h: Regenerated.

2001-12-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-summary.c (content_info_load): Don't try setting a
	content-type parameter if either the name or value is NULL.

	* camel-mime-utils.c (header_set_param): NULL-protection.

2002-01-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (ssl_bad_cert): Do more like what mutt
	does so hopefully this'll fix bug #16363 and #16300.

2001-12-21  Jeffrey Stedfast  <fejj@ximian.com>

	* broken-date-parser.c (parse_broken_date): Completely
	rewritten. It is now a load faster and a heck of a lot more
	accurate, also now returns a time_t and sets the saveoffset
	variable rather than returning a new char* buffer for the normal
	camel date parser to re-parse. This saves a fair number of cpu
	cycles :-)

	* camel-mime-utils.c (header_decode_date): Cleanup the broken date
	parsing code.

2001-12-20  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-address.h: Change the prototype for camel_address_get_type
	to return a CamelType (since internally this is what it returns
	and also in case we decide to write a replacement for the current
	CamelObject it'd be easier to drop in).

	* camel-internet-address.h: Same but for
	camel_internet_address_get_type()

	* providers/smtp/camel-smtp-transport.c (smtp_send_to): Updated to
	use a CamelAddress of recipients.
	(smtp_send): Since smtp_send_to now takes a CamelAddress
	recipients argument, our lives have been simplified and we can now
	just concat To/Cc/Bcc into a recipients addr and send away.

	* providers/sendmail/camel-sendmail-transport.c
	(sendmail_send_to): Updated to use a CamelAddress of recipients.

	* camel-transport.c (camel_transport_send_to): Now takes a
	CamelAddress argument for the recipient list rather than a GList.

2001-12-19  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/Makefile.am: Remove the providerdir variable.

	* providers/sendmail/Makefile.am: Same.

2001-12-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_iso_to_windows): New function
	to map ISO charsets to the Windows charsets.

	* camel-mime-part-utils.c (broken_windows_charset): Detect Windows
	charsets.
	(simple_data_wrapper_construct_from_parser): Simplify a tad and
	also check for iso-8859-* charsets that are really Windows
	charsets. Fixes bug #12631.

2001-12-17  Dan Winship  <danw@ximian.com>

	* Makefile.am (INCLUDES): define CAMEL_PROVIDERDIR to be the
	configure.in-defined camel_providerdir.

	* providers/Makefile.am: Remove some outdated comments

	* providers/imap/Makefile.am (camel_provider_LTLIBRARIES,
	camel_provider_DATA): renamed from provider_LTLIBRARIES,
	provider_DATA.  

	* providers/local/Makefile.am: Likewise 

	* providers/nntp/Makefile.am: Likewise 

	* providers/pop3/Makefile.am: Likewise 

	* providers/sendmail/Makefile.am: Likewise 

	* providers/smtp/Makefile.am: Likewise

2001-12-16  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (get_content): Reverted my
	previous changes here since it doesn't actually work afterall.

	* providers/imap/camel-imap-wrapper.c (imap_wrapper_hydrate):
	Update to do uudecoding when appropriate.

2001-12-16  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (get_content): Try to use the
	original boundary so luis will stop bugging me about "data
	corruption". Also preserve other params in the multipart
	content-type by dumping it to a string and setting it on the mime
	part.

2001-12-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c
	(camel_filter_driver_reset_filtered_count): Reset the
	filtered_count to zero.
	(camel_filter_driver_get_filtered_count): Return the private
	filtered_count value.
	(camel_filter_driver_filter_message): Increment the
	filtered_count.
	(camel_filter_driver_set_shell_exec_func): New function to set the
	shell-exec func.
	(shell_exec): New ESExp filter action callback.

2001-12-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_verify): Removed
	x-inline-pgp-hack kludge because it doesn't work.
	(camel_pgp_mime_part_decrypt): Same.

2001-12-13  Chris Toshok  <toshok@ximian.com>

	* camel-data-cache.c: include stdlib.h (for alloca on freebsd) and
	only include alloca.h if HAVE_ALLOCA_H is defined.

2001-12-11  Zbigniew Chyla  <cyba@gnome.pl>

	Fixes #17085

	* camel-charset-map.c: Added #include <errno.h>.

	* camel-charset-map-private.h:
	Recreated (following instructions from camel-charset-map.c)

2001-12-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-object.c (camel_type_register): Keep a name-to-type hash
	so that we can make sure that the type has not yet been registered
	(prevents a race condition such as the one in bug #16559).

	* camel-service.c (camel_service_connect): Make sure that the
	connect_op is non-NULL before unregistering/unreffing it.

2001-12-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_content_type_simple): Protect against
	either of the types being NULL.

2001-12-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c (filter): If complete() allocates
	len+2 bytes for the out buffer, so should this. See bug #16371 for
	an example case.

2001-12-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-sasl-digest-md5.c: iconv() returns a size_t, not an int.

	* camel-pgp-context.c: The return value of iconv() is a size_t,
	not an int.

	* camel-mime-part-utils.c (convert_buffer): Always use size_t args
	for iconv().

	* camel-mime-filter-charset.c (complete): Always use size_t args
	for iconv().
	(filter): Same.

	* camel-mime-utils.c (header_address_fold): Make headerlen a
	size_t instead of an int.
	(header_fold): Same.
	(base64_encode_close): We should be returning a size_t and inlen
	should also be a size_t.
	(base64_encode_step): Same here.
	(base64_decode_step): Here too.
	(base64_encode_simple): And here...
	(base64_decode_simple): Same.
	(uuencode_close): We should also use size_t's here...
	(uuencode_step): And here too.
	(uudecode_step): And also here.
	(quoted_encode_close): Same idea here.
	(quoted_encode_step): Again here.
	(quoted_decode_step): Here too.
	(quoted_encode): Input length should be a size_t.
	(rfc2047_decode_word): Same.
	(g_string_append_len): Here too.
	(append_8bit): "
	(rfc2047_encode_word): "
	(quote_word): "
	(hex_decode): "
	(rfc2184_decode): Use size_t's with iconv().
	(header_decode_param): Same.

2001-12-09  Jon Trowbridge  <trow@ximian.com>

	* camel-folder-summary.c: Add "NeedsReply" to the flag_names array
	for CAMEL_MESSAGE_NEEDS_REPLY.

	* camel-folder-summary.h: Added CAMEL_MESSAGE_NEEDS_REPLY flag.

2001-12-07  Dan Winship  <danw@ximian.com>

	* camel-mime-message.c (camel_mime_message_set_date): Fix the
	tm_gmtoff case (its sign is the opposite of "timezone"). Fixes
	#14678

2001-11-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder-search.c (search_body_contains): Don't use regex
	matching. Fixes bug #16227.

	* camel-mime-message.c (best_encoding): Check the content-object's
	mime type, not the mime part types. Should fix bug #15843.

2001-11-27  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (get_content): Return NULL if
	construct_from_stream fails.
	(get_message): Same.
	(get_message_simple): Here too.
	(add_message_from_data): And here.

2001-11-14  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (folder_changed_remove_uid): Use the uid
	rather than vuid for unmatched.  Also add the uid to unmatched if
	it wasn't in the unmatched_uids table at all.
	(folder_changed_change): If checking for added, if the new ones
	dont match, then try to add them to unmatched.  Fixes #6893.

	* camel-folder-summary.c (camel_folder_summary_index): Change lock
	order, always summary_lock before ref_lock.
	(camel_folder_summary_array): "
	(camel_folder_summary_uid): "
	(camel_folder_summary_remove_uid): " Fixes a deadlock.

2001-11-30  Not Zed  <NotZed@Ximian.com>
  
	* providers/nntp/camel-nntp-*.c: Completely new implementation of
	NNTP.
	
	Doesn't support subscriptions yet (lists all folders), but should
	be more reliable (faster?), and has an integrated cache.

	* camel-exception.c (camel_exception_new): Use e_memchunks for
	exception blocks.
	(camel_exception_free): Same.

	* camel-data-cache.[ch]: New object for managing on-disk caches of
	anything that can be stored in a camel-stream.

	* camel-file-utils.c (camel_file_util_mkdir): New function, just a
	nicer place to put this (than camel-store), should be removed from
	camel-store.
	(camel_file_util_safe_filename): New function to url-encode a
	filename.

	* camel-mime-parser.c (drop_states): New func to drop the parser
	state to initial state.
	(folder_scan_init_with_fd): 
	(folder_scan_init_with_stream): Call above func to reset state if
	the stream is changed on us so we can change streams to reuse a
	parser object.

2001-11-25  Not Zed  <NotZed@Ximian.com>

	* providers/nntp/camel-nntp-folder.c (nntp_folder_get_message): If
	the uid doesn't have a ',' in it, fail to crash.

	* providers/nntp/camel-nntp-newsrc.c
	(camel_nntp_newsrc_article_is_read): check group != NULL before
	scanning.
	(camel_nntp_newsrc_get_highest_article_read): "
	(camel_nntp_newsrc_get_num_articles_read): "
	(camel_nntp_newsrc_mark_range_read): "

	* providers/nntp/camel-nntp-store.c
	(camel_nntp_store_get_overview_fmt): IF we dont have
	nntp_list_follows, dont try and get a list response.
	(nntp_store_get_folder_info): Set path part of folderinfo.

2001-11-20  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (get_smtp_error_string):
	Check to see that errno is non-zero before returning
	g_strerror. If it's 0, then we have an unknown error.

2001-11-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c: For the uudecoding mode, garble up
	the "begin <mode> <filename>" line before decoding.

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Add a uudecoder if
	the transfer encoding is x-uuencode.

	* camel-mime-part.c (write_to_stream): Handle x-uuencoded content
	too.

2001-11-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (stream_read): Added a check to see if
	the operation has been cancelled.
	(stream_write): Same.

2001-11-19  Jeffrey Stedfast  <fejj@ximian.com>

	Updates for compliance with rfc2231

	* camel-mime-utils.c (header_encode_param):
	camel_mime_special_table[c] & IS_ESAFE should have been
	!(camel_mime_special_table[c] & IS_ESAFE). Also added a few
	comments for how to improve the code at some future date.
	(header_decode_param): Now takes an argument rfc2184_part so our
	caller can get this information as well.
	(header_decode_param_list): Pass an rfc2184_part argument to
	header_decode_param and also added a few comments on where to
	improve on rfc2184/rfc2231 compliance.
	(rfc2047_decode_word): Updated to respect the updated ABNF syntax
	of rfc2047 encoded words, yay.

2001-11-16  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-utils.c (imap_parse_body): Abort if
	body == NULL.

	* camel-mime-filter-tohtml.c (camel_mime_filter_tohtml_new): New
	mime filter to convert plain text to html.

2001-11-16  Jeffrey Stedfast  <fejj@ximian.com>

	Since some mail clients like Outlook are broken, we need to set a
	name parameter on pgp signed and encrypted parts.

	* camel-pgp-mime.c (camel_pgp_mime_part_encrypt): Set a name
	parameter.
	(camel_pgp_mime_part_sign): Same.

2001-11-14  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-command.c
	(camel_imap_command_response): If we get a BYE response, call
	camel_service_disconnect() and set an exception. Also do the check
	for "* BYE" first instead of passing it off imap_read_untagged()
	since we'll just waste time in there mallocing left and right only
	to arrive at the single response line "* BYE" again :-)

2001-11-13  Not Zed  <NotZed@Ximian.com>

	* camel-filter-search.c (get_source): If we have no source string,
	then use undefined, which should always evaluate to FALSE.  Fix
	for #15267.

2001-11-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-store.c (camel_store_get_folder): Added a
	g_return_val_if_fail for folder_name != NULL.

2001-11-08  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (crypto_exec_with_passwd): If any of the
	pipe()'s fail, clean up any pipes that may have succeeded. Also
	close the password fds.

2001-11-09  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (imap_auth_loop): If we get a
	user cancel and that causes us to fail to authenticate, abort
	rather than loop forever.  Fix for #14951.

2001-11-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-command.c
	(camel_imap_command_continuation): Now takes a command-length
	argument so we can 1) avoid duping the command string yet again,
	yay. 2) we now don't have to worry about embedded nul-chars
	screwing us over (we still need to avoid allowing them into the
	string but at least now it won't mess us up).

	* providers/imap/camel-imap-folder.c (do_append): Instead of
	appending a nul char to the end of the byte array and then passing
	that off as if it were a string to
	camel_imap_command_continuation, instead pass the byte-array
	length since that function now takes a length argument. Yay.  Also
	encode any 8bit parts to avoid the possibility of sending embedded
	nul chars to the imap server.

	* providers/imap/camel-imap-store.c (try_auth): Updated to pass a
	command-length argument to camel_imap_command_continuation().

2001-11-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (save_ssl_cert): Oops, pass a mode
	argument to the open() call.

	* camel-tcp-stream-openssl.c (save_ssl_cert): Oops, pass a mode
	argument to the open() call.

2001-11-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_decrypt): Add code to
	kludge around any x-inline-pgp-hacks by prepending some content
	headers to the decrypted data.

2001-11-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-data-wrapper.c (camel_data_wrapper_init): Initialize our
	private mutex.
	(camel_data_wrapper_finalize): Destroy our private mutex.
	(write_to_stream): Lock around camel_stream_write_to_stream() so
	that we don't get 2 threads trying to read from our stream at the
	same time.

2001-11-01  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (folder_changed_change): Move all searching
	operations outside of any locks except subfolder lock, same as
	build_folder.  Fix for #14294.

2001-10-31  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-folder.c (spool_get_message): Same
	as below.

	* providers/local/camel-maildir-folder.c (maildir_get_message):
	Same as below.

	* providers/local/camel-mbox-folder.c (mbox_get_message): Set
	USER_CANCEL if failed due to EINTR.

	* camel-filter-driver.c (camel_filter_driver_filter_mbox): If
	construct from parser fails due to user cancel, set USER_CANCEL on
	exception.

	* camel-mime-part.c (construct_from_parser): Return error if the
	parser had an io error.

	* camel-mime-message.c (construct_from_parser): Check error on
	parser/return error.

	* camel-mime-parser.c (folder_scan_init): Init error number.
	(camel_mime_parser_errno): New function, return errno of any io
	failures.
	(folder_read): Set errno if a failure occured.
	(folder_seek): Same.
	(folder_scan_init_with_fd): Setup errno depeding on ok/failure.
	(folder_scan_init_with_stream): Same.

2001-10-30  Not Zed  <NotZed@Ximian.com>

	* camel-operation.c (camel_operation_new): Dont setup cancel_fd.
	(camel_operation_cancel_fd): If cancel_fd not created, set it up.
	(camel_operation_cancel): Set cancel flag before sending message.
	(cancel_thread): Same.

	* camel-filter-driver.c (camel_filter_driver_filter_mbox): Make
	sure we unref the mimeparse when we're done (successfully).  This
	was leaking an fd every get-mail! :(

	* camel-lock-client.c (camel_lock_helper_init): Close all fd's
	above 2.

	* providers/local/camel-mbox-folder.c (mbox_get_message): Remove
	the X-Evolution header before anyone else gets to see this private
	thing.  Shoudl fix 11676 since we were inheriting flags from
	X-Evolution headers we didn't want to.

	* camel-folder-search.c (match_message): If we can't retrieve the
	message, ignore it, it can't match.

	* providers/imap/camel-imap-search.c
	(camel_imap_search_class_init): Setup parent class pointer.
	(imap_body_contains): If offline, just use the parent
	body_contains method which will get the messages and search them
	manually.

	* providers/imap/camel-imap-folder.c (imap_search_by_expression,
	imap_search_by_uids): Remove offline check.

2001-10-30  Dan Winship  <danw@ximian.com>

	* camel-mime-part.c (free_headers): Fix this to match get_headers.

2001-10-30  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-store.c (rename_folder): Dont try to
	move ibex if we have none.

	* camel-tcp-stream-openssl.c (stream_write): Fixed compilation
	errors.

2001-10-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (camel_mime_utils_init): Removed unused
	variable.

2001-10-30  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_decode_mailbox): w(x) out some warnings.

	* providers/local/camel-local-summary.c
	(camel_local_summary_load): Remove the warning about not loading
	summary file - its a valid case for new folders.

2001-10-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (my_SSL_write): Removed.
	(stream_write): Keep looping (non-blocking case) if errno is
	EAGAIN, EINTR or EWOULDBLOCK. For NONBLOCKing I/O, sync up with
	CamelTcpStreamRaw. As with CamelTcpStreamRaw/SSL - make sure to
	write out everything before returning.
	(my_SSL_read): Removed.
	(stream_read): Just call ssl_error_to_errno() and check the errno
	values that we care about so we can keep the general look of all
	this stream code the same. Also when checking the return value of
	SSL_read, check for <0 instead of ==-1 since the man page for
	SSL_read doesn't say it will return -1 on fail, it just says <0.
	(stream_flush): Don't fsync() since syncing on a socket is a Bad
	Thing (tm).

	* camel-tcp-stream-ssl.c (stream_write): Make sure we write out
	everything just like in camel-tcp-stream-raw.c.

	* camel-stream-buffer.c (camel_stream_buffer_gets): If
	camel_stream_read() returns -1, don't necessarily return -1 to our
	caller since it's possible that we did actually "read" some data
	(ie, we copied some pre-buffered data into the out buffer).

	* camel-stream-buffer.h: Removed CAMEL_STREAM_BUFFER_NEWLINE since
	it never got used anywhere and it isn't supported anyway.

2001-10-30  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c
	(parse_list_response_as_folder_info): If we get an empty name,
	then mark that as NoSelect.  Workaround fix for #13239.

2001-10-29  Dan Winship  <danw@ximian.com>

	* providers/imap/camel-imap-folder.c (get_message_simple, 
	imap_get_message): Set an X-Evolution-Source header on the
	returned message so replies come from the right identity.

2001-10-29  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (folder_changed_change): If we're not going
	to search on a changed uid, make sure we change out copy still.
	Fixes #13916.

2001-10-29  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (subscribe_folder): Don't emit
	a folder_subscribed signal if we are in the process of renaming
	folders.
	(unsubscribe_folder): Same here but for the unsubscribe signal.
	(rename_folder): Unsubscribe from the folder being renamed and any
	subfolders it may have before actually renaming. Once the folder
	has been renamed, re-subscribe to it and it's subfolders with the
	new name.

	* camel-store.c (camel_folder_info_build): Sort the folder info's
	before constructing the tree.

	* camel-mime-utils.c (header_decode_param): Minor fix - should
	have been using a strNcmp when checking if it was an rfc2047
	encoded word.

	* camel-pgp-context.c (pgp_sign): Notify the user that PGP 2.6.x
	is no longer supported and use camel_exception_set() instead of
	setv() where appropriate.
	(pgp_clearsign): Same.
	(pgp_verify): And again here.
	(pgp_encrypt): Here too.
	(pgp_decrypt): And finally here.

2001-10-29  Dan Winship  <danw@ximian.com>

	* providers/imap/camel-imap-store.c (unsubscribe_folder): Don't
	free the hash table key if the folder wasn't found in the hash
	table. I'm not sure where the bug is/was that made it possible to
	add a folder to the tree after creating it failed, but now if that
	happens, it won't crash if you try to delete it again. (#11492)

	* camel-disco-store.c (camel_disco_store_status): if the service
	is being connected and thinks it's online, but the session is
	offline, then mark the service offline as well. Fixes 13683.

2001-10-29  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c: Turn off w() -> warnings.

	* providers/imap/camel-imap-store.c (rename_folder): Also rename
	the message cache.
	(rename_folder): Fix subscribed folders table with rename(s).

	* providers/imap/camel-imap-folder.c (imap_rename): Implement,
	rename the cache dir pointer.

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_set_path): New method to set the path
	used by a message cache.

	* camel-vee-store.c (build_info): Fix the 'is this a matching
	subfolder or subfolder' logic to match camel-store
	get_subfolders'.

	* camel-store.c (get_subfolders): Fix the 'is this a matching
	folder or subfolder' logic.

2001-10-28  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-store.c (rename_folder): Changed to
	call ibex_move to rename it internally.

	* camel-store.c (camel_store_rename_folder): Use the right
	variable, not info.

2001-10-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-stream-buffer.c (camel_stream_buffer_read_line): Make sure
	we've actually read data before checking if p[-] is '\r' or not.

	* camel-tcp-stream-raw.c (stream_write): Same.

	* camel-stream-fs.c (stream_write): If errno isn't EAGAIN, just
	exit with -1 and instead of using continue (which doesn't go to
	the top of the do-while thus making our logic suck), just set w to
	0. Still seems to be a bug in select() if it's telling us the
	socket is ready for data when it really isn't but oh well.

2001-10-28  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): Use path not protocol as the path
	part of the uri of the folder_created event.

	* providers/local/camel-maildir-store.c (scan_dir): If FAST is
	set, dont try and scan for unread counts.

	* providers/local/camel-local-store.c (create_folder): Implement,
	just return the folderinfo of the folder matched, not all of it.

	* camel-store.c (camel_store_rename_folder): Rename the
	camelfolders before emitting the folderchanged event (otherwise
	vstore fails to pick up change.

2001-10-27  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (camel_store_init): Always use a default dir_sep
	of '/'.

	* camel-store.h (struct _CamelStore): Added a dir_sep to the base
	store so rename and whatnot can work, temporary fix for mixed dir
	separator in folder name api's.

	* providers/imap/camel-imap-store.c (rename_folder): Finished
	implementation.
	(imap_connect_online): Also set the store's dir_sep here.
	(imap_connect_offline): "

	* providers/local/camel-local-folder.c (local_rename): Implement
	local rename of folder objects.

2001-10-26  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (camel_vee_folder_class_init): Hook into
	rename function.
	(vee_rename): Implement the veefolder rename function.
	(camel_vee_folder_class_init): 
	(folder_changed_change): Kill a warning with a cast.

	* camel-vee-store.c (vee_rename_folder): Emit a folder_renamed
	event properly, also call parent to do some rename stuff.

	* camel-store.h: Added a CamelRenameInfo for the rename event.

	* camel-folder.c (camel_folder_rename): New function to rename a
	folder object.
	(camel_folder_class_init): Added a renamed event.
	(folder_rename): Default impl, set full_name, and set name
	assuming the dir separator is '/'.

	* camel-store.c (camel_store_class_init): Added folder_renamed
	event.
	(camel_store_rename_folder): Rename an active folder object if we
	have one, and update the folder table.
	(rename_folder): Make a default implementation that handles
	updating the folder tree.

2001-10-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (delete_folder): Don't bother
	checking ex since we can rely on the response being NULL on error.
	(rename_folder): Implemented.

2001-10-26  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-folder.c (imap_get_message): Check to
	make sure that the dataset is non-NULL before using and/or
	freeing.

	* camel-tcp-stream-raw.c (stream_write): Check for EWOULDBLOCK
	too?
	(stream_read): Same.
	(stream_flush): Return 0 always, fsync() and tcp sockets don't
	play nice :-)

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_get): Lets try putting a
	camel_stream_reset() here. Logic being that the stream may have
	been read from since it was cached and thus our caller may try
	reading from it and get no data from it since it is already at the
	EOS. This may fix bug #12943.

2001-10-25  Not Zed  <NotZed@Ximian.com>

	* camel-search-private.c (utf8_get): Remove the stupid warning
	that should never have been there in the first place.

	* camel-sasl-digest-md5.c (digest_response): s/iconv/e_iconv/

	* camel-pgp-context.c (pgp_verify): "

	* camel-mime-utils.c (rfc2047_decode_word, rfc2047_decode_word,
	append_8bit, rfc2047_encode_word, rfc2184_decode,
	header_decode_param): "

	* camel-mime-part-utils.c (convert_buffer, convert_buffer): "

	* camel-mime-filter-charset.c (reset, complete, filter): "

2001-10-24  Not Zed  <NotZed@Ximian.com>

	* camel-mime-filter-basic.c (complete): For qp decoding, if the
	data isn't really qp encoded, we could possible grow the buffer by
	upto 2 bytes above the input size, fix allocations/assertions
	appropraitely.

	* camel-vee-folder.c (folder_changed_change): If we're not
	autoupdate, only search for new matches against changed uid's that
	we dont already have.

2001-10-24  Dan Winship  <danw@ximian.com>

	* providers/imap/camel-imap-store.c (unsubscribe_folder): Don't
	let fi->name be NULL.

2001-10-24  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-stream-fs.c (stream_read): Same as in the TcpStreamRaw code.
	(stream_write): And again here...

	* camel-tcp-stream-raw.c (stream_read): Handle the EAGAIN error
	case as well.
	(stream_write): Same here, this might fix the SMTP truncation
	thing? I hope?

2001-10-23  Dan Winship  <danw@ximian.com>

	* camel-mime-utils.c (mail_list_magic): Remove an extra * in one
	of the regexps that glibc apparently doesn't mind but bsd does.

2001-10-23  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-mbox-summary.c: made d(x) x recompile again.

2001-10-22  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-summary.c (summary_rebuild): No, use
	Storing, as the other code does :p
	(spool_summary_check): Check for consistency.

2001-10-22  Jon Trowbridge  <trow@ximian.com>

	* providers/local/camel-spool-summary.c (summary_rebuild):
	s/summarising/summarizing/.
	(spool_summary_check): s/summarise/summarize/.

2001-10-22  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_verify): If we are
	kludging around a inline-pgp signed part, do some charset
	conversion to protect any 8bit text.

2001-10-22  Not Zed  <NotZed@Ximian.com>

	* camel-filter-search.c, camel-folder-search.c (check_header): Use
	search_type_mlist for mailing list searches.

	* camel.c (camel_init): call camel-mime-utils-init func.

	* camel-mime-utils.c: Changed mail mail_list_magic to include a
	domain part, also pre-compile all the patterns.  They are all
	backward compatible except List-Id: which now uses the
	mail-address-like <list-name.host.name> part rather than the
	plain-text part (which might've been blank anyway).
	(camel_mime_utils_init): Initialisation function to setup any
	static data required by camel-mime-utils at run-time.  We now
	setup the base64/charset class tables here, so it doesn't need to
	be done statically.
	(camel_mime_special_table, camel_mime_base64_rank): No longer
	statically initialise these.
	(main): Removed + the tests at the end of the file.
	(header_raw_check_mailing_list): Dont compile regex's here,
	already compiled in utils_init.  Use the regex patterns to remove
	leading <'s from addresses.  Also, if there is a domain part
	matched, add that after a '@' is added.

	* camel-search-private.c (camel_search_header_match): Match check
	against all addresses in a multiple address match.  Should fix
	#13051.
	(camel_search_header_match): Oops, missing i=0.
	(camel_search_header_match): Added SEARCH_TYPE_MLIST for mlist
	search types.  It ignores the domain part if either (but not both)
	of the values dont have it.

2001-10-22  Dan Winship  <danw@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_verify): Add a hack: if
	the multipart/signed part has a "x-inline-pgp-hack" parameter in
	its Content-Type, don't pass the MIME headers as part of the data
	to be verified.

2001-10-22  Rodrigo Moya <rodrigo@ximian.com>

	* Makefile.am: added $GNOME_INCLUDEDIR to INCLUDES, needed for latest
	libgnome, which install headers in $(prefix)/gnome-1.0

2001-10-21  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Only do the rawtext
	checks if the part is a text part, otherwise don't bother wasting
	cpu cycles.

	* camel-store.c (camel_folder_info_build): Updated comments to
	make the code a bit more clear.

2001-10-21  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (CS_CLASS): Dont do the macro stuff - basically so
	you can actually debug calls.
	(camel_store_uri_cmp): New function to compare store objects.

	* camel-vee-folder.c (vee_folder_add_info): oops, dont free the
	vuid, since its alloca'd now.
	(folder_changed_change): Kill a compile warning.

2001-10-20  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (move_messages_to): If no exception supplied, use
	a local one.
	(move_message_to): Set the seen flag also when we delete it.

2001-10-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-vtrash-folder.c (vtrash_move_messages_to): If the
	destination folder is the vfolder source folder, then
	set_message_flags on it.

2001-10-19  Not Zed  <NotZed@Ximian.com>

	* camel-session.c (register_provider): When registering provider,
	translate all strings.

	* camel-vee-folder.c (camel_vee_folder_remove_folder): Lock the
	right lock for unmatched subfolder list stuff.  If the sub folder
	is deleted & part of unmatched, or the last ref to the sub folder
	is gone from unmatched, blow it away completely from unmatched,
	but only do it once.
	(vee_folder_remove_folder): Added arg to kill unmatched
	unconditionally.  Also handle deleted folders, always remove
	stuff.
	(folder_changed_change): Lock subfolder lock for entirety of
	operation, and also check to see if the subfolder is still there
	before doing any fancy work (incase it got removed while we were
	waiting to execute).
	(folder_changed_change_uid): Use alloca for vuid, and not
	sprintf(".lengths")
	(vee_search_by_expression): Dont use sprintf for vuid.
	(vee_search_by_uids): "
	(vee_folder_add_info): "
	(folder_changed_remove_uid): "
	(folder_changed_change): "
	(folder_changed_change_uid): Also check folder_unmatched for
	changed uid's so we properly update/propagate unmatched changes.
	(folder_changed_change): Ok, so dont hold the subfolder lock for
	the whole duration of the changed event, although we probably
	should, requires a recursive mutex.
	(folder_changed_change): Change logic, we always add changed stuff
	if it now matches, but dont remove it unless its auto-remove, only
	propagate changes for it.
	(vee_set_message_flags): Call parent method after doing our work.
	(vee_set_message_user_flag): Same here.

2001-10-18  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): If a charset isn't
	specified or claims to be utf-8, check the validity of the text
	and if it's invalid, set the rawtext bit to TRUE. If the charset
	is x-unknown or some other x- charset, always set the rawtext bit
	to TRUE.

2001-10-18  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (camel_store_unsubscribe_folder): If we are
	unsubscribing from a folder we have loaded, set the folder
	deleted, as with the delete_folder case.

	* providers/(imap|local|pop3|sendmail|smtp)/Makefile.am: Added
	CAMEL_CFLAGS so we get the right iconv stuff, patch from Yanko
	Kaneti <yaneti@declera.com>

2001-10-18  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (crypto_exec_with_passwd): Make sure the
	cancel_fd isn't -1.

2001-10-18  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-message-cache.c (insert_finish): Flush
	the stream here, not sure it really matters but it might
	(hopefully) fix bug #12943.

	* camel-pgp-context.c (crypto_exec_with_passwd): Make
	user-cancellable.

	* providers/local/camel-local-provider.c: String cleanup for bug
	#6640.

	* providers/imap/camel-imap-folder.c (imap_sync_online): Fix my
	Cyrus imapd workaround...instead of checking to see if info->flags
	== FLAGGED, just check to see if it contains any IMAP flags.

2001-10-17  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-folder.c
	(camel_maildir_folder_new): Use '.' as the inbox name for filter
	new messages test.

	* camel-store.c (camel_folder_info_clone): New function to clone a
	folderinfo tree.

2001-10-17  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-mh-folder.c (mh_append_message): Same as
	maildir and mbox append-message.

	* providers/local/camel-maildir-folder.c (maildir_append_message):
	Same as mbox append.

	* camel-exception.c (camel_exception_set): Make sure the new
	description isn't the same as the old description pointer before
	freeing the old one.
	(camel_exception_setv): Don't free the old description until we
	set the new one this way we can reuse the old description in the
	new description.

	* providers/local/camel-mbox-folder.c (mbox_append_message): If
	errno == EINTR, then we got a user-cancel so set the exception
	appropriately so that we don't make the user shit his pants.

	* camel-filter-driver.c (do_copy): Add an optimization for when
	destination folder is the same as the source folder.

2001-10-17  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (get_folder_info_online):
	(parse_list_response_as_folder_info): Patch from Danw, Use unread
	count of -1 to mark unflagged messages.  Make sure any folder we
	dont lookup explicitly is marked as -1.  Should fix #9947 and
	friends.

	* providers/local/camel-mbox-summary.c (mbox_summary_sync): Only
	touch the summary if the timestamp or size changed.

2001-10-17  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_message): Set
	the DELETED flag on directly on the info if the source folder
	doesn't have summary capability.

2001-10-17  Not Zed  <NotZed@Ximian.com>

	* camel-tcp-stream-raw.c (stream_write): As below.

	* camel-stream-fs.c (stream_write): If not checking cancellation,
	make sure we write out everything asked of us.

2001-10-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (pgp_verify): Rearange the order of the gpg
	options slightly otherwise it might try to use "--no-tty" as the
	filename to verify :-)

	* camel-object.[c,h]: If CAMEL_DEBUG is defined, print some useful
	ref/unref info.

	* providers/imap/camel-imap-store.c (delete_folder): Fixed an
	assignment warning.

	* camel-uid-cache.c (camel_uid_cache_new): Make sure that the
	parent directory exists before trying to open the filename, if it
	doesn't, create it.

2001-10-16  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_address_decode): If no content, dont
	try and decode further and spit meaningless warnings.

2001-10-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (do_flag): Only perform the operation on
	the folder if the folder has summary capability, else just poke
	the info directly. Fixes the "Filters don't work" bug.
	(do_score): Same.
	(do_colour): And here too.

2001-10-15  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-stream-fs.c (stream_read): Save the errno before calling
	fcntl so fcntl doesn't overwrite errno in case of a previous
	error.
	(stream_write): Same.

2001-10-13  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/smtp/camel-smtp-transport.c (smtp_data): Replace the
	Bcc headers in a single location and don't flush the data unless
	the write was successful.

2001-10-12  Jeffrey Stedfast  <fejj@ximian.com>

	* Makefile.am: Remove the stripheader filter from the build.

	* camel-mime-filter-stripheader.[c,h]: Removed.

	* providers/smtp/camel-smtp-transport.c (smtp_data): Check the
	return value of camel_stream_flush to make sure it flushed the
	data successfully before continuing. Don't use the stripheader
	filter, it was completely broken - instead remove the header and
	set it again after we send.

2001-10-12  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (camel_vee_folder_remove_folder): Unhook from
	all events before removing folder.
	(camel_vee_folder_add_folder): Hook onto delete event.
	(camel_vee_folder_finalise): Unhook from deleted event for suibfolder.
	(subfolder_deleted): When the folder is deleted, remove it from
	the vfolder automagically.

2001-10-11  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (vee_search_by_uids): convert the uids list
	to a subset appropriate for each subfolder before trying to search
	on it.

	* camel-charset-map.[ch]: Removed charset/locale charset lookup
	and iconv_open/close functions, moved to gal.  Fixed all callers.

2001-10-11  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (ssl_cert_is_saved): Same.

	* camel-tcp-stream-openssl.c (ssl_cert_is_saved): Instead of
	opening the file, stat it and make sure that it belongs to us.

2001-10-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (ssl_verify): Same hack as below.

	* camel-tcp-stream-ssl.c (ssl_bad_cert): Hack around the fact that
	adding a cert to nss's certdb seems to not work.

2001-10-10  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (vee_sync): Only re-build the folder if we're
	expunging.  Also only clear out the changed folders list if we're
	expungung and everything worked.

2001-10-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_map_init): Added a hack for
	Solaris systems.

2001-10-10  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-store.c (scan_dir): oops, we want
	get_unread_message_count, not get_message_count!

2001-10-09  Not Zed  <NotZed@Ximian.com>

	* camel-service.c (camel_service_disconnect): Duplicate connect
	code that unregisters a cancel op if we created one.

	* camel-operation.c (camel_operation_progress): Another go at
	getting the logic right again.  Make transients only update after
	5 seconds (CAMEL_OPERATION_TRANSIENT_DELAY)
	(camel_operation_end): Likewise.

	* providers/local/camel-spool-folder.c (spool_search_by_uids):
	Implement.

	* providers/imap/camel-imap-search.c (imap_body_contains): If
	searching a sub-set of the total message count, then use a UID
	range to search only specific messages.

	* camel-vee-folder.c (vee_folder_change_match): Removed.
	(folder_changed_add_uid): Helper func for changed code.
	(folder_changed_remove_uid): "
	(folder_changed_change_uid): "
	(folder_changed): Rewritten.  Supports proper auto-updating of
	changes, but not removals till a sync occurs.
	(vee_search_by_uids): Implement.
	(folder_changed): Changed to call an async threaded function to do
	the actual folder updating.

	* camel-folder-summary.c (camel_flag_list_copy): New func to copy
	a whole list of flags.
	(camel_tag_list_copy): New func to copy a whole list of flags.

	* providers/imap/camel-imap-folder.c (imap_search_by_uids):
	Implement.

	* providers/local/camel-local-folder.c (local_search_by_uids):
	Implement.

	* camel-folder.c (camel_folder_search_by_uids): New function,
	search a subset of uid's.
	(search_by_uids): Default impl, return error.

2001-10-08  Dan Winship  <danw@ximian.com>

	* camel-folder.h (struct _CamelFolder): replace the ever-growing
	list of gbooleans with a single guint32 for flags.

	* camel-folder.c: Update folder flag setting/checking.

	* providers/pop3/camel-pop3-folder.c (camel_pop3_folder_init):
	* providers/nntp/camel-nntp-folder.c (camel_nntp_folder_new): 
	* providers/local/camel-spool-folder.c (spool_init,
	camel_spool_folder_new): 
	* providers/local/camel-maildir-folder.c (camel_maildir_folder_new): 
	* providers/local/camel-local-folder.c (local_init): 
	* providers/imap/camel-imap-folder.c (camel_imap_folder_init,
	camel_imap_folder_new): 
	* camel-vtrash-folder.c (camel_vtrash_folder_init): 
	* camel-vee-folder.c (camel_vee_folder_init): 
	* camel-digest-folder.c (camel_digest_folder_init): update folder
	flag setting.

2001-10-07  Dan Winship  <danw@ximian.com>

	* providers/imap/camel-imap-store.c (get_folder_online): Unlock
	the store before returning error. (noted by NotZed)

2001-10-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c (header_decode_text): Fix a slight error in
	logic. Just because the last word was an encoded word doesn't mean
	we ignore the lwsp padding, we only ignore it if the last word and
	*this* word are encoded.

2001-10-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-filter-basic.c (filter): Implemented uuencoding and
	decoding.
	(complete): Implemented uuencoding and decoding.

	* camel-mime-utils.c (uuencode_close): New function to flush the
	uu encoder.
	(uuencode_step): New function to uuencode a block of data.

2001-10-05  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (subscribe_folder): Use a
	folder_subscribed event rather than a folder_created one.
	(unsubscribe_folder): Similarly for unsubscribed/deleted.
	(create_folder): Emit a folder_created event on the folders we
	added.  Not sure hsould probably check which ones are new and
	which ones are just existing ones?
	(delete_folder): Emit a folder_deletd event when we've deleted the
	folder.  Part of fix for #11831.

	* camel-store.c (camel_store_class_init): Added
	folder_subscribed/unsubscribed events.

2001-10-05  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-service.c (camel_service_finalize): Turn off warnings.
	(get_name): Same.

	* camel-sasl.c (sasl_challenge): Turn off warnings.

	* camel-tcp-stream.c (tcp_connect): Turn off warnings.
	(tcp_getsockopt): Same.
	(tcp_setsockopt): Here too.
	(tcp_get_socket): And here.

	* camel-folder.c (folder_sync): Turn off warnings.
	(expunge): Same.
	(append_message): Here too.
	(get_message): And here.
	(search_by_expression): And again here.
	(folder_changed): Here too.

	* camel-store.c (get_folder): Set an exception and turn off
	debugging g_warnings.
	(create_folder): Same.
	(delete_folder): Here too.
	(rename_folder): And here.
	(get_trash): And here.
	(get_folder_info): Same.
	(free_folder_info): And again here.
	(camel_folder_info_build): Here too.
	(folder_subscribed): Same.
	(subscribe_folder): Here too.
	(unsubscribe_folder): And here.

2001-10-05  Not Zed  <NotZed@Ximian.com>

	* camel-mime-utils.c (header_decode_mailbox): Try harder to get
	broken names out of addresses.  Unencoded ,'s in names will still
	break it, but well what can you do eh?
	(header_decode_mailbox): Always add .'s into address we've scanned
	past a '.', even if we can't decode the next part.  Fix for some
	annoying bug #.

2001-10-04  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (camel_store_delete_folder): Change the order of
	execution slightly.  We delete the folder first, then call the
	classes delete folder, then cleanup the hashtable afterwards.
	This is so deletes of vfolders work, since vee-store uses the
	folder hashtable to store all of is vfolders :-/

2001-10-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-service.c (camel_service_connect): Unregister the
	operation before unreffing it.

2001-10-03  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (camel_imap_folder_changed):
	Remove now unused 'recents' array/freeing func.

	* camel-object.c (camel_object_trigger_event): Oops, always run
	the prep function, even if we have no hooks listening.  Causes
	incoming imap recents to get ignored bythe camel-folder filter
	inbox code.

	* providers/local/camel-local-folder.c (local_sync): Dont
	explicitly save metadata, its saved in summary_sync.

	* providers/local/camel-mh-summary.c: Call superclass.
	(mh_summary_check): Dont save ibex.

	* providers/local/camel-maildir-summary.c: Call superclass method.
	(maildir_summary_check): Dont save ibex explictly.

	* providers/local/camel-mbox-summary.c: Call super-class sync when
	done, saves summary/ibex, etc.
	(mbox_summary_check): Dont save ibex.
	(mbox_summary_sync): Call summary_check rather than trying to
	update from our known position.

	* providers/local/camel-local-summary.c
	(camel_local_summary_check): Dont save the summary or index here.
	(local_summary_sync): Save the summary/index here.

	* camel-search-private.c (camel_search_build_match_regex): Added
	MATCH_NEWLINE flag, -> REG_NEWLINE.

	* camel-lock-helper.c: Include <string.h> to kill some warnings.

	* camel-filter-search.c (get_full_header): Put \n's between each
	line we generate.
	(header_full_regex): Dont drop the first argument to the command
	-> empty matches!
	(header_full_regex): Set match_newline for building regex.
	(body_regex): And here too.  These all fix #9877.

2001-10-03  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-store.c (camel_store_delete_folder): Call
	camel_folder_delete() on the folder if it's "alive".

	* camel-folder.c (camel_folder_delete): Mark the folder as
	deleted, perform any folder specific cleanup and emit the deleted
	event.
	(camel_folder_sync): Only sync the folder if it hasn't been
	deleted.
	(camel_folder_expunge): Same.

2001-10-03  Dan Winship  <danw@ximian.com>

	* providers/local/camel-local-provider.c (local_url_equal):
	Strange are the ways of alloca. Fixes 11543.

2001-10-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (ssl_bad_cert): Import the certificate if
	the user accepts it.

2001-10-02  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-local-provider.c (local_url_hash,
	local_url_equal): for hashing/comparing local url's, we ignore
	trailing /'s in paths (maybe shuld handle multiple /'s too).
	(camel_provider_module_init): Use local_url_hash/equal for all
	functions.

	* camel-sasl-digest-md5.c (digest_response): Change to
	camel_charset_iconv_open/close.

	* camel-pgp-context.c (pgp_verify): Change to
	camel_charset_iconv_open/close.

	* camel-mime-part-utils.c (convert_buffer): Change to
	camel_charset_iconv_open().

	* camel-mime-filter-charset.c
	(camel_mime_filter_charset_new_convert, finalise): Change to
	camel_charset_iconv_open, etc.

	* camel-mime-utils.c: Use the camel_charset_iconv_open/close()
	functions to open/close it.

	* camel-charset-map.c (camel_charset_iconv_open): New function,
	wrap iconv_open, so we can cache ic's.
	(camel_charset_iconv_close): Likewise for close.
	(camel_charset_map_init,shutdown): Init/free iconv cache.

2001-10-02  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_to_iconv): Revert my
	x-unknown special-case hack - this may mask other problems.

	* camel-mime-utils.c (rfc2047_decode_word): If the iconv
	conversion fails, for whatever reason, retry using the user's
	locale charset.

2001-10-02  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-store.c (get_folder_info): Go back
	to using the store url's path, not the toplevel_dir thing.

	* camel-operation.c (camel_operation_progress): Fix the progress
	logic, so we dont update too often.

	* camel-object.c (camel_object_get_hooks): Change the lock to a
	recursive e-mutex.
	(camel_object_hook_event): Maintain list length of hook list.
	(camel_object_unhook_event): "
	(camel_object_unhook_event): If we are in an event, just mark the
	pair as removed, without removing it.
	(camel_object_trigger_event): Before running events, copy the
	list, and also ignore 'removed' events.  After running events, if
	we're all out of events, then free up any pending-removed events.
	(camel_object_free_hooks): Add some new assertions on the state of
	the hook structure.
	Removed the #error if threads not defined.  It _should_ actually
	work without threads.
	(camel_object_free_hooks): Free mutex when done.

2001-10-01  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (delete_folder): Remove any
	cached messages that belonged to the deleted folder.
	(subscribe_folder): Don't ever let the info->name be NULL and
	don't use the stupid concat kludge to generate the URL, just use a
	CamelURL to do it. This way we don't risk breaking stuff by having
	a url like imap://fejj@imap//folder

	* camel-charset-map.c (camel_charset_to_iconv): If the charset is
	x-unknown, return the locale_charset.

2001-10-01  Dan Winship  <danw@ximian.com>

	* camel-provider.h: Fix up the provider flags to specify things
	more completely so we don't have to hardcode provider names in the
	mailer.

	* providers/local/camel-local-provider.c: MH, mbox, and Maildir
	are LOCAL. MH and mbox are no longer STORAGE by the new
	definition.

	* camel-session.c (vee_provider): The vfolder store is a STORAGE.

2001-10-01  Dan Winship  <danw@ximian.com>

	* providers/local/camel-local-store.c (construct): Don't munge the
	URL; CamelSession's caching relies on it not changing. Instead,
	add a toplevel_dir field to CamelLocalStore, and set that to the
	path, but always ending with /.
	(camel_local_store_finalize): Free toplevel_dir
	(camel_local_store_get_toplevel_dir): Return toplevel_dir rather
	than url->path.

	* providers/local/*: Lots of s/url->path/toplevel_dir/

	* providers/local/camel-spool-store.c (construct): Likewise, don't
	try to strip a trailing / from url->path here, but I didn't make
	the corresponding toplevel_dir change, because there's no good
	reason someone should expect "/var/spool/mail/danw/" to work since
	that's not a directory.

	* providers/pop3/camel-pop3-folder.c (pop3_refresh_info): if STAT
	returns 0, don't bother sending UIDL. Speeds things up slightly
	and also works around a bug in a particular random POP server.
	(ximian bug 11369).

2001-09-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (pgp_sign): Add --no-secmem-warning and
	--no-greeting to the gpg command-line options.
	(pgp_clearsign): Same.
	(pgp_verify): Here too.
	(pgp_encrypt): And here.
	(pgp_decrypt): And finally here.

2001-09-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-search.c (get_source): Same here.

	* camel-mime-message.c (camel_mime_message_set_source): Don't use
	the e_url_shroud hack, use CamelURL functions instead.

2001-09-28  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/nntp/camel-nntp-provider.c
	(camel_provider_module_init): Init the nntp url hash and url_equal
	functions.

	* providers/sendmail/camel-sendmail-provider.c
	(camel_provider_module_init): Init the sendmail url hash and
	url_equal functions.

	* providers/smtp/camel-smtp-provider.c
	(camel_provider_module_init): Init the smtp url hash and url_equal
	functions.

	* providers/pop3/camel-pop3-provider.c
	(camel_provider_module_init): Init the pop3 url hash and url_equal
	functions.

	* providers/imap/camel-imap-provider.c
	(camel_provider_module_init): Init the imap url hash and url_equal
	functions.

	* providers/local/camel-local-provider.c
	(camel_provider_module_init): Init the local url hash and
	url_equal functions.

	* camel-session.c (camel_session_class_init): Init the vfolder url
	hash and url_equal functions.

	* camel-provider.h: Added url_hash and url_equal function pointers
	to the structure.

	* camel-vtrash-folder.c (vtrash_move_messages_to): Oops, a
	CamelFolder is not a CamelFolderClass.

2001-09-28  Dan Winship  <danw@ximian.com>

	* camel-tcp-stream-openssl.c (ssl_error_to_errno): Make this take
	an SSL * instead of a CamelTcpStreamSSL *, since it can get called
	from open_ssl_connection, when the CamelTcpStreamSSL isn't set up
	right yet. Fixes a crash on connection failure.

2001-09-27  Dan Winship  <danw@ximian.com>

	* providers/imap/camel-imap-folder.c
	(camel_imap_folder_fetch_data): Grab the store's command_lock
	before grabbing the folder's cache_lock to prevent deadlock if
	another thread is processing an EXPUNGE response.

	* providers/imap/camel-imap-folder.c
	(imap_expunge_uids_resyncing): Fix a compiler warning that might
	point out a real bug...

	* providers/imap/camel-imap-folder.c (get_content): and one that
	doesn't

2001-09-27  Not Zed  <NotZed@Ximian.com>

	* camel-service.c (camel_service_connect): Dont re-register the
	connect_op if we got it by calling 'operation_registered', which
	returns an already-registered one.
	(camel_service_disconnect): Likewise here.  This removes all the
	re-registered warnings.

	* camel-object.c (camel_object_unref): Fill the finalised data
	with nonsense, rather than 0's - more easily detect bad data.
	(camel_object_new): Clear instance data when we retrieve it off
	the list.

	* camel-object.h (_CamelObject): Added an event lock pointer for
	uh, locking event stuff.  Also change the hooklist hashtable into
	a list.  Changed all the code to handle it.  Result: thread-safe
	events, event-hooks, and save memory too, and SHOULD FINALLY FIX
	THAT UNREAD COUNT PROBLEM.

2001-09-27  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-mime.c (camel_pgp_mime_part_decrypt): CRLF decode the
	stream before parsing it into a MIME part. This fixes bug #10521.

	* camel-store.c: Remove the old folder from the vTrash folder.

2001-09-27  Dan Winship  <danw@ximian.com>

	* camel-service.c: Change "gboolean connected" to
	"CamelServiceConnectionStatus status", which can be disconnected,
	connecting, connected, or disconnecting.
	(camel_service_init, camel_service_finalize): create/destroy the
	connect_op_lock. Refer to service->status rather than
	service->connected.
	(camel_service_connect): When connecting, note the current
	operation (and create a new one if there's none registered) and
	mark the connection "connecting" until we succeed or fail.
	(camel_service_disconnect): Likewise in reverse.
	(camel_service_cancel_connect): New function to cancel a
	connection attempt.
	(cancel_connect): Default implementation: Call
	camel_operation_cancel on the connect_op.

	* camel-disco-store.c (disco_connect): Only call
	CamelRemoteStore's connect func if we're online.
	(disco_cancel_connect): Fall back to offline if a connection gets
	cancelled.
	(disco_get_folder_info): Kludge: call connect explicitly before
	deciding whether to do the online or offline version, so if the
	connect fails, we fall back correctly.

	* camel-session.c (camel_session_get_service_connected):
	s/svc->connected/svc->status/

	* camel-remote-store.c (camel_remote_store_finalise):
	Change service->connected check to service->status check.
	(remote_connect): Don't set service->connected here:
	camel_service_connect() itself does that.

	* camel-operation.c (camel_operation_registered): Deal with the
	possibility that there's no registered op.

2001-09-26  Not Zed  <NotZed@Ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_message): If
	we get a search error, just abort, dont try and fall back and copy
	to inbox.
	(camel_filter_driver_filter_message): Make sure we ALWAYS use
	exceptions for important things - like moving messages to inbox!
	(camel_filter_driver_filter_message): If we have the source
	folder, use camel_folder_set_message_flags rather then poking the
	info directly, which skips changed events.  This means filtering
	immediate doesn't lose changed events.
	(do_flag): Same here.
	(do_colour): Same thing but using set_tag.
	(do_score): Same again.
	(camel_filter_driver_filter_folder): Use ~0 as the 'set' arg to
	set_flags, just saves typing.
	(open_folder): We cache folders that we couldn't open as well as
	those ones we could.  Use magic token FOLDER_INVALID =
	(void *)~0 as the marker.
	(close_folder): Handle FOLDER_INVALID case properly.

2001-09-26  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-message.c
	(camel_mime_message_get_part_by_content_id): New function to
	convenience Larry ;-)
	(check_content_id): Oops, return !found instead of found. This
	callback has to return whether or not to keep searching, not
	whether or not it found what it's looking for. Do'h!

	* camel-pgp-mime.c (camel_pgp_mime_is_rfc2015_signed): block out
	some code if ENABLE_PEDANTIC_PGPMIME is not defined.

2001-09-26  Not Zed  <NotZed@Ximian.com>

	* camel-vee-store.c: Emptied VeeStorePrivate, member wasn't used.

	* camel-vee-folder.c (camel_vee_folder_set_expression): Lock
	changed list separately.
	(camel_vee_folder_remove_folder): "
	(camel_vee_folder_set_folders): Use changed_lock for changed list.
	(vee_refresh_info): Use changed_lock, also just grab the list,
	reset it in the lock, and do the work unlocked.
	(vee_sync): Use changed lock for changed list.
	(folder_changed): ".  All this kills a deadlock with sync/expunge.
	
	* camel-private.h (CamelVeeFolderPrivate): Added a new lock for
	the folders-changed list.
	(CamelVeeStorePrivate): Removed, defined in camel-vee-store.c,
	thanks to a pedantic.

2001-09-26  Jeffrey Stedfast  <fejj@ximian.com>

	* Makefile.am: Fix Ettore's fix.

2001-09-25  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (camel_pgp_context_new): No longer takes a
	remember argument.
	(pgp_sign): Only uncache the passphrase on failure.
	(pgp_clearsign): Same.
	(pgp_encrypt): Here too.
	(pgp_decrypt): And here.
	(pass_free): New function to zero the passphrase before freeing
	it.

2001-09-25  Ettore Perazzoli  <ettore@ximian.com>

	[Patch for Automake 1.5 compatibility pointed out by Richard
	Boulton <richard@tartarus.org>, as per #9258.]

	* providers/nntp/Makefile.am: Remove some commented parts that
	make Automake 1.5 choke.

	* Makefile.am (camel-lock-helper): Add $(EXEEXT) for Automake 1.5
	compatibility.

2001-09-25  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (get_unread_message_count): Only unref info if we
	got it.

	* camel-operation.c (camel_operation_unref): Fix for !threads
	enabled not ccompiling.
	(camel_operation_ref): Assert refcount > 0.
	(struct _CamelOperation): Removed the lock.  On further
	investigation, I dont think this will always work, the
	registration operations assume that a lookup in the
	operation_active table will return a ref, that will remain valid
	until we ref it, which needn't be the case.  So now i'm using a
	single global lock, since we'd need to do that for unref anyway,
	and every operation is fast & memory-bound.  Changed all the code
	to handle this.
	(camel_operation_progress_count): Since the code is identical,
	just call progress() for now.
	(camel_operation_register): No longer refcount, use unref to
	check/clear the active table.
	(camel_operation_unregister): Same here.
	(camel_operation_unref): Check if operation is in active table, if
	so, warn, remove.

2001-09-25  Dan Winship  <danw@ximian.com>

	* camel-tcp-stream-openssl.c (my_SSL_read, my_SSL_write): call
	SSL_read/write, looping on SSL_ERROR_WANT_READ/WRITE. I'm sure
	there's a perfectly good reason that the API works this way. No,
	really.
	(stream_read, stream_write): use my_SSL_read and my_SSL_write.
	Fixes at least ximian 8593, and probably 6024 and maybe 10366,
	at least for OpenSSL. There may be a parallel NSS bug?

2001-09-25  Not Zed  <NotZed@Ximian.com>

	* camel-stream-buffer.c (stream_write_all): A "safe write"
	function that always writes out all data asked of it, till
	finished.
	(stream_write): Rewritten.  What was i on when i wrote that
	originally, how did it ever work with tcp streams ...

2001-09-24  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (append_message): Set the exception to
	FOLDER_INVALID rather than making out it worked.  A fix for #7025.
	(search_by_expression): Here too.

	* providers/imap/camel-imap-folder.c (imap_update_summary): In the
	'lose' case, free messages, not fetch_data twice!

	* camel-filter-search.c (check_header): If the type is encoded,
	get the fallback charset from the message content-type.

	* camel-mime-part-utils.c (check_html_charset): Dont check for
	charset==null before calling charset_to_iconv.
	(simple_data_wrapper_construct_from_parser): "

	* camel-mime-message.c (process_header): Try use content-type
	charset param as the fallback charset.

	* camel-charset-map.c (camel_charset_to_iconv): Handle name ==
	NULL, return NULL.

	* camel-folder-summary.c (camel_folder_summary_format_address):
	(camel_folder_summary_format_string): Made private again, removed
	#warning about it.  Renamed to s/camel_folder//.
	(summary_format_string): Take default charset param.
	(camel_message_info_new_from_header, message_info_new): Decode
	content-type field to get the charset parameter to use as the
	default charset for decoding strings.

	* camel-search-private.c (camel_search_header_match): Pass NULL as
	the charset, the locale charset is always tried.
	(camel_search_header_match): Supply a default_charset parameter to
	be used with TYPE_ENCODED params.

	* camel-mime-utils.c
	(header_param): get rid of the g_strcasecmp crap.
	(header_set_param): Same here.
	(header_decode_param_list): And here.
	(header_decode_text): Totally rewritten.  30% of its size.  If the
	word is not rfc2047 encoded, always try default_charset if
	supplied, if that fails, try locale charset if it exists, if that
	fails then assume latin1/7 bit ascii.
	(append_8bit): Changed to return FALSE if we can't convert for
	whatever reason, and dont append anything.

	* camel-mime-part.h (struct _CamelMimePart): Move content_type and
	headers out of the 'private' section.

	* camel-mime-part.c (get_headers): Dont do any conversion on the
	header.
	(process_header): Get the content-type charset as the fallback
	charset for decode_string.
	(construct_from_parser): IF we have a content-type header, process
	it before doing anything else, so we have access to a fallback
	charset for invalid headers.

2001-09-23  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-openssl.c (ssl_verify): Don't even try to alert
	the user if the session isn't interactive.
	(errlib_error_to_errno): Make the default errno EINTR so that we
	act just like CamelTcpStreamSSL.

	* camel-pgp-context.c (pgp_sign): When the password is not
	provided, set the exception to USER_CANCEL.
	(pgp_clearsign): Same.
	(pgp_encrypt): And here.
	(pgp_decrypt): Here too.

2001-09-21  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (create_folder): Set the exception if
	create_folder isn't implemented.

2001-09-21  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (create_folder): Go back to
	not using camel_folder_info_build() here because this seems to
	break folder creation (returning nodes from the root path when it
	shouldn't be?).

2001-09-21  Not Zed  <NotZed@Ximian.com>

	* camel-vee-store.c (vee_get_folder_info): Force a refresh of
	vfolders before storing their count.  This essentially makes
	'get_folderinfo' refresh all vfolders, so that get-mail works as
	expected.

	* camel-vee-folder.c (camel_vee_folder_finalise): Clear lists.
	(folder_changed): If we're not autoupdating the folder, then
	add this folder to the list of 'changed' folders for this vfolder.
	(camel_vee_folder_set_expression): Reset the folders_changed list.
	(camel_vee_folder_remove_folder): Remove the folder from the
	folders_changed list.
	(camel_vee_folder_set_folders): If we have a folder already, but
	its changed, use this opportunity to update it.
	(vee_sync): Remove any synced folders from the folders_changed
	list.
	(vee_refresh_info): Refresh folder, re-run queries on any changed
	folders.

2001-09-20  Not Zed  <NotZed@Ximian.com>

	* camel-folder-summary.c (camel_folder_summary_header_load): New
	function to just load the summary.  Not much use yet, until unread
	counts are stored in the summary (which now looks like too much
	work!).

	* camel-mime-utils.c (header_decode_mailbox): Crappy fix for
	stupid mailers.  If we get 'name b. name <foo>' then treat it as
	'"name b. name" <foo>'.  See 8147.
	(header_decode_mailbox): Another fix for really broken mailers
	that have things that look like addresses followed by <address>
	bits.
	(rfc2047_encode_word): Escape ??= to avoid some bizarre warning
	about trigraphs.

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): Setup unread count properly, and
	also setup the url properly.

	* providers/local/camel-maildir-store.c (camel_folder_info_new):
	Build the path on the folderinfo.
	(scan_dir): Dont include empty host part in url for folder.
	(scan_dir): Lookup folder counts for any folders we currenty have
	open.
	(scan_dir): If we dont have the folder open, then scan the 'new'
	and 'cur' folders for new and unread messages to count instead.

	* providers/local/camel-spool-store.c (get_folder_info): If we
	have this folder open, then set unread from the folder itself.
	(get_folder_info): Change the INBOX path to not include the
	leading /.

	* providers/local/camel-spool-folder.c
	(camel_spool_folder_construct): Fix path.
	(camel_spool_folder_construct): Properly setup the url field when
	we say we've got a new folder created.

	* providers/imap/camel-imap-store.c (unsubscribe_folder): Build
	path on folderinfo.

	* camel-store.c (camel_folder_info_build_path): Prepend / to path.

	* camel-vee-folder.c (camel_vee_folder_construct): Use macro for
	unmatched folder name.
	(camel_vee_folder_new): "

	* camel-vee-store.c (vee_get_folder_info): Use macro for unmatched
	folder name.
	(vee_delete_folder): "
	(vee_rename_folder): "
	(vee_get_folder): Prepend / onto path.
	(vee_delete_folder): Setup path in folderinfo.
	(vee_get_folder_info): Fix path in folderinfo.

	* camel-vee-folder.h (CAMEL_UNMATCHED_NAME): New define for
	unmatched (internal) name.

2001-09-20  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-spool-folder.c
	(camel_spool_folder_construct): And finally here.

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): And here.

	* camel-vee-store.c (vee_get_folder): ANd here too.
	(vee_get_folder_info): And here.

	* providers/imap/camel-imap-store.c (create_folder): Use
	camel_folder_info_build() and do better error checking.
	(subscribe_folder): Set the path on the folder info.

	* camel-store.c (camel_folder_info_build): Set the folder-info
	path if it hasn't already been set by the caller.
	(camel_folder_info_free): Free the path.

	* camel-store.h: Added a path member to the FolderInfo type.

2001-09-20  Dan Winship  <danw@ximian.com>

	* camel-charset-map.c (camel_charset_to_iconv): Nuke debug warning.

2001-09-19  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c: Updated exception strings to be more clear.

	* camel-pgp-mime.c (pgp_mime_part_sign_restore_part): Stupid
	mistake, fixes bug #9975.

	* camel-tcp-stream-ssl.c (ssl_bad_cert): Oops, don't fail if
	`data' isn't a CamelService...cuz it's not supposed to be! It's a
	CamelTcpStreamSSL object...doh!

2001-09-19  Not Zed  <NotZed@Ximian.com>

	* General cleanup of camel debug printfs.
	
	* camel-lock.c (camel_lock_fcntl): Changed to return 'success' if
	the error indicates file locking isn't supported on this
	filesystem.  Still return a warning just incase (if its the first
	time).  Might fix a lot of reported bugs.

	* providers/local/camel-spool-store.c (get_folder_info): Dont
	include the empty // host part in the uri.  This 'breaks' the
	service lookup.

2001-09-18  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-mime-utils.c: Match mailing-list header List-Owner.

2001-09-18  Not Zed  <NotZed@Ximian.com>

	* camel-vee-store.c (vee_get_folder): Fix the uri genereated for
	the folderinfo for the folder_created event.

	* camel-store.h: Added 'total' to CamelFolderInfo.

2000-09-18  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-folder.c
	(camel_maildir_folder_new): If filter inbox is set on the store,
	and we're opening inbox '', then enable filtering on new messages.

	* providers/local/camel-local-folder.c
	(camel_local_folder_construct): After loading the summary, check
	it, and only abort if that fails.  Also maintain the changes
	count.

	* providers/local/camel-local-summary.c
	(camel_local_summary_load): Remove summary_check code from here.
	(camel_local_summary_check): Sync index/summary here, if we were
	successful.

	* providers/local/camel-spool-folder.c
	(camel_spool_folder_new): If we have filter-new-messages-on-inbox
	set and we just opened inbox, turn on filtering on this folder.
	(camel_spool_folder_construct): Keep track of changes for the
	folder, so that filter-new-messages works right (?)

	* providers/local/camel-spool-store.c (get_folder): Pass 'INBOX'
	as the folder name, not the path.

	* camel-folder-search.c (search_not): Modified patch from
	<peterw@ximian.com> since the summary is messageinfo's, not
	strings.

	** Ok so the problem with the stuff below is that maildir/spool
	'summary_load' throws away all events, including recents, joy eh?
	
	* providers/local/camel-maildir-summary.c (maildir_summary_check):
	Add new messages to the recent changeinfo.

	* providers/local/camel-spool-summary.c: Mark 'new' message as
	recent, for later processing if required (i.e. 'filter new
	messages').

	* camel-store.c (construct): new function, cascade up construct
	method and check for 'filter' param, and set accordingly for any
	one that might want it.

	* providers/imap/camel-imap-store.c (construct): map the
	param_filter_inbox flag to the store->flags as
	CAMEL_STORE_FILTER_INBOX.

	* camel-store.h (CAMEL_STORE_FILTER_INBOX): new flag to tell it to
	filter inbox.

	* providers/imap/camel-imap-folder.h: Removed do_filtering flag
	from CamelImapFolder.

	* providers/imap/camel-imap-folder.c (imap_update_summary): Remove
	the 'recents' parameter, use the 'changes' parameter instead to
	convey this info.
	(camel_imap_folder_changed): Changed for update_summary api
	change.  Now always just emit the changed event if we have any
	changes to report, filtering code removed, handled upstream.
	(filter_proc): 
	(filter_free): Removed old filtering code.
	(camel_imap_folder_new): Set the filter_recent flag on the folder
	if we're the inbox and filtering of inbox is enabled.

	* camel-folder.c (folder_changed): If we have 'recent' messages,
	and are set to filter recents, then freeze the folder and launch a
	thread to do the processing (or similar if threading not enabled).
	(thaw): Make sure we emit the changed signal outside of owning the
	lock and if things have changed.  Also, no longer bother
	downgrading folder_changed events to message_changed events.

	* camel-folder.h (struct _CamelFolder): Added filter_recent flag
	-> signifies all recent messages in folder should be filtered.

	* camel-session.c: (camel_session_thread_msg_new,
	camel_session_thread_msg_free, camel_session_thread_queue,
	camel_session_thread_wait): code to handle async operations as
	part of camel processing.
	(camel_session_finalise): free thread_lock, destroy thread, active
	hash, etc.
	(camel_session_init): init thread, active hash, etc.
	(camel_session_class_init): Init virtual functions.
	(session_thread_msg_new, session_thread_msg_free,
	session_thread_destroy, session_thread_received,
	session_thread_queue, session_thread_wait): default implementation
	of session threads stuff.

2001-09-17  Not Zed  <NotZed@Ximian.com>

	* camel-folder.c (camel_folder_change_info_recent_uid): New
	function to add a 'recent' uid to the change info.
	(camel_folder_change_info_clear): Clear recent list.
	(camel_folder_change_info_free): Free recent list.
	(camel_folder_change_info_new): Setup recent list.

	* camel-folder.h: Added a uid_recent item to the folder_changed
	event data.

	* providers/local/camel-maildir-store.c (scan_dir): Free new in
	the right block.

	* providers/local/camel-local-provider.c: Add local config entries
	to filter on new messages in spool and maildir provider.

	* camel-vee-folder.c (vee_folder_construct): Remove the assertion
	which stops ? in names from being allowed.

2001-09-18  Dan Winship  <danw@ximian.com>

	* camel-data-wrapper.c (camel_data_wrapper_is_offline): Virtualize
	this.

	* camel-medium.c (is_offline): A medium is offline if its content
	object is offline.

	* camel-multipart.c (is_offline): A multipart is offline if any of
	its subparts are offline.

2001-09-18  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c: Added korean charset conversion.

2001-09-17  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/imap/camel-imap-store.c (delete_folder): Don't process
	the ImapResponse data, we don't want to block forever on data we
	don't care about...
	(create_folder): Use get_folders_online() instead of
	get_folder_info_online().

	* camel-folder.c: Reverted previous changes.

2001-09-17  JP Rosevear  <jpr@ximian.com>

	* Makefile.am: Helpful install-exec-hook debugging output

2001-09-16  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-folder.c (camel_folder_get_uri): New function to get the
	URI of a folder.
	(get_uri): Default implementation.

2001-09-14  Not Zed  <NotZed@Ximian.com>

	* camel-vee-folder.c (camel_vee_folder_set_folders): New function,
	set the complete list of folders on a vfolder, all at once.
	(camel_vee_folder_set_expression): If we set the query to be the
	same thing, dont do anything.

	* camel-vee-store.c (camel_vee_store_init): Turn off vtrash for
	this store.

	* camel-store.c (camel_store_init): Enable vtrash by default via
	flags.
	(camel_store_get_trash): REturn NULL if the store doesn't support
	vtrash.
	(init_trash): Dont init if store doesn't support vtrash.

	* camel-store.h: Add a new flags CAMEL_STORE_VTRASH -> store
	supports vtrash.

2001-09-13  Not Zed  <NotZed@Ximian.com>

	* camel-vee-store.c (vee_get_folder_info): Implement.
	(build_info): Used to build a folder record from the folders
	hashtable.
	(vee_delete_folder): Implemented, remove folder from hashtable.
	(vee_rename_folder): Implemented, remove old folder from
	hashtable, add new one and rename its guts too.

	* camel-store.c (camel_store_rename_folder): Do nothing if we're
	not asked to actually change names.  Also dont do the renamed
	cache check till after we've called the subclass.
	(camel_store_delete_folder): Call the subclass delete firs,t then
	make sure the cache is right.

	* camel-vee-folder.c (vee_folder_construct): Remove support for
	name?query syntax to setup vfolder.  Abort if such syntax is used.
	(camel_vee_folder_new): Removed code that handles ? syntax, etc.
	(vee_folder_build_folder): Handle unset expression, treat it as an
	empty search.
	(camel_vee_folder_set_expression): Oops, actually set the
	expression.

	* camel-vtrash-folder.c (camel_vtrash_folder_new): Dont use
	name?query syntax to setup vfolder, but set the expression
	directly.  Also fixes a small memleak.

2001-09-12  Not Zed  <NotZed@Ximian.com>

	* camel-store.c (camel_store_delete_folder): Fixed warnings with a
	cast.
	(camel_store_rename_folder): "

2001-09-14  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-url.c (camel_url_set_param): Use g_datalist_set_data_full
	so that the data will be free'd when we clear the list.

2001-09-14  Dan Winship  <danw@ximian.com>

	* camel-file-utils.c (camel_file_util_encode_string,
	camel_file_util_decode_string): Don't claim failure when
	reading/writing the empty string.

2001-09-14  JP Rosevear  <jpr@ximian.com>

	* Makefile.am: use install hook instead of install rule to
	guarantee we run after installation

2001-09-13  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_folder): Don't
	reuse the exception if it has already been set.
	(camel_filter_driver_filter_message): Same here. Also use the new
	return value from camel_filter_search_match().

	* camel-filter-search.c (camel_filter_search_match): Return an
	integer (matched, no-match, or error).

	* providers/local/camel-mbox-folder.c (mbox_append_message): Do
	error-checking based on function return values rather than
	exceptions as it's possible for them to be NULL.
	(mbox_get_message): Same.

	* providers/imap/camel-imap-folder.c (imap_append_offline): Pass
	an exception to the cache.
	(imap_append_online): Same.
	(imap_append_resyncing): Here too.
	(imap_copy_offline): And here.
	(handle_copyuid): Pass NULL as the exception here...
	(parse_fetch_response): And finally here.

	* providers/imap/camel-imap-message-cache.c
	(camel_imap_message_cache_insert):
	(insert_setup):
	(camel_imap_message_cache_insert_stream):
	(camel_imap_message_cache_insert_wrapper):
	(camel_imap_message_cache_copy): Take an exception argument and
	set it on error.

	* camel-mime-part-utils.c
	(simple_data_wrapper_construct_from_parser): Convert the charset
	to the iconv-friendly name.

	* camel-charset-map.c (camel_charset_to_iconv): Add code to
	convert windows-[cp]#### charsets to their iconv-friendly format
	of cp####.

	* camel-pgp-context.c (crypto_exec_with_passwd): Return -1 on
	failure.

2001-09-12  Larry Ewing  <lewing@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_mbox): free
	the source url in the nonfailure case.

2001-09-12  Not Zed  <NotZed@Ximian.com>

	* camel-folder-search.h: Change the 'not' virtual method from an
	immediate e-sexp function to a non-immediate one, which is what it
	should be.

	* camel-folder-search.c (search_not): Implement a 'not' function
	ourselves.  If 'not' on a vector value, then not over all items
	in the summary.
	(builtings[]): Change the 'not' builtin to be a non-immediate
	function.

2001-09-12  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-filter-driver.c (camel_filter_driver_filter_mbox): Unref
	the message info.

2001-09-10  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-maildir-store.c (get_folder_info): Pass in
	a hashtalbe used for finding visited nodes.
	(inode_hash): 
	(inode_equal): 
	(inode_free): Helper functions for visited node checks, hashes on
	inode + device number.
	(scan_dir): Dont re-visited directories we've already visited, use
	inodes + device number.
	Also, if the folder doesn't contain cur/tmp/new, mark it as
	noselect, but continue to recurse folders, if asked.

	* camel-folder.c (move_messages_to): Progress reporting while
	moving messages.

	* camel-store.c (camel_store_delete_folder): Make sure we remove
	the folder from our vtrash, if we have it in our opened set, and
	also remove it from our hashtable.
	(camel_store_rename_folder): Remove the old folder name from the
	folder cahce, if it is there.

2001-09-10  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-charset-map.c (camel_charset_to_iconv): Get rid of the
	g_warning, we no longer really need that.

2001-09-10  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-store.c (camel_imap_msg_new): Forgot
	to return the newly allocated msg.

2001-09-08  Not Zed  <NotZed@Ximian.com>

	* providers/local/camel-spool-summary.c (spool_summary_sync_full):
	Likewise.

	* providers/local/camel-mbox-summary.c (mbox_summary_sync_full):
	Fix the wording.

	* camel-tcp-stream-raw.c (stream_read): Save errno around fcntl
	call in cancellable read case.  Also, loop while we get EINTR.
	This might fix some weird reconnect behaviour with pop.
	(stream_write): "

2001-09-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (ssl_bad_cert): #if 0 out the code that
	was hopefully going to fix bug #5325 because the functions I used
	seem to have been deprecated. *sigh*.

	* camel-remote-store.c (camel_remote_store_finalise): Disconnect
	from the service here otherwise the locks will be destroyed and by
	the time CamelService finalizes we'll crash or hang.

	* providers/smtp/camel-smtp-transport.c (smtp_data): Make sure to
	unref the mime filters when we finish with them.

2001-09-07  Ettore Perazzoli  <ettore@ximian.com>

	* providers/local/camel-mbox-summary.c (mbox_summary_sync_full):
	s/Synchronising/Synchronizing/.
	(mbox_summary_sync_quick): Likewise.
	(summary_rebuild): s/Summarising/Summarizing/.

2001-09-07  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-multipart.c (camel_multipart_set_boundary): Take a const
	char * instead of a char *.

	* camel-mime-part-utils.c
	(camel_mime_part_construct_content_from_parser): Reuse the
	original boundary instead of generating our own.

2001-09-06  Not Zed  <NotZed@Ximian.com>

	* providers/imap/camel-imap-folder.c (filter_proc): Thread
	function to perform filtering.
	(filter_free): Free the filter object.
	(camel_imap_folder_changed): If we have threads enabled, then
	queue up a request to perform filtering.  For bug #4422.

	* providers/imap/camel-imap-store.c (camel_imap_msg_new): Create a
	new 'imap msg'.
	(camel_imap_msg_queue): Queue an 'imap msg'.
	(async_received): Handle receiving of imap msg in async thread.
	(async_destroy): Handle destroying of imap msg.
	(camel_imap_store_finalize): Destroy thread when done.
	(camel_imap_store_init): Setup thread.

	* providers/imap/camel-imap-store.h: Added an ethread to the
	store, for async processing.

2001-09-06  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-remote-store.c (remote_recv_line): Use
	camel_stream_buffer_read_line() instead of duplicationing the
	functionality. Also, the previous way was broken anyway. What if a
	line was the same length as our buffer? Then we'd go and read a
	second line and a third and so on until they weren't the same
	length, leaving \r's in the middle of the buffer.

2001-09-06  Dan Winship  <danw@ximian.com>

	* providers/pop3/camel-pop3-store.c (pop3_get_response): Fix this
	to always set an exception if it returns POP3_FAIL, as documented.

	* providers/pop3/camel-pop3-folder.c (pop3_get_message_stream):
	Revert.

2001-09-06  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/pop3/camel-pop3-folder.c (pop3_get_message_stream):
	Set an exception on POP3_FAIL as well.

2001-09-06  Dan Winship  <danw@ximian.com>

	* providers/pop3/camel-pop3-provider.c: #ifdef out the "delete
	after N days" option in pop3_conf_entries, since it won't be done
	for 1.0.

2001-09-04  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-remote-store.c (remote_disconnect): Too late to sync the
	folders here... if this is gonna happen at all it should be done
	in the provider.

	* camel-service.c (camel_service_finalize): Do a clean disconnect.

2001-08-30  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-spool-store.c (get_inbox): Return the
	default folder (ie. INBOX) rather than saying we don't support an
	inbox.

	* camel-tcp-stream-ssl.c: #include pk11func.h.
	(ssl_bad_cert): Use CERT_GetDefaultCertDB.

2001-08-29  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-smime-context.c (smime_sign_prepare): Do the same here as
	what we did in the pgp code a moment ago.
	(smime_sign_restore): And again here.
	(smime_sign): And update thise code to pass in the address of the
	encodings list when restoring parts.

	* camel-pgp-mime.c (pgp_mime_part_sign_prepare_part): Special-case
	message/rfc822 mime parts - don't set an encoding on these,
	instead traverse into their subparts and set the encodings for
	those.
	(pgp_mime_part_sign_restore_part): Reverse any operations done to
	message/rfc822 parts in the above prepare_part() function and also
	take a pointer to a GSList of encodings instead of just a GSList
	so we can properly keep track of which encoding we are on.
	(camel_pgp_mime_part_sign): Pass in the address to the encodings
	list when restoring parts.

2001-08-29  Not Zed  <NotZed@Ximian.com>

	* providers/pop3/camel-pop3-folder.c (pop3_sync): Add progress
	reporting to deleting messages.  Dont change the calculation to a
	bloody float.  Bug #6189.

2001-08-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-pgp-context.c (crypto_exec_with_passwd): Initialize buf
	and diag_buf to NULL, hopefully this fixes the crash if the
	select() times out.
	(pgp_encrypt): Argh. What was I thinking? Don't use "-r recipient"
	as an argument, instead use "-r" and "recipient" as 2 separate
	arguments to pgp. This might fix the "gpg only encrypts to my
	private key" bug?

2001-08-28  Peter Williams  <peterw@ximian.com>

	* providers/imap/camel-imap-store.c (create_folder): Whoops.
	Double-free and FMR = bad.

	* camel-remote-store.c (remote_send_string): Don't reveal the
	user's IMAP password if their server supports LITERALPLUS. Also
	add some more dashes to make it line up nicely :-)

2001-08-28  Jeffrey Stedfast  <fejj@ximian.com>

	* camel-tcp-stream-ssl.c (ssl_bad_cert): If the user accepts the
	certificate, add it to the database as a trusted CA.

2001-08-28  Peter Williams  <peterw@ximian.com>

	* camel-object.c (camel_object_unref): Make the locking more
	fine-grained on destruction; specifically, don't hold the
	type lock while calling the finalize functions.

2001-08-27  Jeffrey Stedfast  <fejj@ximian.com>

	* providers/local/camel-local-provider.c: Changed the
	description/names of some of the local providers to try and
	clarify the meanings.

	* providers/pop3/camel-pop3-provider.c: Simplify the POP
	description - we want short but sweet.

	* providers/imap/camel-imap-provider.c: s/IMAPv4/IMAP

2001-08-27  Not Zed  <NotZed@Ximian.com>

